/* View.c generated by valac 0.56.17, the Vala compiler
 * generated from View.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include "budgiemenuapplet.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib-object.h>
#include "budgie-appindexer.h"
#include "budgie-private.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	APPLICATION_VIEW_0_PROPERTY,
	APPLICATION_VIEW_APPLICATION_BUTTONS_PROPERTY,
	APPLICATION_VIEW_CONTROL_CENTER_BUTTONS_PROPERTY,
	APPLICATION_VIEW_SEARCH_TERM_PROPERTY,
	APPLICATION_VIEW_ICON_SIZE_PROPERTY,
	APPLICATION_VIEW_NUM_PROPERTIES
};
static GParamSpec* application_view_properties[APPLICATION_VIEW_NUM_PROPERTIES];
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block4Data Block4Data;
enum  {
	APPLICATION_VIEW_APP_LAUNCHED_SIGNAL,
	APPLICATION_VIEW_NUM_SIGNALS
};
static guint application_view_signals[APPLICATION_VIEW_NUM_SIGNALS] = {0};

struct _ApplicationViewPrivate {
	GHashTable* _application_buttons;
	GeeArrayList* _control_center_buttons;
	gchar* _search_term;
	gint _icon_size;
	guint timeout_id;
};

struct _Block4Data {
	int _ref_count_;
	ApplicationView* self;
	BudgieAppIndex* app_tracker;
};

static gint ApplicationView_private_offset;
static gpointer application_view_parent_class = NULL;
static GType application_view_type_id = 0;

static void application_view_real_on_search_entry_activated (ApplicationView* self);
static void application_view_real_on_show (ApplicationView* self);
static void application_view_real_refresh (ApplicationView* self,
                                    BudgieAppIndex* app_tracker);
static void application_view_real_invalidate (ApplicationView* self);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static gboolean __lambda4_ (Block4Data* _data4_);
static gboolean ___lambda4__gsource_func (gpointer self);
static GObject * application_view_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties);
static void _g_free0_ (gpointer var);
static void _g_object_unref0_ (gpointer var);
static void application_view_finalize (GObject * obj);
static void _vala_application_view_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_application_view_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);

static inline gpointer
application_view_get_instance_private (ApplicationView* self)
{
	return G_STRUCT_MEMBER_P (self, ApplicationView_private_offset);
}

/**
 * This should be called when the user activates a search entry.
 */
static void
application_view_real_on_search_entry_activated (ApplicationView* self)
{
#line 40 "../src/panel/applets/budgie-menu/views/View.vala"
	g_critical ("Type `%s' does not implement abstract method `application_view_on_search_entry_activated'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 40 "../src/panel/applets/budgie-menu/views/View.vala"
	return;
#line 111 "View.c"
}

void
application_view_on_search_entry_activated (ApplicationView* self)
{
	ApplicationViewClass* _klass_;
#line 40 "../src/panel/applets/budgie-menu/views/View.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/panel/applets/budgie-menu/views/View.vala"
	_klass_ = APPLICATION_VIEW_GET_CLASS (self);
#line 40 "../src/panel/applets/budgie-menu/views/View.vala"
	if (_klass_->on_search_entry_activated) {
#line 40 "../src/panel/applets/budgie-menu/views/View.vala"
		_klass_->on_search_entry_activated (self);
#line 126 "View.c"
	}
}

/**
 * Performs any work that should be done to the view when the menu
 * is opened, e.g. resetting the current category or invalidating filters.
 */
static void
application_view_real_on_show (ApplicationView* self)
{
#line 46 "../src/panel/applets/budgie-menu/views/View.vala"
	g_critical ("Type `%s' does not implement abstract method `application_view_on_show'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 46 "../src/panel/applets/budgie-menu/views/View.vala"
	return;
#line 141 "View.c"
}

void
application_view_on_show (ApplicationView* self)
{
	ApplicationViewClass* _klass_;
#line 46 "../src/panel/applets/budgie-menu/views/View.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/panel/applets/budgie-menu/views/View.vala"
	_klass_ = APPLICATION_VIEW_GET_CLASS (self);
#line 46 "../src/panel/applets/budgie-menu/views/View.vala"
	if (_klass_->on_show) {
#line 46 "../src/panel/applets/budgie-menu/views/View.vala"
		_klass_->on_show (self);
#line 156 "View.c"
	}
}

/**
 * Refreshes the entire application view.
 */
static void
application_view_real_refresh (ApplicationView* self,
                               BudgieAppIndex* app_tracker)
{
#line 51 "../src/panel/applets/budgie-menu/views/View.vala"
	g_critical ("Type `%s' does not implement abstract method `application_view_refresh'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 51 "../src/panel/applets/budgie-menu/views/View.vala"
	return;
#line 171 "View.c"
}

void
application_view_refresh (ApplicationView* self,
                          BudgieAppIndex* app_tracker)
{
	ApplicationViewClass* _klass_;
#line 51 "../src/panel/applets/budgie-menu/views/View.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/panel/applets/budgie-menu/views/View.vala"
	_klass_ = APPLICATION_VIEW_GET_CLASS (self);
#line 51 "../src/panel/applets/budgie-menu/views/View.vala"
	if (_klass_->refresh) {
#line 51 "../src/panel/applets/budgie-menu/views/View.vala"
		_klass_->refresh (self, app_tracker);
#line 187 "View.c"
	}
}

/**
 * Invalidate aspects of the view, e.g. category headers.
 */
static void
application_view_real_invalidate (ApplicationView* self)
{
#line 56 "../src/panel/applets/budgie-menu/views/View.vala"
	g_critical ("Type `%s' does not implement abstract method `application_view_invalidate'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 56 "../src/panel/applets/budgie-menu/views/View.vala"
	return;
#line 201 "View.c"
}

void
application_view_invalidate (ApplicationView* self)
{
	ApplicationViewClass* _klass_;
#line 56 "../src/panel/applets/budgie-menu/views/View.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/panel/applets/budgie-menu/views/View.vala"
	_klass_ = APPLICATION_VIEW_GET_CLASS (self);
#line 56 "../src/panel/applets/budgie-menu/views/View.vala"
	if (_klass_->invalidate) {
#line 56 "../src/panel/applets/budgie-menu/views/View.vala"
		_klass_->invalidate (self);
#line 216 "View.c"
	}
}

/**
 * Queue a refresh of the application view.
 *
 * The time to wait before refreshing can be set by passing in `seconds`.
 * By default, the time is 1 second.
 */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 64 "../src/panel/applets/budgie-menu/views/View.vala"
	return self ? g_object_ref (self) : NULL;
#line 231 "View.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 64 "../src/panel/applets/budgie-menu/views/View.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 64 "../src/panel/applets/budgie-menu/views/View.vala"
	return _data4_;
#line 241 "View.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 64 "../src/panel/applets/budgie-menu/views/View.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 251 "View.c"
		ApplicationView* self;
#line 64 "../src/panel/applets/budgie-menu/views/View.vala"
		self = _data4_->self;
#line 64 "../src/panel/applets/budgie-menu/views/View.vala"
		_g_object_unref0 (_data4_->app_tracker);
#line 64 "../src/panel/applets/budgie-menu/views/View.vala"
		_g_object_unref0 (self);
#line 64 "../src/panel/applets/budgie-menu/views/View.vala"
		g_slice_free (Block4Data, _data4_);
#line 261 "View.c"
	}
}

static gboolean
__lambda4_ (Block4Data* _data4_)
{
	ApplicationView* self;
	gboolean result;
#line 72 "../src/panel/applets/budgie-menu/views/View.vala"
	self = _data4_->self;
#line 73 "../src/panel/applets/budgie-menu/views/View.vala"
	application_view_refresh (self, _data4_->app_tracker);
#line 74 "../src/panel/applets/budgie-menu/views/View.vala"
	self->priv->timeout_id = (guint) 0;
#line 75 "../src/panel/applets/budgie-menu/views/View.vala"
	result = G_SOURCE_REMOVE;
#line 75 "../src/panel/applets/budgie-menu/views/View.vala"
	return result;
#line 280 "View.c"
}

static gboolean
___lambda4__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda4_ (self);
#line 72 "../src/panel/applets/budgie-menu/views/View.vala"
	return result;
#line 290 "View.c"
}

void
application_view_queue_refresh (ApplicationView* self,
                                BudgieAppIndex* app_tracker,
                                gint seconds)
{
	Block4Data* _data4_;
	BudgieAppIndex* _tmp0_;
#line 64 "../src/panel/applets/budgie-menu/views/View.vala"
	g_return_if_fail (self != NULL);
#line 64 "../src/panel/applets/budgie-menu/views/View.vala"
	g_return_if_fail (app_tracker != NULL);
#line 64 "../src/panel/applets/budgie-menu/views/View.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 64 "../src/panel/applets/budgie-menu/views/View.vala"
	_data4_->_ref_count_ = 1;
#line 64 "../src/panel/applets/budgie-menu/views/View.vala"
	_data4_->self = g_object_ref (self);
#line 64 "../src/panel/applets/budgie-menu/views/View.vala"
	_tmp0_ = _g_object_ref0 (app_tracker);
#line 64 "../src/panel/applets/budgie-menu/views/View.vala"
	_g_object_unref0 (_data4_->app_tracker);
#line 64 "../src/panel/applets/budgie-menu/views/View.vala"
	_data4_->app_tracker = _tmp0_;
#line 66 "../src/panel/applets/budgie-menu/views/View.vala"
	if (self->priv->timeout_id != ((guint) 0)) {
#line 67 "../src/panel/applets/budgie-menu/views/View.vala"
		g_source_remove (self->priv->timeout_id);
#line 68 "../src/panel/applets/budgie-menu/views/View.vala"
		self->priv->timeout_id = (guint) 0;
#line 322 "View.c"
	}
#line 72 "../src/panel/applets/budgie-menu/views/View.vala"
	self->priv->timeout_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) seconds, ___lambda4__gsource_func, block4_data_ref (_data4_), block4_data_unref);
#line 64 "../src/panel/applets/budgie-menu/views/View.vala"
	block4_data_unref (_data4_);
#line 64 "../src/panel/applets/budgie-menu/views/View.vala"
	_data4_ = NULL;
#line 330 "View.c"
}

/**
 * To be called when the search entry changes.
 */
void
application_view_search_changed (ApplicationView* self,
                                 const gchar* search_term)
{
	GHashTable* _tmp0_;
	GList* _tmp1_;
#line 82 "../src/panel/applets/budgie-menu/views/View.vala"
	g_return_if_fail (self != NULL);
#line 82 "../src/panel/applets/budgie-menu/views/View.vala"
	g_return_if_fail (search_term != NULL);
#line 83 "../src/panel/applets/budgie-menu/views/View.vala"
	application_view_set_search_term (self, search_term);
#line 87 "../src/panel/applets/budgie-menu/views/View.vala"
	_tmp0_ = self->priv->_application_buttons;
#line 87 "../src/panel/applets/budgie-menu/views/View.vala"
	_tmp1_ = g_hash_table_get_values (_tmp0_);
#line 352 "View.c"
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
#line 87 "../src/panel/applets/budgie-menu/views/View.vala"
		child_collection = _tmp1_;
#line 87 "../src/panel/applets/budgie-menu/views/View.vala"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 360 "View.c"
			MenuButton* child = NULL;
#line 87 "../src/panel/applets/budgie-menu/views/View.vala"
			child = (MenuButton*) child_it->data;
#line 364 "View.c"
			{
				BudgieRelevancyService* _tmp2_;
				MenuButton* _tmp3_;
				BudgieApplication* _tmp4_;
				BudgieApplication* _tmp5_;
#line 88 "../src/panel/applets/budgie-menu/views/View.vala"
				_tmp2_ = self->relevancy_service;
#line 88 "../src/panel/applets/budgie-menu/views/View.vala"
				_tmp3_ = child;
#line 88 "../src/panel/applets/budgie-menu/views/View.vala"
				_tmp4_ = menu_button_get_app (_tmp3_);
#line 88 "../src/panel/applets/budgie-menu/views/View.vala"
				_tmp5_ = _tmp4_;
#line 88 "../src/panel/applets/budgie-menu/views/View.vala"
				budgie_relevancy_service_update_relevancy (_tmp2_, _tmp5_, search_term);
#line 380 "View.c"
			}
		}
#line 87 "../src/panel/applets/budgie-menu/views/View.vala"
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 385 "View.c"
	}
#line 91 "../src/panel/applets/budgie-menu/views/View.vala"
	application_view_invalidate (self);
#line 389 "View.c"
}

/**
 * Checks if a `MenuButton` already exists in the view.
 */
gboolean
application_view_is_item_dupe (ApplicationView* self,
                               MenuButton* button)
{
	MenuButton* compare_item = NULL;
	GHashTable* _tmp0_;
	BudgieApplication* _tmp1_;
	BudgieApplication* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gconstpointer _tmp5_;
	MenuButton* _tmp6_;
	gboolean _tmp7_ = FALSE;
	MenuButton* _tmp8_;
	gboolean result;
#line 97 "../src/panel/applets/budgie-menu/views/View.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 98 "../src/panel/applets/budgie-menu/views/View.vala"
	_tmp0_ = self->priv->_application_buttons;
#line 98 "../src/panel/applets/budgie-menu/views/View.vala"
	_tmp1_ = menu_button_get_app (button);
#line 98 "../src/panel/applets/budgie-menu/views/View.vala"
	_tmp2_ = _tmp1_;
#line 98 "../src/panel/applets/budgie-menu/views/View.vala"
	_tmp3_ = budgie_application_get_desktop_id (_tmp2_);
#line 98 "../src/panel/applets/budgie-menu/views/View.vala"
	_tmp4_ = _tmp3_;
#line 98 "../src/panel/applets/budgie-menu/views/View.vala"
	_tmp5_ = g_hash_table_lookup (_tmp0_, _tmp4_);
#line 98 "../src/panel/applets/budgie-menu/views/View.vala"
	_tmp6_ = _g_object_ref0 ((MenuButton*) _tmp5_);
#line 98 "../src/panel/applets/budgie-menu/views/View.vala"
	compare_item = _tmp6_;
#line 99 "../src/panel/applets/budgie-menu/views/View.vala"
	_tmp8_ = compare_item;
#line 99 "../src/panel/applets/budgie-menu/views/View.vala"
	if (_tmp8_ != NULL) {
#line 432 "View.c"
		MenuButton* _tmp9_;
#line 99 "../src/panel/applets/budgie-menu/views/View.vala"
		_tmp9_ = compare_item;
#line 99 "../src/panel/applets/budgie-menu/views/View.vala"
		_tmp7_ = _tmp9_ != button;
#line 438 "View.c"
	} else {
#line 99 "../src/panel/applets/budgie-menu/views/View.vala"
		_tmp7_ = FALSE;
#line 442 "View.c"
	}
#line 99 "../src/panel/applets/budgie-menu/views/View.vala"
	if (_tmp7_) {
#line 100 "../src/panel/applets/budgie-menu/views/View.vala"
		result = TRUE;
#line 100 "../src/panel/applets/budgie-menu/views/View.vala"
		_g_object_unref0 (compare_item);
#line 100 "../src/panel/applets/budgie-menu/views/View.vala"
		return result;
#line 452 "View.c"
	}
#line 102 "../src/panel/applets/budgie-menu/views/View.vala"
	result = FALSE;
#line 102 "../src/panel/applets/budgie-menu/views/View.vala"
	_g_object_unref0 (compare_item);
#line 102 "../src/panel/applets/budgie-menu/views/View.vala"
	return result;
#line 460 "View.c"
}

ApplicationView*
application_view_construct (GType object_type)
{
	ApplicationView * self = NULL;
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
	self = (ApplicationView*) g_object_new (object_type, NULL);
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
	return self;
#line 471 "View.c"
}

GHashTable*
application_view_get_application_buttons (ApplicationView* self)
{
	GHashTable* result;
	GHashTable* _tmp0_;
#line 18 "../src/panel/applets/budgie-menu/views/View.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 18 "../src/panel/applets/budgie-menu/views/View.vala"
	_tmp0_ = self->priv->_application_buttons;
#line 18 "../src/panel/applets/budgie-menu/views/View.vala"
	result = _tmp0_;
#line 18 "../src/panel/applets/budgie-menu/views/View.vala"
	return result;
#line 487 "View.c"
}

static gpointer
_g_hash_table_ref0 (gpointer self)
{
#line 18 "../src/panel/applets/budgie-menu/views/View.vala"
	return self ? g_hash_table_ref (self) : NULL;
#line 495 "View.c"
}

void
application_view_set_application_buttons (ApplicationView* self,
                                          GHashTable* value)
{
	GHashTable* old_value;
#line 18 "../src/panel/applets/budgie-menu/views/View.vala"
	g_return_if_fail (self != NULL);
#line 18 "../src/panel/applets/budgie-menu/views/View.vala"
	old_value = application_view_get_application_buttons (self);
#line 18 "../src/panel/applets/budgie-menu/views/View.vala"
	if (old_value != value) {
#line 509 "View.c"
		GHashTable* _tmp0_;
#line 18 "../src/panel/applets/budgie-menu/views/View.vala"
		_tmp0_ = _g_hash_table_ref0 (value);
#line 18 "../src/panel/applets/budgie-menu/views/View.vala"
		_g_hash_table_unref0 (self->priv->_application_buttons);
#line 18 "../src/panel/applets/budgie-menu/views/View.vala"
		self->priv->_application_buttons = _tmp0_;
#line 18 "../src/panel/applets/budgie-menu/views/View.vala"
		g_object_notify_by_pspec ((GObject *) self, application_view_properties[APPLICATION_VIEW_APPLICATION_BUTTONS_PROPERTY]);
#line 519 "View.c"
	}
}

GeeArrayList*
application_view_get_control_center_buttons (ApplicationView* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 19 "../src/panel/applets/budgie-menu/views/View.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 19 "../src/panel/applets/budgie-menu/views/View.vala"
	_tmp0_ = self->priv->_control_center_buttons;
#line 19 "../src/panel/applets/budgie-menu/views/View.vala"
	result = _tmp0_;
#line 19 "../src/panel/applets/budgie-menu/views/View.vala"
	return result;
#line 536 "View.c"
}

void
application_view_set_control_center_buttons (ApplicationView* self,
                                             GeeArrayList* value)
{
	GeeArrayList* old_value;
#line 19 "../src/panel/applets/budgie-menu/views/View.vala"
	g_return_if_fail (self != NULL);
#line 19 "../src/panel/applets/budgie-menu/views/View.vala"
	old_value = application_view_get_control_center_buttons (self);
#line 19 "../src/panel/applets/budgie-menu/views/View.vala"
	if (old_value != value) {
#line 550 "View.c"
		GeeArrayList* _tmp0_;
#line 19 "../src/panel/applets/budgie-menu/views/View.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 19 "../src/panel/applets/budgie-menu/views/View.vala"
		_g_object_unref0 (self->priv->_control_center_buttons);
#line 19 "../src/panel/applets/budgie-menu/views/View.vala"
		self->priv->_control_center_buttons = _tmp0_;
#line 19 "../src/panel/applets/budgie-menu/views/View.vala"
		g_object_notify_by_pspec ((GObject *) self, application_view_properties[APPLICATION_VIEW_CONTROL_CENTER_BUTTONS_PROPERTY]);
#line 560 "View.c"
	}
}

const gchar*
application_view_get_search_term (ApplicationView* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 20 "../src/panel/applets/budgie-menu/views/View.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 20 "../src/panel/applets/budgie-menu/views/View.vala"
	_tmp0_ = self->priv->_search_term;
#line 20 "../src/panel/applets/budgie-menu/views/View.vala"
	result = _tmp0_;
#line 20 "../src/panel/applets/budgie-menu/views/View.vala"
	return result;
#line 577 "View.c"
}

void
application_view_set_search_term (ApplicationView* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 20 "../src/panel/applets/budgie-menu/views/View.vala"
	g_return_if_fail (self != NULL);
#line 20 "../src/panel/applets/budgie-menu/views/View.vala"
	old_value = application_view_get_search_term (self);
#line 20 "../src/panel/applets/budgie-menu/views/View.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 591 "View.c"
		gchar* _tmp0_;
#line 20 "../src/panel/applets/budgie-menu/views/View.vala"
		_tmp0_ = g_strdup (value);
#line 20 "../src/panel/applets/budgie-menu/views/View.vala"
		_g_free0 (self->priv->_search_term);
#line 20 "../src/panel/applets/budgie-menu/views/View.vala"
		self->priv->_search_term = _tmp0_;
#line 20 "../src/panel/applets/budgie-menu/views/View.vala"
		g_object_notify_by_pspec ((GObject *) self, application_view_properties[APPLICATION_VIEW_SEARCH_TERM_PROPERTY]);
#line 601 "View.c"
	}
}

gint
application_view_get_icon_size (ApplicationView* self)
{
	gint result;
#line 21 "../src/panel/applets/budgie-menu/views/View.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 21 "../src/panel/applets/budgie-menu/views/View.vala"
	result = self->priv->_icon_size;
#line 21 "../src/panel/applets/budgie-menu/views/View.vala"
	return result;
#line 615 "View.c"
}

void
application_view_set_icon_size (ApplicationView* self,
                                gint value)
{
	gint old_value;
#line 21 "../src/panel/applets/budgie-menu/views/View.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/panel/applets/budgie-menu/views/View.vala"
	old_value = application_view_get_icon_size (self);
#line 21 "../src/panel/applets/budgie-menu/views/View.vala"
	if (old_value != value) {
#line 21 "../src/panel/applets/budgie-menu/views/View.vala"
		self->priv->_icon_size = value;
#line 21 "../src/panel/applets/budgie-menu/views/View.vala"
		g_object_notify_by_pspec ((GObject *) self, application_view_properties[APPLICATION_VIEW_ICON_SIZE_PROPERTY]);
#line 633 "View.c"
	}
}

static void
_g_free0_ (gpointer var)
{
#line 32 "../src/panel/applets/budgie-menu/views/View.vala"
	var = (g_free (var), NULL);
#line 642 "View.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 32 "../src/panel/applets/budgie-menu/views/View.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 650 "View.c"
}

static GObject *
application_view_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ApplicationView * self;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GHashTable* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* _tmp5_;
	BudgieRelevancyService* _tmp6_;
#line 31 "../src/panel/applets/budgie-menu/views/View.vala"
	parent_class = G_OBJECT_CLASS (application_view_parent_class);
#line 31 "../src/panel/applets/budgie-menu/views/View.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 31 "../src/panel/applets/budgie-menu/views/View.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APPLICATION_VIEW, ApplicationView);
#line 32 "../src/panel/applets/budgie-menu/views/View.vala"
	_tmp0_ = g_str_hash;
#line 32 "../src/panel/applets/budgie-menu/views/View.vala"
	_tmp1_ = g_str_equal;
#line 32 "../src/panel/applets/budgie-menu/views/View.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_object_unref0_);
#line 32 "../src/panel/applets/budgie-menu/views/View.vala"
	_tmp3_ = _tmp2_;
#line 32 "../src/panel/applets/budgie-menu/views/View.vala"
	application_view_set_application_buttons (self, _tmp3_);
#line 32 "../src/panel/applets/budgie-menu/views/View.vala"
	_g_hash_table_unref0 (_tmp3_);
#line 33 "../src/panel/applets/budgie-menu/views/View.vala"
	_tmp4_ = gee_array_list_new (TYPE_MENU_BUTTON, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 33 "../src/panel/applets/budgie-menu/views/View.vala"
	_tmp5_ = _tmp4_;
#line 33 "../src/panel/applets/budgie-menu/views/View.vala"
	application_view_set_control_center_buttons (self, _tmp5_);
#line 33 "../src/panel/applets/budgie-menu/views/View.vala"
	_g_object_unref0 (_tmp5_);
#line 34 "../src/panel/applets/budgie-menu/views/View.vala"
	_tmp6_ = budgie_relevancy_service_new ();
#line 34 "../src/panel/applets/budgie-menu/views/View.vala"
	_g_object_unref0 (self->relevancy_service);
#line 34 "../src/panel/applets/budgie-menu/views/View.vala"
	self->relevancy_service = _tmp6_;
#line 31 "../src/panel/applets/budgie-menu/views/View.vala"
	return obj;
#line 702 "View.c"
}

static void
application_view_class_init (ApplicationViewClass * klass,
                             gpointer klass_data)
{
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
	application_view_parent_class = g_type_class_peek_parent (klass);
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
	g_type_class_adjust_private_offset (klass, &ApplicationView_private_offset);
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
	((ApplicationViewClass *) klass)->on_search_entry_activated = (void (*) (ApplicationView*)) application_view_real_on_search_entry_activated;
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
	((ApplicationViewClass *) klass)->on_show = (void (*) (ApplicationView*)) application_view_real_on_show;
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
	((ApplicationViewClass *) klass)->refresh = (void (*) (ApplicationView*, BudgieAppIndex*)) application_view_real_refresh;
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
	((ApplicationViewClass *) klass)->invalidate = (void (*) (ApplicationView*)) application_view_real_invalidate;
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_application_view_get_property;
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_application_view_set_property;
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
	G_OBJECT_CLASS (klass)->constructor = application_view_constructor;
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
	G_OBJECT_CLASS (klass)->finalize = application_view_finalize;
#line 729 "View.c"
	/** Mapped id to MenuButton */
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_VIEW_APPLICATION_BUTTONS_PROPERTY, application_view_properties[APPLICATION_VIEW_APPLICATION_BUTTONS_PROPERTY] = g_param_spec_boxed ("application-buttons", "application-buttons", "application-buttons", G_TYPE_HASH_TABLE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_VIEW_CONTROL_CENTER_BUTTONS_PROPERTY, application_view_properties[APPLICATION_VIEW_CONTROL_CENTER_BUTTONS_PROPERTY] = g_param_spec_object ("control-center-buttons", "control-center-buttons", "control-center-buttons", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_VIEW_SEARCH_TERM_PROPERTY, application_view_properties[APPLICATION_VIEW_SEARCH_TERM_PROPERTY] = g_param_spec_string ("search-term", "search-term", "search-term", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_VIEW_ICON_SIZE_PROPERTY, application_view_properties[APPLICATION_VIEW_ICON_SIZE_PROPERTY] = g_param_spec_int ("icon-size", "icon-size", "icon-size", G_MININT, G_MAXINT, 24, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 739 "View.c"
	/**
	 * Emitted when an app is launched.
	 */
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
	application_view_signals[APPLICATION_VIEW_APP_LAUNCHED_SIGNAL] = g_signal_new ("app-launched", TYPE_APPLICATION_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 745 "View.c"
}

static void
application_view_instance_init (ApplicationView * self,
                                gpointer klass)
{
	gchar* _tmp0_;
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
	self->priv = application_view_get_instance_private (self);
#line 18 "../src/panel/applets/budgie-menu/views/View.vala"
	self->priv->_application_buttons = NULL;
#line 19 "../src/panel/applets/budgie-menu/views/View.vala"
	self->priv->_control_center_buttons = NULL;
#line 20 "../src/panel/applets/budgie-menu/views/View.vala"
	_tmp0_ = g_strdup ("");
#line 20 "../src/panel/applets/budgie-menu/views/View.vala"
	self->priv->_search_term = _tmp0_;
#line 21 "../src/panel/applets/budgie-menu/views/View.vala"
	self->priv->_icon_size = 24;
#line 24 "../src/panel/applets/budgie-menu/views/View.vala"
	self->priv->timeout_id = (guint) 0;
#line 767 "View.c"
}

static void
application_view_finalize (GObject * obj)
{
	ApplicationView * self;
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APPLICATION_VIEW, ApplicationView);
#line 18 "../src/panel/applets/budgie-menu/views/View.vala"
	_g_hash_table_unref0 (self->priv->_application_buttons);
#line 19 "../src/panel/applets/budgie-menu/views/View.vala"
	_g_object_unref0 (self->priv->_control_center_buttons);
#line 20 "../src/panel/applets/budgie-menu/views/View.vala"
	_g_free0 (self->priv->_search_term);
#line 23 "../src/panel/applets/budgie-menu/views/View.vala"
	_g_object_unref0 (self->relevancy_service);
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
	G_OBJECT_CLASS (application_view_parent_class)->finalize (obj);
#line 786 "View.c"
}

/**
 * Abstract class for different views for the application menu to
 * extend.
 */
GType
application_view_get_type (void)
{
	return application_view_type_id;
}

GType
application_view_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (ApplicationViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) application_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ApplicationView), 0, (GInstanceInitFunc) application_view_instance_init, NULL };
	application_view_type_id = g_type_module_register_type (module, gtk_box_get_type (), "ApplicationView", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	ApplicationView_private_offset = sizeof (ApplicationViewPrivate);
	return application_view_type_id;
}

static void
_vala_application_view_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	ApplicationView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_APPLICATION_VIEW, ApplicationView);
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
	switch (property_id) {
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
		case APPLICATION_VIEW_APPLICATION_BUTTONS_PROPERTY:
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
		g_value_set_boxed (value, application_view_get_application_buttons (self));
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
		break;
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
		case APPLICATION_VIEW_CONTROL_CENTER_BUTTONS_PROPERTY:
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
		g_value_set_object (value, application_view_get_control_center_buttons (self));
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
		break;
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
		case APPLICATION_VIEW_SEARCH_TERM_PROPERTY:
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
		g_value_set_string (value, application_view_get_search_term (self));
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
		break;
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
		case APPLICATION_VIEW_ICON_SIZE_PROPERTY:
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
		g_value_set_int (value, application_view_get_icon_size (self));
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
		break;
#line 842 "View.c"
		default:
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
		break;
#line 848 "View.c"
	}
}

static void
_vala_application_view_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	ApplicationView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_APPLICATION_VIEW, ApplicationView);
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
	switch (property_id) {
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
		case APPLICATION_VIEW_APPLICATION_BUTTONS_PROPERTY:
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
		application_view_set_application_buttons (self, g_value_get_boxed (value));
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
		break;
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
		case APPLICATION_VIEW_CONTROL_CENTER_BUTTONS_PROPERTY:
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
		application_view_set_control_center_buttons (self, g_value_get_object (value));
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
		break;
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
		case APPLICATION_VIEW_SEARCH_TERM_PROPERTY:
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
		application_view_set_search_term (self, g_value_get_string (value));
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
		break;
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
		case APPLICATION_VIEW_ICON_SIZE_PROPERTY:
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
		application_view_set_icon_size (self, g_value_get_int (value));
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
		break;
#line 886 "View.c"
		default:
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 16 "../src/panel/applets/budgie-menu/views/View.vala"
		break;
#line 892 "View.c"
	}
}

