/* CaffeineApplet.c generated by valac 0.56.17, the Vala compiler
 * generated from CaffeineApplet.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include "caffeineapplet.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "plugin.h"
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <libpeas/peas.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	CAFFEINE_PLUGIN_0_PROPERTY,
	CAFFEINE_PLUGIN_NUM_PROPERTIES
};
static GParamSpec* caffeine_plugin_properties[CAFFEINE_PLUGIN_NUM_PROPERTIES];
enum  {
	CAFFEINE_APPLET_0_PROPERTY,
	CAFFEINE_APPLET_UUID_PROPERTY,
	CAFFEINE_APPLET_NUM_PROPERTIES
};
static GParamSpec* caffeine_applet_properties[CAFFEINE_APPLET_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _CaffeineAppletPrivate {
	GtkEventBox* event_box;
	GtkImage* applet_icon;
	BudgiePopover* popover;
	BudgiePopoverManager* manager;
	GSettings* interface_settings;
	GSettings* settings;
	GThemedIcon* caffeine_full_cup;
	GThemedIcon* caffeine_empty_cup;
	gchar* _uuid;
};

static gpointer caffeine_plugin_parent_class = NULL;
static BudgiePluginIface * caffeine_plugin_budgie_plugin_parent_iface = NULL;
static GType caffeine_plugin_type_id = 0;
static gint CaffeineApplet_private_offset;
static gpointer caffeine_applet_parent_class = NULL;
static GType caffeine_applet_type_id = 0;

static BudgieApplet* caffeine_plugin_real_get_panel_widget (BudgiePlugin* base,
                                                     const gchar* uuid);
static GThemedIcon* caffeine_applet_get_current_mode_icon (CaffeineApplet* self);
static void __lambda7_ (CaffeineApplet* self);
static void caffeine_applet_update_icon (CaffeineApplet* self);
static void ___lambda7__g_settings_changed (GSettings* _sender,
                                     const gchar* key,
                                     gpointer self);
static void __lambda8_ (CaffeineApplet* self);
static gboolean __lambda9_ (CaffeineApplet* self);
static void caffeine_applet_set_caffeine_icons (CaffeineApplet* self);
static gboolean ___lambda9__gsource_func (gpointer self);
static void ___lambda8__g_settings_changed (GSettings* _sender,
                                     const gchar* key,
                                     gpointer self);
static gboolean __lambda10_ (CaffeineApplet* self,
                      GdkEventButton* e);
static void caffeine_applet_toggle_caffeine_mode (CaffeineApplet* self);
static gboolean ___lambda10__gtk_widget_button_press_event (GtkWidget* _sender,
                                                     GdkEventButton* event,
                                                     gpointer self);
static void caffeine_applet_real_update_popovers (BudgieApplet* base,
                                           BudgiePopoverManager* manager);
static gboolean caffeine_applet_real_supports_settings (BudgieApplet* base);
static GtkWidget* caffeine_applet_real_get_settings_ui (BudgieApplet* base);
static void caffeine_applet_finalize (GObject * obj);
static void _vala_caffeine_applet_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_caffeine_applet_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
GType caffeine_caffeine_window_register_type (GTypeModule * module);
GType caffeine_applet_settings_register_type (GTypeModule * module);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static BudgieApplet*
caffeine_plugin_real_get_panel_widget (BudgiePlugin* base,
                                       const gchar* uuid)
{
	CaffeinePlugin * self;
	CaffeineApplet* _tmp0_;
	BudgieApplet* result;
#line 14 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	self = (CaffeinePlugin*) base;
#line 14 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 15 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp0_ = caffeine_applet_new (uuid);
#line 15 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	g_object_ref_sink (_tmp0_);
#line 15 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	result = (BudgieApplet*) _tmp0_;
#line 15 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	return result;
#line 131 "CaffeineApplet.c"
}

CaffeinePlugin*
caffeine_plugin_construct (GType object_type)
{
	CaffeinePlugin * self = NULL;
#line 13 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	self = (CaffeinePlugin*) g_object_new (object_type, NULL);
#line 13 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	return self;
#line 142 "CaffeineApplet.c"
}

CaffeinePlugin*
caffeine_plugin_new (void)
{
#line 13 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	return caffeine_plugin_construct (CAFFEINE_TYPE_PLUGIN);
#line 150 "CaffeineApplet.c"
}

static void
caffeine_plugin_class_init (CaffeinePluginClass * klass,
                            gpointer klass_data)
{
#line 13 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	caffeine_plugin_parent_class = g_type_class_peek_parent (klass);
#line 159 "CaffeineApplet.c"
}

static void
caffeine_plugin_budgie_plugin_interface_init (BudgiePluginIface * iface,
                                              gpointer iface_data)
{
#line 13 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	caffeine_plugin_budgie_plugin_parent_iface = g_type_interface_peek_parent (iface);
#line 13 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	iface->get_panel_widget = (BudgieApplet* (*) (BudgiePlugin*, const gchar*)) caffeine_plugin_real_get_panel_widget;
#line 170 "CaffeineApplet.c"
}

static void
caffeine_plugin_instance_init (CaffeinePlugin * self,
                               gpointer klass)
{
}

GType
caffeine_plugin_get_type (void)
{
	return caffeine_plugin_type_id;
}

GType
caffeine_plugin_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (CaffeinePluginClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) caffeine_plugin_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CaffeinePlugin), 0, (GInstanceInitFunc) caffeine_plugin_instance_init, NULL };
	static const GInterfaceInfo budgie_plugin_info = { (GInterfaceInitFunc) caffeine_plugin_budgie_plugin_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	caffeine_plugin_type_id = g_type_module_register_type (module, peas_extension_base_get_type (), "CaffeinePlugin", &g_define_type_info, 0);
	g_type_module_add_interface (module, caffeine_plugin_type_id, budgie_plugin_get_type (), &budgie_plugin_info);
	return caffeine_plugin_type_id;
}

static inline gpointer
caffeine_applet_get_instance_private (CaffeineApplet* self)
{
	return G_STRUCT_MEMBER_P (self, CaffeineApplet_private_offset);
}

static void
__lambda7_ (CaffeineApplet* self)
{
#line 51 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	caffeine_applet_update_icon (self);
#line 206 "CaffeineApplet.c"
}

static void
___lambda7__g_settings_changed (GSettings* _sender,
                                const gchar* key,
                                gpointer self)
{
#line 50 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	__lambda7_ ((CaffeineApplet*) self);
#line 216 "CaffeineApplet.c"
}

static gboolean
__lambda9_ (CaffeineApplet* self)
{
	gboolean result;
#line 56 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	caffeine_applet_set_caffeine_icons (self);
#line 57 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	caffeine_applet_update_icon (self);
#line 58 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	result = FALSE;
#line 58 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	return result;
#line 231 "CaffeineApplet.c"
}

static gboolean
___lambda9__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda9_ ((CaffeineApplet*) self);
#line 55 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	return result;
#line 241 "CaffeineApplet.c"
}

static void
__lambda8_ (CaffeineApplet* self)
{
#line 55 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 200, ___lambda9__gsource_func, g_object_ref (self), g_object_unref);
#line 249 "CaffeineApplet.c"
}

static void
___lambda8__g_settings_changed (GSettings* _sender,
                                const gchar* key,
                                gpointer self)
{
#line 54 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	__lambda8_ ((CaffeineApplet*) self);
#line 259 "CaffeineApplet.c"
}

static gboolean
__lambda10_ (CaffeineApplet* self,
             GdkEventButton* e)
{
	gboolean result;
#line 63 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 64 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	switch (e->button) {
#line 64 "../src/panel/applets/caffeine/CaffeineApplet.vala"
		case 1:
#line 273 "CaffeineApplet.c"
		{
			BudgiePopover* _tmp0_;
#line 66 "../src/panel/applets/caffeine/CaffeineApplet.vala"
			_tmp0_ = self->priv->popover;
#line 66 "../src/panel/applets/caffeine/CaffeineApplet.vala"
			if (gtk_widget_get_visible ((GtkWidget*) _tmp0_)) {
#line 280 "CaffeineApplet.c"
				BudgiePopover* _tmp1_;
#line 67 "../src/panel/applets/caffeine/CaffeineApplet.vala"
				_tmp1_ = self->priv->popover;
#line 67 "../src/panel/applets/caffeine/CaffeineApplet.vala"
				gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 286 "CaffeineApplet.c"
			} else {
				BudgiePopover* _tmp2_;
				BudgiePopoverManager* _tmp3_;
				GtkEventBox* _tmp4_;
#line 69 "../src/panel/applets/caffeine/CaffeineApplet.vala"
				_tmp2_ = self->priv->popover;
#line 69 "../src/panel/applets/caffeine/CaffeineApplet.vala"
				gtk_widget_show_all ((GtkWidget*) _tmp2_);
#line 70 "../src/panel/applets/caffeine/CaffeineApplet.vala"
				_tmp3_ = self->priv->manager;
#line 70 "../src/panel/applets/caffeine/CaffeineApplet.vala"
				_tmp4_ = self->priv->event_box;
#line 70 "../src/panel/applets/caffeine/CaffeineApplet.vala"
				budgie_popover_manager_show_popover (_tmp3_, (GtkWidget*) _tmp4_);
#line 301 "CaffeineApplet.c"
			}
#line 72 "../src/panel/applets/caffeine/CaffeineApplet.vala"
			break;
#line 305 "CaffeineApplet.c"
		}
#line 64 "../src/panel/applets/caffeine/CaffeineApplet.vala"
		case 2:
#line 309 "CaffeineApplet.c"
		{
#line 74 "../src/panel/applets/caffeine/CaffeineApplet.vala"
			caffeine_applet_toggle_caffeine_mode (self);
#line 75 "../src/panel/applets/caffeine/CaffeineApplet.vala"
			break;
#line 315 "CaffeineApplet.c"
		}
		default:
		{
#line 77 "../src/panel/applets/caffeine/CaffeineApplet.vala"
			result = GDK_EVENT_PROPAGATE;
#line 77 "../src/panel/applets/caffeine/CaffeineApplet.vala"
			return result;
#line 323 "CaffeineApplet.c"
		}
	}
#line 80 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	result = GDK_EVENT_STOP;
#line 80 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	return result;
#line 330 "CaffeineApplet.c"
}

static gboolean
___lambda10__gtk_widget_button_press_event (GtkWidget* _sender,
                                            GdkEventButton* event,
                                            gpointer self)
{
	gboolean result;
	result = __lambda10_ ((CaffeineApplet*) self, event);
#line 63 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	return result;
#line 342 "CaffeineApplet.c"
}

CaffeineApplet*
caffeine_applet_construct (GType object_type,
                           const gchar* uuid)
{
	CaffeineApplet * self = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	GThemedIcon* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar** _tmp9_;
	gchar** _tmp10_;
	gint _tmp10__length1;
	GThemedIcon* _tmp11_;
	GtkEventBox* _tmp12_;
	GtkEventBox* _tmp13_;
	GThemedIcon* _tmp14_;
	GThemedIcon* _tmp15_;
	GtkImage* _tmp16_;
	GtkEventBox* _tmp17_;
	GtkImage* _tmp18_;
	GtkEventBox* _tmp19_;
	GSettings* _tmp20_;
	CaffeineCaffeineWindow* _tmp21_;
	GSettings* _tmp22_;
	GSettings* _tmp23_;
	GtkEventBox* _tmp24_;
#line 34 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 35 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	self = (CaffeineApplet*) g_object_new (object_type, "uuid", uuid, NULL);
#line 37 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp0_ = g_settings_new ("org.gnome.desktop.interface");
#line 37 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_g_object_unref0 (self->priv->interface_settings);
#line 37 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	self->priv->interface_settings = _tmp0_;
#line 38 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp1_ = g_settings_new ("com.solus-project.budgie-wm");
#line 38 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_g_object_unref0 (self->priv->settings);
#line 38 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	self->priv->settings = _tmp1_;
#line 40 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp2_ = g_strdup ("caffeine-cup-full");
#line 40 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp3_ = g_strdup ("budgie-caffeine-cup-full");
#line 40 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp4_ = g_new0 (gchar*, 2 + 1);
#line 40 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp4_[0] = _tmp2_;
#line 40 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp4_[1] = _tmp3_;
#line 40 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp5_ = _tmp4_;
#line 40 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp5__length1 = 2;
#line 40 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp6_ = (GThemedIcon*) g_themed_icon_new_from_names (_tmp5_, 2);
#line 40 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_g_object_unref0 (self->priv->caffeine_full_cup);
#line 40 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	self->priv->caffeine_full_cup = _tmp6_;
#line 40 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_free), NULL);
#line 41 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp7_ = g_strdup ("caffeine-cup-empty");
#line 41 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp8_ = g_strdup ("budgie-caffeine-cup-empty");
#line 41 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp9_ = g_new0 (gchar*, 2 + 1);
#line 41 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp9_[0] = _tmp7_;
#line 41 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp9_[1] = _tmp8_;
#line 41 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp10_ = _tmp9_;
#line 41 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp10__length1 = 2;
#line 41 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp11_ = (GThemedIcon*) g_themed_icon_new_from_names (_tmp10_, 2);
#line 41 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_g_object_unref0 (self->priv->caffeine_empty_cup);
#line 41 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	self->priv->caffeine_empty_cup = _tmp11_;
#line 41 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp10_ = (_vala_array_free (_tmp10_, _tmp10__length1, (GDestroyNotify) g_free), NULL);
#line 43 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp12_ = (GtkEventBox*) gtk_event_box_new ();
#line 43 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	g_object_ref_sink (_tmp12_);
#line 43 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_g_object_unref0 (self->priv->event_box);
#line 43 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	self->priv->event_box = _tmp12_;
#line 44 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp13_ = self->priv->event_box;
#line 44 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp13_);
#line 45 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp14_ = caffeine_applet_get_current_mode_icon (self);
#line 45 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp15_ = _tmp14_;
#line 45 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp16_ = (GtkImage*) gtk_image_new_from_gicon ((GIcon*) _tmp15_, (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 45 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	g_object_ref_sink (_tmp16_);
#line 45 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_g_object_unref0 (self->priv->applet_icon);
#line 45 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	self->priv->applet_icon = _tmp16_;
#line 45 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_g_object_unref0 (_tmp15_);
#line 46 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp17_ = self->priv->event_box;
#line 46 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp18_ = self->priv->applet_icon;
#line 46 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	gtk_container_add ((GtkContainer*) _tmp17_, (GtkWidget*) _tmp18_);
#line 48 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp19_ = self->priv->event_box;
#line 48 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp20_ = self->priv->settings;
#line 48 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp21_ = caffeine_caffeine_window_new ((GtkWidget*) _tmp19_, _tmp20_);
#line 48 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	g_object_ref_sink (_tmp21_);
#line 48 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_g_object_unref0 (self->priv->popover);
#line 48 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	self->priv->popover = (BudgiePopover*) _tmp21_;
#line 50 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp22_ = self->priv->settings;
#line 50 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	g_signal_connect_object (_tmp22_, "changed::caffeine-mode", (GCallback) ___lambda7__g_settings_changed, self, 0);
#line 54 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp23_ = self->priv->interface_settings;
#line 54 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	g_signal_connect_object (_tmp23_, "changed::icon-theme", (GCallback) ___lambda8__g_settings_changed, self, G_CONNECT_AFTER);
#line 63 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp24_ = self->priv->event_box;
#line 63 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	g_signal_connect_object ((GtkWidget*) _tmp24_, "button-press-event", (GCallback) ___lambda10__gtk_widget_button_press_event, self, 0);
#line 83 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 34 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	return self;
#line 497 "CaffeineApplet.c"
}

CaffeineApplet*
caffeine_applet_new (const gchar* uuid)
{
#line 34 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	return caffeine_applet_construct (CAFFEINE_TYPE_APPLET, uuid);
#line 505 "CaffeineApplet.c"
}

/**
* get_current_mode_icon will get the current ThemedIcon (GIcon) for the current Caffeine Mode state
*/
static gpointer
_g_object_ref0 (gpointer self)
{
#line 91 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	return self ? g_object_ref (self) : NULL;
#line 516 "CaffeineApplet.c"
}

static GThemedIcon*
caffeine_applet_get_current_mode_icon (CaffeineApplet* self)
{
	gboolean enabled = FALSE;
	GSettings* _tmp0_;
	GThemedIcon* _tmp1_ = NULL;
	GThemedIcon* state_icon = NULL;
	GThemedIcon* _tmp4_;
	GThemedIcon* result;
#line 89 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 90 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp0_ = self->priv->settings;
#line 90 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	enabled = g_settings_get_boolean (_tmp0_, "caffeine-mode");
#line 91 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	if (enabled) {
#line 536 "CaffeineApplet.c"
		GThemedIcon* _tmp2_;
#line 91 "../src/panel/applets/caffeine/CaffeineApplet.vala"
		_tmp2_ = self->priv->caffeine_full_cup;
#line 91 "../src/panel/applets/caffeine/CaffeineApplet.vala"
		_tmp1_ = _tmp2_;
#line 542 "CaffeineApplet.c"
	} else {
		GThemedIcon* _tmp3_;
#line 91 "../src/panel/applets/caffeine/CaffeineApplet.vala"
		_tmp3_ = self->priv->caffeine_empty_cup;
#line 91 "../src/panel/applets/caffeine/CaffeineApplet.vala"
		_tmp1_ = _tmp3_;
#line 549 "CaffeineApplet.c"
	}
#line 91 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp4_ = _g_object_ref0 (_tmp1_);
#line 91 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	state_icon = _tmp4_;
#line 92 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	result = state_icon;
#line 92 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	return result;
#line 559 "CaffeineApplet.c"
}

/**
* toggle_caffeine_mode will toggle our current Caffeine Mode
*/
static void
caffeine_applet_toggle_caffeine_mode (CaffeineApplet* self)
{
	gboolean enabled = FALSE;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 98 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	g_return_if_fail (self != NULL);
#line 99 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp0_ = self->priv->settings;
#line 99 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	enabled = g_settings_get_boolean (_tmp0_, "caffeine-mode");
#line 100 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp1_ = self->priv->settings;
#line 100 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	g_settings_set_boolean (_tmp1_, "caffeine-mode", !enabled);
#line 581 "CaffeineApplet.c"
}

/**
* set_caffeine_icons will set our full and empty cup icons to the current IconTheme icons
*/
static void
caffeine_applet_set_caffeine_icons (CaffeineApplet* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	GThemedIcon* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	GThemedIcon* _tmp9_;
#line 106 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	g_return_if_fail (self != NULL);
#line 107 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp0_ = g_strdup ("caffeine-cup-full");
#line 107 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp1_ = g_strdup ("budgie-caffeine-cup-full");
#line 107 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp2_ = g_new0 (gchar*, 2 + 1);
#line 107 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp2_[0] = _tmp0_;
#line 107 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp2_[1] = _tmp1_;
#line 107 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp3_ = _tmp2_;
#line 107 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp3__length1 = 2;
#line 107 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp4_ = (GThemedIcon*) g_themed_icon_new_from_names (_tmp3_, 2);
#line 107 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_g_object_unref0 (self->priv->caffeine_full_cup);
#line 107 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	self->priv->caffeine_full_cup = _tmp4_;
#line 107 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
#line 108 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp5_ = g_strdup ("caffeine-cup-empty");
#line 108 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp6_ = g_strdup ("budgie-caffeine-cup-empty");
#line 108 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp7_ = g_new0 (gchar*, 2 + 1);
#line 108 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp7_[0] = _tmp5_;
#line 108 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp7_[1] = _tmp6_;
#line 108 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp8_ = _tmp7_;
#line 108 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp8__length1 = 2;
#line 108 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp9_ = (GThemedIcon*) g_themed_icon_new_from_names (_tmp8_, 2);
#line 108 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_g_object_unref0 (self->priv->caffeine_empty_cup);
#line 108 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	self->priv->caffeine_empty_cup = _tmp9_;
#line 108 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 648 "CaffeineApplet.c"
}

/**
* update_icon will update the applet icon
*/
static void
caffeine_applet_update_icon (CaffeineApplet* self)
{
	GtkImage* _tmp0_;
	GThemedIcon* _tmp1_;
	GThemedIcon* _tmp2_;
#line 114 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	g_return_if_fail (self != NULL);
#line 115 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp0_ = self->priv->applet_icon;
#line 115 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp1_ = caffeine_applet_get_current_mode_icon (self);
#line 115 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp2_ = _tmp1_;
#line 115 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	gtk_image_set_from_gicon (_tmp0_, (GIcon*) _tmp2_, (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 115 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_g_object_unref0 (_tmp2_);
#line 672 "CaffeineApplet.c"
}

static void
caffeine_applet_real_update_popovers (BudgieApplet* base,
                                      BudgiePopoverManager* manager)
{
	CaffeineApplet * self;
	GtkEventBox* _tmp0_;
	BudgiePopover* _tmp1_;
#line 118 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	self = (CaffeineApplet*) base;
#line 119 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp0_ = self->priv->event_box;
#line 119 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp1_ = self->priv->popover;
#line 119 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	budgie_popover_manager_register_popover (manager, (GtkWidget*) _tmp0_, (GtkPopover*) _tmp1_);
#line 120 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	self->priv->manager = manager;
#line 692 "CaffeineApplet.c"
}

static gboolean
caffeine_applet_real_supports_settings (BudgieApplet* base)
{
	CaffeineApplet * self;
	gboolean result;
#line 123 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	self = (CaffeineApplet*) base;
#line 124 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	result = TRUE;
#line 124 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	return result;
#line 706 "CaffeineApplet.c"
}

static GtkWidget*
caffeine_applet_real_get_settings_ui (BudgieApplet* base)
{
	CaffeineApplet * self;
	const gchar* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	CaffeineAppletSettings* _tmp3_;
	GtkWidget* _tmp4_;
	GtkWidget* result;
#line 127 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	self = (CaffeineApplet*) base;
#line 128 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp0_ = self->priv->_uuid;
#line 128 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp1_ = budgie_applet_get_applet_settings ((BudgieApplet*) self, _tmp0_);
#line 128 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp2_ = _tmp1_;
#line 128 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp3_ = caffeine_applet_settings_new (_tmp2_);
#line 128 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	g_object_ref_sink (_tmp3_);
#line 128 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp4_ = (GtkWidget*) _tmp3_;
#line 128 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_g_object_unref0 (_tmp2_);
#line 128 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	result = _tmp4_;
#line 128 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	return result;
#line 739 "CaffeineApplet.c"
}

const gchar*
caffeine_applet_get_uuid (CaffeineApplet* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 32 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp0_ = self->priv->_uuid;
#line 32 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	result = _tmp0_;
#line 32 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	return result;
#line 755 "CaffeineApplet.c"
}

void
caffeine_applet_set_uuid (CaffeineApplet* self,
                          const gchar* value)
{
	gchar* old_value;
#line 32 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	old_value = caffeine_applet_get_uuid (self);
#line 32 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 769 "CaffeineApplet.c"
		gchar* _tmp0_;
#line 32 "../src/panel/applets/caffeine/CaffeineApplet.vala"
		_tmp0_ = g_strdup (value);
#line 32 "../src/panel/applets/caffeine/CaffeineApplet.vala"
		_g_free0 (self->priv->_uuid);
#line 32 "../src/panel/applets/caffeine/CaffeineApplet.vala"
		self->priv->_uuid = _tmp0_;
#line 32 "../src/panel/applets/caffeine/CaffeineApplet.vala"
		g_object_notify_by_pspec ((GObject *) self, caffeine_applet_properties[CAFFEINE_APPLET_UUID_PROPERTY]);
#line 779 "CaffeineApplet.c"
	}
}

static void
caffeine_applet_class_init (CaffeineAppletClass * klass,
                            gpointer klass_data)
{
#line 19 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	caffeine_applet_parent_class = g_type_class_peek_parent (klass);
#line 19 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	g_type_class_adjust_private_offset (klass, &CaffeineApplet_private_offset);
#line 19 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	((BudgieAppletClass *) klass)->update_popovers = (void (*) (BudgieApplet*, BudgiePopoverManager*)) caffeine_applet_real_update_popovers;
#line 19 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	((BudgieAppletClass *) klass)->supports_settings = (gboolean (*) (BudgieApplet*)) caffeine_applet_real_supports_settings;
#line 19 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	((BudgieAppletClass *) klass)->get_settings_ui = (GtkWidget* (*) (BudgieApplet*)) caffeine_applet_real_get_settings_ui;
#line 19 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_caffeine_applet_get_property;
#line 19 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_caffeine_applet_set_property;
#line 19 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	G_OBJECT_CLASS (klass)->finalize = caffeine_applet_finalize;
#line 19 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CAFFEINE_APPLET_UUID_PROPERTY, caffeine_applet_properties[CAFFEINE_APPLET_UUID_PROPERTY] = g_param_spec_string ("uuid", "uuid", "uuid", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 805 "CaffeineApplet.c"
}

static void
caffeine_applet_instance_init (CaffeineApplet * self,
                               gpointer klass)
{
#line 19 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	self->priv = caffeine_applet_get_instance_private (self);
#line 23 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	self->priv->popover = NULL;
#line 24 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	self->priv->manager = NULL;
#line 818 "CaffeineApplet.c"
}

static void
caffeine_applet_finalize (GObject * obj)
{
	CaffeineApplet * self;
#line 19 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CAFFEINE_TYPE_APPLET, CaffeineApplet);
#line 20 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_g_object_unref0 (self->priv->event_box);
#line 21 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_g_object_unref0 (self->priv->applet_icon);
#line 23 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_g_object_unref0 (self->priv->popover);
#line 26 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_g_object_unref0 (self->priv->interface_settings);
#line 27 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_g_object_unref0 (self->priv->settings);
#line 29 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_g_object_unref0 (self->priv->caffeine_full_cup);
#line 30 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_g_object_unref0 (self->priv->caffeine_empty_cup);
#line 32 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_g_free0 (self->priv->_uuid);
#line 19 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	G_OBJECT_CLASS (caffeine_applet_parent_class)->finalize (obj);
#line 845 "CaffeineApplet.c"
}

GType
caffeine_applet_get_type (void)
{
	return caffeine_applet_type_id;
}

GType
caffeine_applet_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (CaffeineAppletClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) caffeine_applet_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CaffeineApplet), 0, (GInstanceInitFunc) caffeine_applet_instance_init, NULL };
	caffeine_applet_type_id = g_type_module_register_type (module, budgie_applet_get_type (), "CaffeineApplet", &g_define_type_info, 0);
	CaffeineApplet_private_offset = sizeof (CaffeineAppletPrivate);
	return caffeine_applet_type_id;
}

static void
_vala_caffeine_applet_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	CaffeineApplet * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CAFFEINE_TYPE_APPLET, CaffeineApplet);
#line 19 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	switch (property_id) {
#line 19 "../src/panel/applets/caffeine/CaffeineApplet.vala"
		case CAFFEINE_APPLET_UUID_PROPERTY:
#line 19 "../src/panel/applets/caffeine/CaffeineApplet.vala"
		g_value_set_string (value, caffeine_applet_get_uuid (self));
#line 19 "../src/panel/applets/caffeine/CaffeineApplet.vala"
		break;
#line 879 "CaffeineApplet.c"
		default:
#line 19 "../src/panel/applets/caffeine/CaffeineApplet.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../src/panel/applets/caffeine/CaffeineApplet.vala"
		break;
#line 885 "CaffeineApplet.c"
	}
}

static void
_vala_caffeine_applet_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	CaffeineApplet * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CAFFEINE_TYPE_APPLET, CaffeineApplet);
#line 19 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	switch (property_id) {
#line 19 "../src/panel/applets/caffeine/CaffeineApplet.vala"
		case CAFFEINE_APPLET_UUID_PROPERTY:
#line 19 "../src/panel/applets/caffeine/CaffeineApplet.vala"
		caffeine_applet_set_uuid (self, g_value_get_string (value));
#line 19 "../src/panel/applets/caffeine/CaffeineApplet.vala"
		break;
#line 905 "CaffeineApplet.c"
		default:
#line 19 "../src/panel/applets/caffeine/CaffeineApplet.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../src/panel/applets/caffeine/CaffeineApplet.vala"
		break;
#line 911 "CaffeineApplet.c"
	}
}

void
peas_register_types (GTypeModule* module)
{
	PeasObjectModule* objmodule = NULL;
	PeasObjectModule* _tmp0_;
#line 134 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	g_return_if_fail (module != NULL);
#line 134 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	caffeine_plugin_register_type (module);
#line 134 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	caffeine_applet_register_type (module);
#line 134 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	caffeine_caffeine_window_register_type (module);
#line 134 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	caffeine_applet_settings_register_type (module);
#line 136 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (module, peas_object_module_get_type ()) ? ((PeasObjectModule*) module) : NULL);
#line 136 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	objmodule = _tmp0_;
#line 137 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	peas_object_module_register_extension_type (objmodule, budgie_plugin_get_type (), CAFFEINE_TYPE_PLUGIN);
#line 134 "../src/panel/applets/caffeine/CaffeineApplet.vala"
	_g_object_unref0 (objmodule);
#line 938 "CaffeineApplet.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

