/* Icon.c generated by valac 0.56.17, the Vala compiler
 * generated from Icon.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include <glib.h>
#include "icontasklistapplet.h"
#include "plugin.h"
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <cairo-gobject.h>
#include <glib-object.h>
#include "budgie-private.h"
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>

#define MAX_CYCLES 12
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	ICON_0_PROPERTY,
	ICON_BOUNCE_PROPERTY,
	ICON_ATTENTION_PROPERTY,
	ICON_ICON_OPACITY_PROPERTY,
	ICON_NUM_PROPERTIES
};
static GParamSpec* icon_properties[ICON_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block5Data Block5Data;
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))

struct _IconPrivate {
	gint widget_width;
	gint widget_height;
	BudgiePanelPosition panel_position;
	gint wait_cycle_counter;
	gint attention_cycle_counter;
	gdouble bounce_amount;
	gdouble attention_amount;
};

struct _Block5Data {
	int _ref_count_;
	Icon* self;
	BudgieAnimation* wait_animation;
	BudgieAnimation* wait_animation1;
};

static gint Icon_private_offset;
static gpointer icon_parent_class = NULL;
static GType icon_type_id = 0;

static void _icon_on_size_allocate_gtk_widget_size_allocate (GtkWidget* _sender,
                                                      GtkAllocation* allocation,
                                                      gpointer self);
static gdouble _budgie_sine_ease_in_budgie_tween_func (gdouble factor,
                                                gpointer self);
static void _vala_BudgiePropChange_array_free (BudgiePropChange * array,
                                        gssize array_length);
static void __lambda4_ (Icon* self,
                 BudgieAnimation* a);
static void ___lambda4__budgie_anim_completion_func (BudgieAnimation* src,
                                              gpointer self);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void __lambda5_ (Icon* self);
static void ___lambda5__budgie_anim_completion_func (BudgieAnimation* src,
                                              gpointer self);
static gboolean __lambda6_ (Block5Data* _data5_);
static void __lambda7_ (Icon* self,
                 BudgieAnimation* a);
static void ___lambda7__budgie_anim_completion_func (BudgieAnimation* src,
                                              gpointer self);
static gboolean ___lambda6__gsource_func (gpointer self);
static gdouble _budgie_elastic_ease_out_budgie_tween_func (gdouble factor,
                                                    gpointer self);
static void __lambda8_ (Icon* self,
                 BudgieAnimation* a);
static void ___lambda8__budgie_anim_completion_func (BudgieAnimation* src,
                                              gpointer self);
static gboolean icon_real_draw (GtkWidget* base,
                         cairo_t* cr);
static void icon_finalize (GObject * obj);
static void _vala_icon_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec);
static void _vala_icon_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec);

static inline gpointer
icon_get_instance_private (Icon* self)
{
	return G_STRUCT_MEMBER_P (self, Icon_private_offset);
}

static void
_icon_on_size_allocate_gtk_widget_size_allocate (GtkWidget* _sender,
                                                 GtkAllocation* allocation,
                                                 gpointer self)
{
#line 59 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	icon_on_size_allocate ((Icon*) self, allocation);
#line 127 "Icon.c"
}

Icon*
icon_construct (GType object_type)
{
	Icon * self = NULL;
#line 58 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	self = (Icon*) g_object_new (object_type, NULL);
#line 59 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_signal_connect_object ((GtkWidget*) self, "size-allocate", (GCallback) _icon_on_size_allocate_gtk_widget_size_allocate, self, 0);
#line 58 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	return self;
#line 140 "Icon.c"
}

Icon*
icon_new (void)
{
#line 58 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	return icon_construct (TYPE_ICON);
#line 148 "Icon.c"
}

void
icon_on_size_allocate (Icon* self,
                       GtkAllocation* allocation)
{
	GtkAllocation _tmp0_;
	GtkAllocation _tmp1_;
#line 62 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_return_if_fail (self != NULL);
#line 62 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_return_if_fail (allocation != NULL);
#line 63 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp0_ = *allocation;
#line 63 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	self->priv->widget_width = _tmp0_.width;
#line 64 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp1_ = *allocation;
#line 64 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	self->priv->widget_height = _tmp1_.height;
#line 169 "Icon.c"
}

static gdouble
_budgie_sine_ease_in_budgie_tween_func (gdouble factor,
                                        gpointer self)
{
	gdouble result;
	result = budgie_sine_ease_in (factor);
#line 83 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	return result;
#line 180 "Icon.c"
}

static void
_vala_BudgiePropChange_array_free (BudgiePropChange * array,
                                   gssize array_length)
{
#line 86 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	if (array != NULL) {
#line 189 "Icon.c"
		gssize i;
#line 86 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 86 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			budgie_prop_change_destroy (&array[i]);
#line 195 "Icon.c"
		}
	}
#line 86 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_free (array);
#line 200 "Icon.c"
}

static void
__lambda4_ (Icon* self,
            BudgieAnimation* a)
{
#line 112 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	icon_animate_attention (self, NULL);
#line 209 "Icon.c"
}

static void
___lambda4__budgie_anim_completion_func (BudgieAnimation* src,
                                         gpointer self)
{
#line 111 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	__lambda4_ ((Icon*) self, src);
#line 218 "Icon.c"
}

void
icon_animate_attention (Icon* self,
                        BudgiePanelPosition* position)
{
	gint _tmp0_;
	BudgieAnimation* attention_animation = NULL;
	BudgieAnimation* _tmp1_;
	BudgieAnimation* _tmp2_;
	BudgieAnimation* _tmp3_;
	BudgieAnimation* _tmp4_;
	BudgieAnimation* _tmp24_;
#line 67 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_return_if_fail (self != NULL);
#line 68 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	if (position != NULL) {
#line 69 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		self->priv->panel_position = *position;
#line 238 "Icon.c"
	}
#line 72 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	if (self->priv->attention_cycle_counter == 6) {
#line 73 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		self->priv->attention_amount = (gdouble) 0;
#line 74 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		self->priv->attention_cycle_counter = 0;
#line 75 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		return;
#line 248 "Icon.c"
	}
#line 78 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp0_ = self->priv->attention_cycle_counter;
#line 78 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	self->priv->attention_cycle_counter = _tmp0_ + 1;
#line 80 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp1_ = budgie_animation_new ();
#line 80 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	attention_animation = _tmp1_;
#line 81 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp2_ = attention_animation;
#line 81 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp2_->widget = (GtkWidget*) self;
#line 82 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp3_ = attention_animation;
#line 82 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp3_->length = 50 * BUDGIE_MSECOND;
#line 83 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp4_ = attention_animation;
#line 83 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp4_->tween = _budgie_sine_ease_in_budgie_tween_func;
#line 83 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp4_->tween_target = NULL;
#line 85 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	if ((self->priv->attention_cycle_counter % 2) == 0) {
#line 274 "Icon.c"
		BudgieAnimation* _tmp5_;
		gchar* _tmp6_;
		GValue _tmp7_ = {0};
		GValue _tmp8_ = {0};
		BudgiePropChange _tmp9_ = {0};
		BudgiePropChange* _tmp10_;
#line 86 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		_tmp5_ = attention_animation;
#line 86 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		_tmp6_ = g_strdup ("attention");
#line 86 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		g_value_init (&_tmp7_, G_TYPE_DOUBLE);
#line 86 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		g_value_set_double (&_tmp7_, -5.0);
#line 86 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		g_value_init (&_tmp8_, G_TYPE_DOUBLE);
#line 86 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		g_value_set_double (&_tmp8_, 5.0);
#line 86 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		memset (&_tmp9_, 0, sizeof (BudgiePropChange));
#line 86 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		_g_free0 (_tmp9_.property);
#line 86 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		_tmp9_.property = _tmp6_;
#line 86 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		G_IS_VALUE (&_tmp9_.old) ? (g_value_unset (&_tmp9_.old), NULL) : NULL;
#line 86 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		_tmp9_.old = _tmp7_;
#line 86 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		G_IS_VALUE (&_tmp9_.new) ? (g_value_unset (&_tmp9_.new), NULL) : NULL;
#line 86 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		_tmp9_.new = _tmp8_;
#line 86 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		_tmp10_ = g_new0 (BudgiePropChange, 1);
#line 86 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		_tmp10_[0] = _tmp9_;
#line 86 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		_tmp5_->changes = (_vala_BudgiePropChange_array_free (_tmp5_->changes, _tmp5_->changes_length1), NULL);
#line 86 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		_tmp5_->changes = _tmp10_;
#line 86 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		_tmp5_->changes_length1 = 1;
#line 317 "Icon.c"
	} else {
#line 93 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		if (self->priv->attention_cycle_counter == 5) {
#line 321 "Icon.c"
			BudgieAnimation* _tmp11_;
			gchar* _tmp12_;
			GValue _tmp13_ = {0};
			GValue _tmp14_ = {0};
			BudgiePropChange _tmp15_ = {0};
			BudgiePropChange* _tmp16_;
#line 94 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			_tmp11_ = attention_animation;
#line 94 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			_tmp12_ = g_strdup ("attention");
#line 94 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			g_value_init (&_tmp13_, G_TYPE_DOUBLE);
#line 94 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			g_value_set_double (&_tmp13_, 5.0);
#line 94 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			g_value_init (&_tmp14_, G_TYPE_DOUBLE);
#line 94 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			g_value_set_double (&_tmp14_, 0.0);
#line 94 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			memset (&_tmp15_, 0, sizeof (BudgiePropChange));
#line 94 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			_g_free0 (_tmp15_.property);
#line 94 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			_tmp15_.property = _tmp12_;
#line 94 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			G_IS_VALUE (&_tmp15_.old) ? (g_value_unset (&_tmp15_.old), NULL) : NULL;
#line 94 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			_tmp15_.old = _tmp13_;
#line 94 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			G_IS_VALUE (&_tmp15_.new) ? (g_value_unset (&_tmp15_.new), NULL) : NULL;
#line 94 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			_tmp15_.new = _tmp14_;
#line 94 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			_tmp16_ = g_new0 (BudgiePropChange, 1);
#line 94 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			_tmp16_[0] = _tmp15_;
#line 94 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			_tmp11_->changes = (_vala_BudgiePropChange_array_free (_tmp11_->changes, _tmp11_->changes_length1), NULL);
#line 94 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			_tmp11_->changes = _tmp16_;
#line 94 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			_tmp11_->changes_length1 = 1;
#line 364 "Icon.c"
		} else {
			gdouble _tmp17_ = 0.0;
			BudgieAnimation* _tmp18_;
			gchar* _tmp19_;
			GValue _tmp20_ = {0};
			GValue _tmp21_ = {0};
			BudgiePropChange _tmp22_ = {0};
			BudgiePropChange* _tmp23_;
#line 105 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			if (self->priv->attention_cycle_counter == 1) {
#line 105 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
				_tmp17_ = 0.0;
#line 377 "Icon.c"
			} else {
#line 105 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
				_tmp17_ = 5.0;
#line 381 "Icon.c"
			}
#line 102 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			_tmp18_ = attention_animation;
#line 102 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			_tmp19_ = g_strdup ("attention");
#line 102 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			g_value_init (&_tmp20_, G_TYPE_DOUBLE);
#line 102 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			g_value_set_double (&_tmp20_, _tmp17_);
#line 102 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			g_value_init (&_tmp21_, G_TYPE_DOUBLE);
#line 102 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			g_value_set_double (&_tmp21_, -5.0);
#line 102 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			memset (&_tmp22_, 0, sizeof (BudgiePropChange));
#line 102 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			_g_free0 (_tmp22_.property);
#line 102 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			_tmp22_.property = _tmp19_;
#line 102 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			G_IS_VALUE (&_tmp22_.old) ? (g_value_unset (&_tmp22_.old), NULL) : NULL;
#line 102 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			_tmp22_.old = _tmp20_;
#line 102 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			G_IS_VALUE (&_tmp22_.new) ? (g_value_unset (&_tmp22_.new), NULL) : NULL;
#line 102 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			_tmp22_.new = _tmp21_;
#line 102 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			_tmp23_ = g_new0 (BudgiePropChange, 1);
#line 102 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			_tmp23_[0] = _tmp22_;
#line 102 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			_tmp18_->changes = (_vala_BudgiePropChange_array_free (_tmp18_->changes, _tmp18_->changes_length1), NULL);
#line 102 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			_tmp18_->changes = _tmp23_;
#line 102 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			_tmp18_->changes_length1 = 1;
#line 419 "Icon.c"
		}
	}
#line 111 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp24_ = attention_animation;
#line 111 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	budgie_animation_start (_tmp24_, ___lambda4__budgie_anim_completion_func, self);
#line 67 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_g_object_unref0 (attention_animation);
#line 428 "Icon.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 116 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 116 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	return _data5_;
#line 438 "Icon.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 116 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 448 "Icon.c"
		Icon* self;
#line 116 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		self = _data5_->self;
#line 116 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		_g_object_unref0 (_data5_->wait_animation1);
#line 116 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		_g_object_unref0 (_data5_->wait_animation);
#line 116 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		_g_object_unref0 (self);
#line 116 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		g_slice_free (Block5Data, _data5_);
#line 460 "Icon.c"
	}
}

static void
__lambda5_ (Icon* self)
{
#line 154 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	icon_set_icon_opacity (self, 0.3);
#line 469 "Icon.c"
}

static void
___lambda5__budgie_anim_completion_func (BudgieAnimation* src,
                                         gpointer self)
{
#line 153 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	__lambda5_ ((Icon*) self);
#line 478 "Icon.c"
}

static void
__lambda7_ (Icon* self,
            BudgieAnimation* a)
{
#line 165 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	icon_set_icon_opacity (self, 1.0);
#line 166 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	icon_animate_wait (self);
#line 489 "Icon.c"
}

static void
___lambda7__budgie_anim_completion_func (BudgieAnimation* src,
                                         gpointer self)
{
#line 164 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	__lambda7_ ((Icon*) self, src);
#line 498 "Icon.c"
}

static gboolean
__lambda6_ (Block5Data* _data5_)
{
	Icon* self;
	BudgieAnimation* _tmp2_;
	gboolean result;
#line 157 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	self = _data5_->self;
#line 158 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	if (!self->waiting) {
#line 511 "Icon.c"
		BudgieAnimation* _tmp0_;
		BudgieAnimation* _tmp1_;
#line 159 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		_tmp0_ = _data5_->wait_animation;
#line 159 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		budgie_animation_stop (_tmp0_);
#line 160 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		_tmp1_ = _data5_->wait_animation1;
#line 160 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		budgie_animation_stop (_tmp1_);
#line 161 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		icon_set_icon_opacity (self, 1.0);
#line 162 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		result = FALSE;
#line 162 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		return result;
#line 528 "Icon.c"
	}
#line 164 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp2_ = _data5_->wait_animation1;
#line 164 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	budgie_animation_start (_tmp2_, ___lambda7__budgie_anim_completion_func, self);
#line 168 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	result = FALSE;
#line 168 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	return result;
#line 538 "Icon.c"
}

static gboolean
___lambda6__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda6_ (self);
#line 157 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	return result;
#line 548 "Icon.c"
}

void
icon_animate_wait (Icon* self)
{
	Block5Data* _data5_;
	gint _tmp0_;
	BudgieAnimation* _tmp1_;
	BudgieAnimation* _tmp2_;
	BudgieAnimation* _tmp3_;
	BudgieAnimation* _tmp4_;
	BudgieAnimation* _tmp5_;
	gchar* _tmp6_;
	GValue _tmp7_ = {0};
	GValue _tmp8_ = {0};
	BudgiePropChange _tmp9_ = {0};
	BudgiePropChange* _tmp10_;
	BudgieAnimation* _tmp11_;
	BudgieAnimation* _tmp12_;
	BudgieAnimation* _tmp13_;
	BudgieAnimation* _tmp14_;
	BudgieAnimation* _tmp15_;
	gchar* _tmp16_;
	GValue _tmp17_ = {0};
	GValue _tmp18_ = {0};
	BudgiePropChange _tmp19_ = {0};
	BudgiePropChange* _tmp20_;
	BudgieAnimation* _tmp21_;
#line 116 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_return_if_fail (self != NULL);
#line 116 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 116 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_data5_->_ref_count_ = 1;
#line 116 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_data5_->self = g_object_ref (self);
#line 117 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	if (!self->waiting) {
#line 118 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		self->priv->wait_cycle_counter = 0;
#line 119 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		block5_data_unref (_data5_);
#line 119 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		_data5_ = NULL;
#line 119 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		return;
#line 595 "Icon.c"
	}
#line 122 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	if (self->priv->wait_cycle_counter == MAX_CYCLES) {
#line 123 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		self->priv->wait_cycle_counter = 0;
#line 124 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		block5_data_unref (_data5_);
#line 124 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		_data5_ = NULL;
#line 124 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		return;
#line 607 "Icon.c"
	}
#line 127 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp0_ = self->priv->wait_cycle_counter;
#line 127 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	self->priv->wait_cycle_counter = _tmp0_ + 1;
#line 129 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp1_ = budgie_animation_new ();
#line 129 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_data5_->wait_animation = _tmp1_;
#line 130 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp2_ = _data5_->wait_animation;
#line 130 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp2_->widget = (GtkWidget*) self;
#line 131 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp3_ = _data5_->wait_animation;
#line 131 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp3_->length = 700 * BUDGIE_MSECOND;
#line 132 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp4_ = _data5_->wait_animation;
#line 132 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp4_->tween = _budgie_sine_ease_in_budgie_tween_func;
#line 132 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp4_->tween_target = NULL;
#line 133 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp5_ = _data5_->wait_animation;
#line 133 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp6_ = g_strdup ("icon_opacity");
#line 133 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_value_init (&_tmp7_, G_TYPE_DOUBLE);
#line 133 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_value_set_double (&_tmp7_, 1.0);
#line 133 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_value_init (&_tmp8_, G_TYPE_DOUBLE);
#line 133 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_value_set_double (&_tmp8_, 0.3);
#line 133 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	memset (&_tmp9_, 0, sizeof (BudgiePropChange));
#line 133 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_g_free0 (_tmp9_.property);
#line 133 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp9_.property = _tmp6_;
#line 133 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	G_IS_VALUE (&_tmp9_.old) ? (g_value_unset (&_tmp9_.old), NULL) : NULL;
#line 133 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp9_.old = _tmp7_;
#line 133 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	G_IS_VALUE (&_tmp9_.new) ? (g_value_unset (&_tmp9_.new), NULL) : NULL;
#line 133 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp9_.new = _tmp8_;
#line 133 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp10_ = g_new0 (BudgiePropChange, 1);
#line 133 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp10_[0] = _tmp9_;
#line 133 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp5_->changes = (_vala_BudgiePropChange_array_free (_tmp5_->changes, _tmp5_->changes_length1), NULL);
#line 133 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp5_->changes = _tmp10_;
#line 133 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp5_->changes_length1 = 1;
#line 141 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp11_ = budgie_animation_new ();
#line 141 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_data5_->wait_animation1 = _tmp11_;
#line 142 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp12_ = _data5_->wait_animation1;
#line 142 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp12_->widget = (GtkWidget*) self;
#line 143 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp13_ = _data5_->wait_animation1;
#line 143 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp13_->length = 700 * BUDGIE_MSECOND;
#line 144 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp14_ = _data5_->wait_animation1;
#line 144 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp14_->tween = _budgie_sine_ease_in_budgie_tween_func;
#line 144 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp14_->tween_target = NULL;
#line 145 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp15_ = _data5_->wait_animation1;
#line 145 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp16_ = g_strdup ("icon_opacity");
#line 145 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_value_init (&_tmp17_, G_TYPE_DOUBLE);
#line 145 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_value_set_double (&_tmp17_, 0.3);
#line 145 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_value_init (&_tmp18_, G_TYPE_DOUBLE);
#line 145 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_value_set_double (&_tmp18_, 1.0);
#line 145 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	memset (&_tmp19_, 0, sizeof (BudgiePropChange));
#line 145 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_g_free0 (_tmp19_.property);
#line 145 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp19_.property = _tmp16_;
#line 145 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	G_IS_VALUE (&_tmp19_.old) ? (g_value_unset (&_tmp19_.old), NULL) : NULL;
#line 145 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp19_.old = _tmp17_;
#line 145 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	G_IS_VALUE (&_tmp19_.new) ? (g_value_unset (&_tmp19_.new), NULL) : NULL;
#line 145 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp19_.new = _tmp18_;
#line 145 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp20_ = g_new0 (BudgiePropChange, 1);
#line 145 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp20_[0] = _tmp19_;
#line 145 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp15_->changes = (_vala_BudgiePropChange_array_free (_tmp15_->changes, _tmp15_->changes_length1), NULL);
#line 145 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp15_->changes = _tmp20_;
#line 145 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp15_->changes_length1 = 1;
#line 153 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp21_ = _data5_->wait_animation;
#line 153 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	budgie_animation_start (_tmp21_, ___lambda5__budgie_anim_completion_func, self);
#line 157 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 700, ___lambda6__gsource_func, block5_data_ref (_data5_), block5_data_unref);
#line 116 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	block5_data_unref (_data5_);
#line 116 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_data5_ = NULL;
#line 731 "Icon.c"
}

static gdouble
_budgie_elastic_ease_out_budgie_tween_func (gdouble factor,
                                            gpointer self)
{
	gdouble result;
	result = budgie_elastic_ease_out (factor);
#line 186 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	return result;
#line 742 "Icon.c"
}

static void
__lambda8_ (Icon* self,
            BudgieAnimation* a)
{
#line 196 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	icon_set_bounce (self, 0.0);
#line 751 "Icon.c"
}

static void
___lambda8__budgie_anim_completion_func (BudgieAnimation* src,
                                         gpointer self)
{
#line 195 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	__lambda8_ ((Icon*) self, src);
#line 760 "Icon.c"
}

void
icon_animate_launch (Icon* self,
                     BudgiePanelPosition position)
{
	gdouble old_value = 0.0;
	gboolean _tmp0_ = FALSE;
	BudgieAnimation* launch_animation = NULL;
	BudgieAnimation* _tmp5_;
	gchar* _tmp6_;
	GValue _tmp7_ = {0};
	gdouble _tmp8_;
	gdouble _tmp9_;
	GValue _tmp10_ = {0};
	BudgiePropChange _tmp11_ = {0};
	BudgiePropChange* _tmp12_;
#line 172 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_return_if_fail (self != NULL);
#line 173 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	self->priv->panel_position = position;
#line 177 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	if (position == BUDGIE_PANEL_POSITION_TOP) {
#line 177 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		_tmp0_ = TRUE;
#line 786 "Icon.c"
	} else {
#line 177 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		_tmp0_ = position == BUDGIE_PANEL_POSITION_BOTTOM;
#line 790 "Icon.c"
	}
#line 177 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	if (_tmp0_) {
#line 794 "Icon.c"
		gint _tmp1_;
		gint _tmp2_;
#line 178 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		_tmp1_ = gtk_image_get_pixel_size ((GtkImage*) self);
#line 178 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		_tmp2_ = _tmp1_;
#line 178 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		old_value = (gdouble) ((self->priv->widget_height - _tmp2_) / 2);
#line 803 "Icon.c"
	} else {
		gint _tmp3_;
		gint _tmp4_;
#line 180 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		_tmp3_ = gtk_image_get_pixel_size ((GtkImage*) self);
#line 180 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		_tmp4_ = _tmp3_;
#line 180 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		old_value = (gdouble) ((self->priv->widget_width - _tmp4_) / 2);
#line 813 "Icon.c"
	}
#line 183 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp5_ = budgie_animation_new ();
#line 183 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	launch_animation = _tmp5_;
#line 184 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	launch_animation->widget = (GtkWidget*) self;
#line 185 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	launch_animation->length = 1200 * BUDGIE_MSECOND;
#line 186 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	launch_animation->tween = _budgie_elastic_ease_out_budgie_tween_func;
#line 186 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	launch_animation->tween_target = NULL;
#line 187 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp6_ = g_strdup ("bounce");
#line 187 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_value_init (&_tmp7_, G_TYPE_DOUBLE);
#line 187 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_value_set_double (&_tmp7_, old_value);
#line 187 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp8_ = icon_get_bounce (self);
#line 187 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp9_ = _tmp8_;
#line 187 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_value_init (&_tmp10_, G_TYPE_DOUBLE);
#line 187 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_value_set_double (&_tmp10_, _tmp9_);
#line 187 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	memset (&_tmp11_, 0, sizeof (BudgiePropChange));
#line 187 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_g_free0 (_tmp11_.property);
#line 187 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp11_.property = _tmp6_;
#line 187 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	G_IS_VALUE (&_tmp11_.old) ? (g_value_unset (&_tmp11_.old), NULL) : NULL;
#line 187 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp11_.old = _tmp7_;
#line 187 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	G_IS_VALUE (&_tmp11_.new) ? (g_value_unset (&_tmp11_.new), NULL) : NULL;
#line 187 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp11_.new = _tmp10_;
#line 187 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp12_ = g_new0 (BudgiePropChange, 1);
#line 187 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp12_[0] = _tmp11_;
#line 187 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	launch_animation->changes = (_vala_BudgiePropChange_array_free (launch_animation->changes, launch_animation->changes_length1), NULL);
#line 187 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	launch_animation->changes = _tmp12_;
#line 187 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	launch_animation->changes_length1 = 1;
#line 195 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	budgie_animation_start (launch_animation, ___lambda8__budgie_anim_completion_func, self);
#line 172 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_g_object_unref0 (launch_animation);
#line 869 "Icon.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 205 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	return self ? g_object_ref (self) : NULL;
#line 877 "Icon.c"
}

static gboolean
icon_real_draw (GtkWidget* base,
                cairo_t* cr)
{
	Icon * self;
	GtkAllocation alloc = {0};
	GtkAllocation _tmp0_ = {0};
	GdkWindow* window = NULL;
	GdkWindow* _tmp1_;
	GdkWindow* _tmp2_;
	GdkWindow* _tmp3_;
	cairo_surface_t* buffer = NULL;
	GdkWindow* _tmp4_;
	GtkAllocation _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	GtkAllocation _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	cairo_surface_t* _tmp13_;
	cairo_t* cr2 = NULL;
	cairo_surface_t* _tmp14_;
	cairo_t* _tmp15_;
	cairo_t* _tmp16_;
	gint x = 0;
	gint y = 0;
	cairo_surface_t* _tmp17_;
	gboolean result;
#line 200 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	self = (Icon*) base;
#line 200 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 202 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp0_);
#line 202 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	alloc = _tmp0_;
#line 205 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp1_ = gtk_widget_get_window ((GtkWidget*) self);
#line 205 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 205 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	window = _tmp2_;
#line 206 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp3_ = window;
#line 206 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	if (_tmp3_ == NULL) {
#line 207 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		result = GDK_EVENT_STOP;
#line 207 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		_g_object_unref0 (window);
#line 207 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		return result;
#line 934 "Icon.c"
	}
#line 210 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp4_ = window;
#line 210 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp5_ = alloc;
#line 210 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp6_ = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 210 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp7_ = _tmp6_;
#line 210 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp8_ = alloc;
#line 210 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp9_ = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 210 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp10_ = _tmp9_;
#line 210 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp11_ = gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 210 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp12_ = _tmp11_;
#line 210 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp13_ = gdk_window_create_similar_image_surface (_tmp4_, CAIRO_FORMAT_ARGB32, _tmp5_.width * _tmp7_, _tmp8_.height * _tmp10_, _tmp12_);
#line 210 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	buffer = _tmp13_;
#line 214 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp14_ = buffer;
#line 214 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp15_ = cairo_create (_tmp14_);
#line 214 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	cr2 = _tmp15_;
#line 215 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp16_ = cr2;
#line 215 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	GTK_WIDGET_CLASS (icon_parent_class)->draw ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_image_get_type (), GtkImage), _tmp16_);
#line 218 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	x = 0;
#line 219 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	y = 0;
#line 222 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	if (self->priv->panel_position == BUDGIE_PANEL_POSITION_LEFT) {
#line 223 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		x += (gint) self->priv->bounce_amount;
#line 224 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		y += (gint) self->priv->attention_amount;
#line 978 "Icon.c"
	} else {
#line 225 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		if (self->priv->panel_position == BUDGIE_PANEL_POSITION_RIGHT) {
#line 226 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			x -= (gint) self->priv->bounce_amount;
#line 227 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			y += (gint) self->priv->attention_amount;
#line 986 "Icon.c"
		} else {
#line 228 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
			if (self->priv->panel_position == BUDGIE_PANEL_POSITION_TOP) {
#line 229 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
				y += (gint) self->priv->bounce_amount;
#line 230 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
				x += (gint) self->priv->attention_amount;
#line 994 "Icon.c"
			} else {
#line 232 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
				y -= (gint) self->priv->bounce_amount;
#line 233 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
				x += (gint) self->priv->attention_amount;
#line 1000 "Icon.c"
			}
		}
	}
#line 237 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp17_ = buffer;
#line 237 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	cairo_set_source_surface (cr, _tmp17_, (gdouble) x, (gdouble) y);
#line 238 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	cairo_paint (cr);
#line 240 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	result = TRUE;
#line 240 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_cairo_destroy0 (cr2);
#line 240 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_cairo_surface_destroy0 (buffer);
#line 240 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_g_object_unref0 (window);
#line 240 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	return result;
#line 1020 "Icon.c"
}

gdouble
icon_get_bounce (Icon* self)
{
	gdouble result;
#line 30 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 31 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	result = self->priv->bounce_amount;
#line 31 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	return result;
#line 1033 "Icon.c"
}

void
icon_set_bounce (Icon* self,
                 gdouble value)
{
#line 26 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	self->priv->bounce_amount = value;
#line 28 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 26 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_object_notify_by_pspec ((GObject *) self, icon_properties[ICON_BOUNCE_PROPERTY]);
#line 1048 "Icon.c"
}

gdouble
icon_get_attention (Icon* self)
{
	gdouble result;
#line 40 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 41 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	result = self->priv->attention_amount;
#line 41 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	return result;
#line 1061 "Icon.c"
}

void
icon_set_attention (Icon* self,
                    gdouble value)
{
#line 36 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	self->priv->attention_amount = value;
#line 38 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 36 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_object_notify_by_pspec ((GObject *) self, icon_properties[ICON_ATTENTION_PROPERTY]);
#line 1076 "Icon.c"
}

gdouble
icon_get_icon_opacity (Icon* self)
{
	gdouble result;
	gdouble _tmp0_;
	gdouble _tmp1_;
#line 53 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 54 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp0_ = gtk_widget_get_opacity ((GtkWidget*) self);
#line 54 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	_tmp1_ = _tmp0_;
#line 54 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	result = _tmp1_;
#line 54 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	return result;
#line 1095 "Icon.c"
}

void
icon_set_icon_opacity (Icon* self,
                       gdouble value)
{
#line 46 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_return_if_fail (self != NULL);
#line 47 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	if (self->waiting) {
#line 48 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		gtk_widget_set_opacity ((GtkWidget*) self, value);
#line 1108 "Icon.c"
	} else {
#line 50 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		gtk_widget_set_opacity ((GtkWidget*) self, 1.0);
#line 1112 "Icon.c"
	}
#line 46 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_object_notify_by_pspec ((GObject *) self, icon_properties[ICON_ICON_OPACITY_PROPERTY]);
#line 1116 "Icon.c"
}

static void
icon_class_init (IconClass * klass,
                 gpointer klass_data)
{
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	icon_parent_class = g_type_class_peek_parent (klass);
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_type_class_adjust_private_offset (klass, &Icon_private_offset);
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) icon_real_draw;
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_icon_get_property;
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_icon_set_property;
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	G_OBJECT_CLASS (klass)->finalize = icon_finalize;
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ICON_BOUNCE_PROPERTY, icon_properties[ICON_BOUNCE_PROPERTY] = g_param_spec_double ("bounce", "bounce", "bounce", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ICON_ATTENTION_PROPERTY, icon_properties[ICON_ATTENTION_PROPERTY] = g_param_spec_double ("attention", "attention", "attention", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ICON_ICON_OPACITY_PROPERTY, icon_properties[ICON_ICON_OPACITY_PROPERTY] = g_param_spec_double ("icon-opacity", "icon-opacity", "icon-opacity", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1141 "Icon.c"
}

static void
icon_instance_init (Icon * self,
                    gpointer klass)
{
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	self->priv = icon_get_instance_private (self);
#line 15 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	self->priv->widget_width = 36;
#line 16 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	self->priv->widget_height = 30;
#line 17 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	self->priv->panel_position = BUDGIE_PANEL_POSITION_BOTTOM;
#line 18 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	self->waiting = FALSE;
#line 19 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	self->priv->wait_cycle_counter = 0;
#line 20 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	self->priv->attention_cycle_counter = 0;
#line 22 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	self->priv->bounce_amount = 0.0;
#line 23 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	self->priv->attention_amount = 0.0;
#line 1166 "Icon.c"
}

static void
icon_finalize (GObject * obj)
{
	Icon * self;
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ICON, Icon);
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	G_OBJECT_CLASS (icon_parent_class)->finalize (obj);
#line 1177 "Icon.c"
}

GType
icon_get_type (void)
{
	return icon_type_id;
}

GType
icon_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (IconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) icon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Icon), 0, (GInstanceInitFunc) icon_instance_init, NULL };
	icon_type_id = g_type_module_register_type (module, gtk_image_get_type (), "Icon", &g_define_type_info, 0);
	Icon_private_offset = sizeof (IconPrivate);
	return icon_type_id;
}

static void
_vala_icon_get_property (GObject * object,
                         guint property_id,
                         GValue * value,
                         GParamSpec * pspec)
{
	Icon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ICON, Icon);
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	switch (property_id) {
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		case ICON_BOUNCE_PROPERTY:
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		g_value_set_double (value, icon_get_bounce (self));
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		break;
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		case ICON_ATTENTION_PROPERTY:
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		g_value_set_double (value, icon_get_attention (self));
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		break;
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		case ICON_ICON_OPACITY_PROPERTY:
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		g_value_set_double (value, icon_get_icon_opacity (self));
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		break;
#line 1223 "Icon.c"
		default:
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		break;
#line 1229 "Icon.c"
	}
}

static void
_vala_icon_set_property (GObject * object,
                         guint property_id,
                         const GValue * value,
                         GParamSpec * pspec)
{
	Icon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ICON, Icon);
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
	switch (property_id) {
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		case ICON_BOUNCE_PROPERTY:
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		icon_set_bounce (self, g_value_get_double (value));
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		break;
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		case ICON_ATTENTION_PROPERTY:
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		icon_set_attention (self, g_value_get_double (value));
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		break;
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		case ICON_ICON_OPACITY_PROPERTY:
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		icon_set_icon_opacity (self, g_value_get_double (value));
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		break;
#line 1261 "Icon.c"
		default:
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "../src/panel/applets/icon-tasklist/widgets/Icon.vala"
		break;
#line 1267 "Icon.c"
	}
}

