/* IconButton.c generated by valac 0.56.17, the Vala compiler
 * generated from IconButton.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include "icontasklistapplet.h"
#include "budgie-private.h"
#include "plugin.h"
#include <glib.h>
#include "windowing.h"
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>
#include <libxfce4windowing/libxfce4windowing.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gio/gio.h>

#define ICON_BUTTON_DEFAULT_OPACITY 0.1
#define ICON_BUTTON_INDICATOR_PADDING 2
#define ICON_BUTTON_INDICATOR_SIZE 2
#define ICON_BUTTON_INDICATOR_SPACING 1
#define ICON_BUTTON_INACTIVE_INDICATOR_SPACING 4
#define ICON_BUTTON_DEFAULT_ICON_SIZE 32
#define ICON_BUTTON_TARGET_ICON_PADDING 18
#define ICON_BUTTON_TARGET_ICON_SCALE (2.0 / 3.0)
#define ICON_BUTTON_FORMULA_SWAP_POINT (ICON_BUTTON_TARGET_ICON_PADDING * 3)
#define ICON_BUTTON_SCROLL_TIMEOUT ((gint64) 300000)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	ICON_BUTTON_0_PROPERTY,
	ICON_BUTTON_APP_PROPERTY,
	ICON_BUTTON_POPOVER_MANAGER_PROPERTY,
	ICON_BUTTON_PINNED_PROPERTY,
	ICON_BUTTON_HAS_ACTIVE_WINDOW_PROPERTY,
	ICON_BUTTON_NUM_PROPERTIES
};
static GParamSpec* icon_button_properties[ICON_BUTTON_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _IconButtonPrivate {
	BudgieApplication* _app;
	BudgiePopoverManager* _popover_manager;
	gboolean _pinned;
	gboolean _has_active_window;
	BudgieWindowingWindowGroup* window_group;
	Icon* icon;
	ButtonPopover* popover;
	GtkAllocation definite_allocation;
	gint target_icon_size;
	gint panel_size;
	BudgiePanelPosition panel_position;
	GtkOrientation orientation;
	gint64 last_scroll_time;
	gboolean urgent;
};

static gint IconButton_private_offset;
static gpointer icon_button_parent_class = NULL;
static GType icon_button_type_id = 0;

static void icon_button_on_size_allocate (IconButton* self,
                                   GtkAllocation* allocation);
static gboolean _cairo_rectangle_int_equal (const cairo_rectangle_int_t * s1,
                                     const cairo_rectangle_int_t * s2);
static void icon_button_set_window_button_geometry (IconButton* self,
                                             XfwWindow* window,
                                             GError** error);
static gboolean icon_button_real_scroll_event (GtkWidget* base,
                                        GdkEventScroll* event);
static gboolean icon_button_real_draw (GtkWidget* base,
                                cairo_t* ctx);
static void icon_button_real_get_preferred_width (GtkWidget* base,
                                           gint* min,
                                           gint* nat);
static void icon_button_real_get_preferred_height (GtkWidget* base,
                                            gint* min,
                                            gint* nat);
static void icon_button_set_has_active_window (IconButton* self,
                                        gboolean value);
static void __lambda22_ (IconButton* self,
                  XfwWindow* window);
static void ___lambda22__budgie_windowing_window_group_active_window_changed (BudgieWindowingWindowGroup* _sender,
                                                                       XfwWindow* window,
                                                                       gpointer self);
static void __lambda23_ (IconButton* self);
static void ___lambda23__budgie_windowing_window_group_app_icon_changed (BudgieWindowingWindowGroup* _sender,
                                                                  gpointer self);
static void __lambda24_ (IconButton* self,
                  XfwWindow* window);
static void __lambda25_ (IconButton* self,
                  XfwWindowState changed_mask,
                  XfwWindowState new_state);
static void ___lambda25__libxfce4windowing_window_state_changed (XfwWindow* _sender,
                                                          XfwWindowState changed_mask,
                                                          XfwWindowState new_state,
                                                          gpointer self);
static void ___lambda24__budgie_windowing_window_group_window_added (BudgieWindowingWindowGroup* _sender,
                                                              XfwWindow* window,
                                                              gpointer self);
static void __lambda26_ (IconButton* self,
                  XfwWindow* window);
static void ___lambda26__budgie_windowing_window_group_window_removed (BudgieWindowingWindowGroup* _sender,
                                                                XfwWindow* window,
                                                                gpointer self);
static GObject * icon_button_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static void _icon_button____lambda27_ (IconButton* self);
static void __icon_button____lambda27__budgie_application_launch_failed (BudgieApplication* _sender,
                                                                  const gchar* startup_notify_id,
                                                                  gpointer self);
static void _icon_button_on_size_allocate_gtk_widget_size_allocate (GtkWidget* _sender,
                                                             GtkAllocation* allocation,
                                                             gpointer self);
static void icon_button_finalize (GObject * obj);
static void _vala_icon_button_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_icon_button_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

static inline gpointer
icon_button_get_instance_private (IconButton* self)
{
	return G_STRUCT_MEMBER_P (self, IconButton_private_offset);
}

IconButton*
icon_button_construct (GType object_type,
                       BudgiePopoverManager* popover_manager,
                       BudgieApplication* app)
{
	IconButton * self = NULL;
#line 47 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_val_if_fail (popover_manager != NULL, NULL);
#line 47 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_val_if_fail (app != NULL, NULL);
#line 48 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	self = (IconButton*) g_object_new (object_type, "app", app, "popover-manager", popover_manager, "relief", GTK_RELIEF_NONE, NULL);
#line 47 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	return self;
#line 169 "IconButton.c"
}

IconButton*
icon_button_new (BudgiePopoverManager* popover_manager,
                 BudgieApplication* app)
{
#line 47 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	return icon_button_construct (TYPE_ICON_BUTTON, popover_manager, app);
#line 178 "IconButton.c"
}

IconButton*
icon_button_construct_with_group (GType object_type,
                                  BudgieWindowingWindowGroup* window_group,
                                  BudgiePopoverManager* popover_manager,
                                  BudgieApplication* app)
{
	IconButton * self = NULL;
#line 54 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_val_if_fail (window_group != NULL, NULL);
#line 54 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_val_if_fail (popover_manager != NULL, NULL);
#line 55 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	self = (IconButton*) g_object_new (object_type, "app", app, "popover-manager", popover_manager, "relief", GTK_RELIEF_NONE, NULL);
#line 61 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	icon_button_set_window_group (self, window_group);
#line 54 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	return self;
#line 198 "IconButton.c"
}

IconButton*
icon_button_new_with_group (BudgieWindowingWindowGroup* window_group,
                            BudgiePopoverManager* popover_manager,
                            BudgieApplication* app)
{
#line 54 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	return icon_button_construct_with_group (TYPE_ICON_BUTTON, window_group, popover_manager, app);
#line 208 "IconButton.c"
}

static gboolean
_cairo_rectangle_int_equal (const cairo_rectangle_int_t * s1,
                            const cairo_rectangle_int_t * s2)
{
#line 103 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (s1 == s2) {
#line 103 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		return TRUE;
#line 219 "IconButton.c"
	}
#line 103 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (s1 == NULL) {
#line 103 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		return FALSE;
#line 225 "IconButton.c"
	}
#line 103 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (s2 == NULL) {
#line 103 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		return FALSE;
#line 231 "IconButton.c"
	}
#line 103 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (s1->x != s2->x) {
#line 103 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		return FALSE;
#line 237 "IconButton.c"
	}
#line 103 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (s1->y != s2->y) {
#line 103 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		return FALSE;
#line 243 "IconButton.c"
	}
#line 103 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (s1->width != s2->width) {
#line 103 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		return FALSE;
#line 249 "IconButton.c"
	}
#line 103 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (s1->height != s2->height) {
#line 103 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		return FALSE;
#line 255 "IconButton.c"
	}
#line 103 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	return TRUE;
#line 259 "IconButton.c"
}

static void
icon_button_on_size_allocate (IconButton* self,
                              GtkAllocation* allocation)
{
	GtkAllocation _tmp0_;
	GtkAllocation _tmp1_;
	GtkAllocation _tmp4_;
	GtkAllocation _tmp5_;
	gboolean _tmp6_ = FALSE;
	BudgieWindowingWindowGroup* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 102 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 102 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_if_fail (allocation != NULL);
#line 103 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp0_ = self->priv->definite_allocation;
#line 103 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp1_ = *allocation;
#line 103 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (_cairo_rectangle_int_equal (&_tmp0_, &_tmp1_) != TRUE) {
#line 283 "IconButton.c"
		gint max = 0;
		GtkAllocation _tmp2_;
		GtkAllocation _tmp3_;
#line 104 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp2_ = *allocation;
#line 104 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp3_ = *allocation;
#line 104 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		max = (gint) fmin ((gdouble) _tmp2_.width, (gdouble) _tmp3_.height);
#line 106 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		if (max > ICON_BUTTON_FORMULA_SWAP_POINT) {
#line 107 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			self->priv->target_icon_size = max - ICON_BUTTON_TARGET_ICON_PADDING;
#line 297 "IconButton.c"
		} else {
#line 109 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			self->priv->target_icon_size = (gint) round (ICON_BUTTON_TARGET_ICON_SCALE * max);
#line 301 "IconButton.c"
		}
#line 112 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		icon_button_update_icon (self);
#line 305 "IconButton.c"
	}
#line 115 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp4_ = *allocation;
#line 115 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	self->priv->definite_allocation = _tmp4_;
#line 116 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp5_ = self->priv->definite_allocation;
#line 116 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	GTK_WIDGET_CLASS (icon_button_parent_class)->size_allocate ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_toggle_button_get_type (), GtkToggleButton), &_tmp5_);
#line 119 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp7_ = self->priv->window_group;
#line 119 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (_tmp7_ != NULL) {
#line 319 "IconButton.c"
		BudgieWindowingWindowGroup* _tmp8_;
#line 119 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp8_ = self->priv->window_group;
#line 119 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp6_ = budgie_windowing_window_group_has_windows (_tmp8_);
#line 325 "IconButton.c"
	} else {
#line 119 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp6_ = FALSE;
#line 329 "IconButton.c"
	}
#line 119 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (_tmp6_) {
#line 333 "IconButton.c"
		BudgieWindowingWindowGroup* _tmp9_;
		GList* _tmp10_;
#line 120 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp9_ = self->priv->window_group;
#line 120 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp10_ = budgie_windowing_window_group_get_windows (_tmp9_);
#line 340 "IconButton.c"
		{
			GList* win_collection = NULL;
			GList* win_it = NULL;
#line 120 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			win_collection = _tmp10_;
#line 120 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			for (win_it = win_collection; win_it != NULL; win_it = win_it->next) {
#line 348 "IconButton.c"
				XfwWindow* win = NULL;
#line 120 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				win = (XfwWindow*) win_it->data;
#line 352 "IconButton.c"
				{
					{
						XfwWindow* _tmp11_;
#line 122 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						_tmp11_ = win;
#line 122 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						icon_button_set_window_button_geometry (self, _tmp11_, &_inner_error0_);
#line 122 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 362 "IconButton.c"
							goto __catch0_g_error;
						}
					}
					goto __finally0;
					__catch0_g_error:
					{
						GError* e = NULL;
						XfwWindow* _tmp12_;
						const gchar* _tmp13_;
						GError* _tmp14_;
						const gchar* _tmp15_;
#line 121 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						e = _inner_error0_;
#line 121 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						_inner_error0_ = NULL;
#line 124 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						_tmp12_ = win;
#line 124 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						_tmp13_ = xfw_window_get_name (_tmp12_);
#line 124 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						_tmp14_ = e;
#line 124 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						_tmp15_ = _tmp14_->message;
#line 124 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						g_warning ("IconButton.vala:124: Unable to set button geometry for window %s: %s", _tmp13_, _tmp15_);
#line 121 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						_g_error_free0 (e);
#line 390 "IconButton.c"
					}
					__finally0:
#line 121 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 121 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						(win_collection == NULL) ? NULL : (win_collection = (g_list_free (win_collection), NULL));
#line 121 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 121 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						g_clear_error (&_inner_error0_);
#line 121 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						return;
#line 403 "IconButton.c"
					}
				}
			}
#line 120 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			(win_collection == NULL) ? NULL : (win_collection = (g_list_free (win_collection), NULL));
#line 409 "IconButton.c"
		}
	}
}

/**
 * Sets the button geometry for a window.
 *
 * What this means is that when a window is minimized, it will minimize to
 * the icon button's location on the screen.
 *
 * Throws: if the button geometry could not be set
 */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 140 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	return self ? g_object_ref (self) : NULL;
#line 427 "IconButton.c"
}

static void
icon_button_set_window_button_geometry (IconButton* self,
                                        XfwWindow* window,
                                        GError** error)
{
	gint x = 0;
	gint y = 0;
	GtkWidget* toplevel = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GtkWidget* _tmp3_;
	GtkWidget* _tmp6_;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	GtkWidget* _tmp9_;
	GdkWindow* _tmp10_;
	gint _tmp11_ = 0;
	gint _tmp12_ = 0;
	GdkRectangle rect = {0};
	GtkAllocation _tmp13_;
	GtkAllocation _tmp14_;
	GdkRectangle _tmp15_ = {0};
	GtkWidget* _tmp16_;
	GdkWindow* _tmp17_;
	GdkRectangle _tmp18_;
	GError* _inner_error0_ = NULL;
#line 138 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 138 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_if_fail (window != NULL);
#line 140 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp0_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 140 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 140 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	toplevel = _tmp1_;
#line 142 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp3_ = toplevel;
#line 142 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (_tmp3_ == NULL) {
#line 142 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp2_ = TRUE;
#line 473 "IconButton.c"
	} else {
		GtkWidget* _tmp4_;
		GdkWindow* _tmp5_;
#line 142 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp4_ = toplevel;
#line 142 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp5_ = gtk_widget_get_window (_tmp4_);
#line 142 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp2_ = _tmp5_ == NULL;
#line 483 "IconButton.c"
	}
#line 142 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (_tmp2_) {
#line 142 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_g_object_unref0 (toplevel);
#line 142 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		return;
#line 491 "IconButton.c"
	}
#line 144 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp6_ = toplevel;
#line 144 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	gtk_widget_translate_coordinates ((GtkWidget*) self, _tmp6_, 0, 0, &_tmp7_, &_tmp8_);
#line 144 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	x = _tmp7_;
#line 144 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	y = _tmp8_;
#line 145 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp9_ = toplevel;
#line 145 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp10_ = gtk_widget_get_window (_tmp9_);
#line 145 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	gdk_window_get_root_coords (_tmp10_, x, y, &_tmp11_, &_tmp12_);
#line 145 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	x = _tmp11_;
#line 145 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	y = _tmp12_;
#line 147 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp13_ = self->priv->definite_allocation;
#line 147 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp14_ = self->priv->definite_allocation;
#line 147 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp15_.x = x;
#line 147 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp15_.y = y;
#line 147 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp15_.width = _tmp13_.width;
#line 147 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp15_.height = _tmp14_.height;
#line 147 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	rect = _tmp15_;
#line 154 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp16_ = toplevel;
#line 154 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp17_ = gtk_widget_get_window (_tmp16_);
#line 154 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp18_ = rect;
#line 154 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	xfw_window_set_button_geometry (window, _tmp17_, &_tmp18_, &_inner_error0_);
#line 154 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 154 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		g_propagate_error (error, _inner_error0_);
#line 154 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_g_object_unref0 (toplevel);
#line 154 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		return;
#line 541 "IconButton.c"
	}
#line 138 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_g_object_unref0 (toplevel);
#line 545 "IconButton.c"
}

static gboolean
icon_button_real_scroll_event (GtkWidget* base,
                               GdkEventScroll* event)
{
	IconButton * self;
	BudgieWindowingWindowGroup* _tmp0_;
	XfwWindow* target_window = NULL;
	BudgieWindowingWindowGroup* _tmp1_ = NULL;
	BudgieWindowingWindowGroup* _tmp2_;
	XfwWindow* _tmp3_ = NULL;
	XfwWindow* active_window = NULL;
	XfwWindow* _tmp5_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 157 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	self = (IconButton*) base;
#line 157 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 158 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if ((g_get_monotonic_time () - self->priv->last_scroll_time) < ICON_BUTTON_SCROLL_TIMEOUT) {
#line 159 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		result = GDK_EVENT_STOP;
#line 159 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		return result;
#line 572 "IconButton.c"
	}
#line 163 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp0_ = self->priv->window_group;
#line 163 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (_tmp0_ == NULL) {
#line 163 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		result = GDK_EVENT_STOP;
#line 163 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		return result;
#line 582 "IconButton.c"
	}
#line 165 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	target_window = NULL;
#line 168 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp2_ = self->priv->window_group;
#line 168 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp1_ = _tmp2_;
#line 168 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp3_ = NULL;
#line 168 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (_tmp1_ != NULL) {
#line 594 "IconButton.c"
		XfwWindow* _tmp4_;
#line 168 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp4_ = budgie_windowing_window_group_get_active_window (_tmp1_);
#line 168 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp3_ = _tmp4_;
#line 600 "IconButton.c"
	}
#line 168 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	active_window = _tmp3_;
#line 171 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp5_ = active_window;
#line 171 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (_tmp5_ == NULL) {
#line 608 "IconButton.c"
		BudgieWindowingWindowGroup* _tmp6_;
		XfwWindow* _tmp7_;
#line 172 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp6_ = self->priv->window_group;
#line 172 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp7_ = budgie_windowing_window_group_get_last_active_window (_tmp6_);
#line 172 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		active_window = _tmp7_;
#line 617 "IconButton.c"
	}
#line 175 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	switch (event->direction) {
#line 175 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		case GDK_SCROLL_UP:
#line 623 "IconButton.c"
		{
			BudgieWindowingWindowGroup* _tmp8_;
			XfwWindow* _tmp9_;
			XfwWindow* _tmp10_;
#line 178 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp8_ = self->priv->window_group;
#line 178 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp9_ = active_window;
#line 178 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp10_ = budgie_windowing_window_group_get_next_window (_tmp8_, _tmp9_, FALSE);
#line 178 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			target_window = _tmp10_;
#line 636 "IconButton.c"
			{
				XfwWindow* _tmp11_;
#line 182 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp11_ = target_window;
#line 182 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				xfw_window_activate (_tmp11_, (guint64) event->time, &_inner_error0_);
#line 182 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 645 "IconButton.c"
					goto __catch0_g_error;
				}
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* e = NULL;
				XfwWindow* _tmp12_;
				const gchar* _tmp13_;
				GError* _tmp14_;
				const gchar* _tmp15_;
#line 181 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				e = _inner_error0_;
#line 181 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_inner_error0_ = NULL;
#line 184 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp12_ = target_window;
#line 184 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp13_ = xfw_window_get_name (_tmp12_);
#line 184 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp14_ = e;
#line 184 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp15_ = _tmp14_->message;
#line 184 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				g_warning ("IconButton.vala:184: Error activating and unminimizing window '%s': %s", _tmp13_, _tmp15_);
#line 181 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_g_error_free0 (e);
#line 673 "IconButton.c"
			}
			__finally0:
#line 181 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 678 "IconButton.c"
				gboolean _tmp16_ = FALSE;
#line 181 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 181 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				g_clear_error (&_inner_error0_);
#line 181 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				return _tmp16_;
#line 686 "IconButton.c"
			}
#line 187 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			break;
#line 690 "IconButton.c"
		}
#line 175 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		case GDK_SCROLL_DOWN:
#line 694 "IconButton.c"
		{
			XfwWindow* _tmp17_;
			XfwWindow* _tmp18_;
			XfwWindow* _tmp19_;
#line 190 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp17_ = active_window;
#line 190 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			target_window = _tmp17_;
#line 192 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp18_ = target_window;
#line 192 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			if (_tmp18_ == NULL) {
#line 193 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				break;
#line 709 "IconButton.c"
			}
#line 197 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp19_ = target_window;
#line 197 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			if (xfw_window_is_minimized (_tmp19_)) {
#line 198 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				break;
#line 717 "IconButton.c"
			}
			{
				XfwWindow* _tmp20_;
#line 203 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp20_ = target_window;
#line 203 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				xfw_window_set_minimized (_tmp20_, TRUE, &_inner_error0_);
#line 203 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 727 "IconButton.c"
					goto __catch1_g_error;
				}
			}
			goto __finally1;
			__catch1_g_error:
			{
				GError* e = NULL;
				XfwWindow* _tmp21_;
				const gchar* _tmp22_;
				GError* _tmp23_;
				const gchar* _tmp24_;
#line 202 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				e = _inner_error0_;
#line 202 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_inner_error0_ = NULL;
#line 205 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp21_ = target_window;
#line 205 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp22_ = xfw_window_get_name (_tmp21_);
#line 205 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp23_ = e;
#line 205 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp24_ = _tmp23_->message;
#line 205 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				g_warning ("IconButton.vala:205: Error minimizing window '%s': %s", _tmp22_, _tmp24_);
#line 202 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_g_error_free0 (e);
#line 755 "IconButton.c"
			}
			__finally1:
#line 202 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 760 "IconButton.c"
				gboolean _tmp25_ = FALSE;
#line 202 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 202 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				g_clear_error (&_inner_error0_);
#line 202 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				return _tmp25_;
#line 768 "IconButton.c"
			}
#line 207 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			break;
#line 772 "IconButton.c"
		}
		default:
		{
#line 209 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			break;
#line 778 "IconButton.c"
		}
	}
#line 212 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	self->priv->last_scroll_time = g_get_monotonic_time ();
#line 214 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	result = GDK_EVENT_STOP;
#line 214 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	return result;
#line 787 "IconButton.c"
}

static inline gboolean
vala_g_list_is_empty (GList* self)
{
	gboolean result;
#line 5297 "glib-2.0.vapi"
	result = ((GList*) self) == NULL;
#line 5297 "glib-2.0.vapi"
	return result;
#line 798 "IconButton.c"
}

static gboolean
icon_button_real_draw (GtkWidget* base,
                       cairo_t* ctx)
{
	IconButton * self;
	gint x = 0;
	GtkAllocation _tmp0_;
	gint y = 0;
	GtkAllocation _tmp1_;
	gint width = 0;
	GtkAllocation _tmp2_;
	gint height = 0;
	GtkAllocation _tmp3_;
	GList* windows = NULL;
	gboolean _tmp4_ = FALSE;
	BudgieWindowingWindowGroup* _tmp5_;
	GList* _tmp9_;
	gint count = 0;
	GList* _tmp10_;
	gint spacing = 0;
	gint _tmp11_ = 0;
	gint previous_x = 0;
	gint previous_y = 0;
	gboolean result;
#line 217 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	self = (IconButton*) base;
#line 217 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_val_if_fail (ctx != NULL, FALSE);
#line 218 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp0_ = self->priv->definite_allocation;
#line 218 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	x = _tmp0_.x;
#line 219 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp1_ = self->priv->definite_allocation;
#line 219 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	y = _tmp1_.y;
#line 220 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp2_ = self->priv->definite_allocation;
#line 220 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	width = _tmp2_.width;
#line 221 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp3_ = self->priv->definite_allocation;
#line 221 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	height = _tmp3_.height;
#line 226 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp5_ = self->priv->window_group;
#line 226 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (_tmp5_ != NULL) {
#line 849 "IconButton.c"
		BudgieWindowingWindowGroup* _tmp6_;
#line 226 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp6_ = self->priv->window_group;
#line 226 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp4_ = budgie_windowing_window_group_has_windows (_tmp6_);
#line 855 "IconButton.c"
	} else {
#line 226 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp4_ = FALSE;
#line 859 "IconButton.c"
	}
#line 226 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (_tmp4_) {
#line 863 "IconButton.c"
		BudgieWindowingWindowGroup* _tmp7_;
		GList* _tmp8_;
#line 227 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp7_ = self->priv->window_group;
#line 227 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp8_ = budgie_windowing_window_group_get_windows (_tmp7_);
#line 227 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 227 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		windows = _tmp8_;
#line 874 "IconButton.c"
	} else {
#line 229 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 229 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		windows = NULL;
#line 880 "IconButton.c"
	}
#line 233 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp9_ = windows;
#line 233 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (vala_g_list_is_empty (_tmp9_)) {
#line 233 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		result = GTK_WIDGET_CLASS (icon_button_parent_class)->draw ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_toggle_button_get_type (), GtkToggleButton), ctx);
#line 233 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 233 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		return result;
#line 892 "IconButton.c"
	}
#line 237 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (!gtk_toggle_button_get_active ((GtkToggleButton*) self)) {
#line 237 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		result = icon_button_draw_inactive (self, ctx);
#line 237 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 237 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		return result;
#line 902 "IconButton.c"
	}
#line 239 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp10_ = windows;
#line 239 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	count = MIN ((gint) g_list_length (_tmp10_), 5);
#line 242 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	spacing = width % count;
#line 243 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (spacing == 0) {
#line 243 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp11_ = ICON_BUTTON_INDICATOR_SPACING;
#line 914 "IconButton.c"
	} else {
#line 243 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp11_ = spacing;
#line 918 "IconButton.c"
	}
#line 243 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	spacing = _tmp11_;
#line 245 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	previous_x = 0;
#line 246 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	previous_y = 0;
#line 926 "IconButton.c"
	{
		gint i = 0;
#line 249 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		i = 0;
#line 931 "IconButton.c"
		{
			gboolean _tmp12_ = FALSE;
#line 249 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp12_ = TRUE;
#line 249 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			while (TRUE) {
#line 938 "IconButton.c"
				XfwWindow* window = NULL;
				GList* _tmp14_;
				gconstpointer _tmp15_;
				XfwWindow* _tmp16_;
				XfwWindow* _tmp17_;
				gint indicator_x = 0;
				gint indicator_y = 0;
				gint length = 0;
				GdkRGBA color = {0};
				gboolean _tmp18_ = FALSE;
				gboolean _tmp19_;
				GdkRGBA _tmp38_;
				GdkRGBA _tmp39_;
				GdkRGBA _tmp40_;
				gint to = 0;
#line 249 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				if (!_tmp12_) {
#line 956 "IconButton.c"
					gint _tmp13_;
#line 249 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					_tmp13_ = i;
#line 249 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					i = _tmp13_ + 1;
#line 962 "IconButton.c"
				}
#line 249 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp12_ = FALSE;
#line 249 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				if (!(i < count)) {
#line 249 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					break;
#line 970 "IconButton.c"
				}
#line 251 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp14_ = windows;
#line 251 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp15_ = g_list_nth_data (_tmp14_, (guint) i);
#line 251 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp16_ = _g_object_ref0 ((XfwWindow*) _tmp15_);
#line 251 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				window = _tmp16_;
#line 254 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp17_ = window;
#line 254 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				if (xfw_window_is_skip_tasklist (_tmp17_)) {
#line 254 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					_g_object_unref0 (window);
#line 254 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					continue;
#line 988 "IconButton.c"
				}
#line 257 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				indicator_x = 0;
#line 258 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				indicator_y = 0;
#line 259 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				length = 0;
#line 262 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				switch (self->priv->panel_position) {
#line 262 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					case BUDGIE_PANEL_POSITION_LEFT:
#line 262 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					case BUDGIE_PANEL_POSITION_RIGHT:
#line 1002 "IconButton.c"
					{
#line 265 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						length = height / count;
#line 266 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						break;
#line 1008 "IconButton.c"
					}
					default:
					{
#line 268 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						length = width / count;
#line 269 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						break;
#line 1016 "IconButton.c"
					}
				}
#line 273 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				switch (self->priv->panel_position) {
#line 273 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					case BUDGIE_PANEL_POSITION_LEFT:
#line 1023 "IconButton.c"
					{
#line 275 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						indicator_x = x + ICON_BUTTON_INDICATOR_PADDING;
#line 276 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						break;
#line 1029 "IconButton.c"
					}
#line 273 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					case BUDGIE_PANEL_POSITION_RIGHT:
#line 1033 "IconButton.c"
					{
#line 278 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						indicator_x = (x + width) - ICON_BUTTON_INDICATOR_PADDING;
#line 279 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						break;
#line 1039 "IconButton.c"
					}
#line 273 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					case BUDGIE_PANEL_POSITION_TOP:
#line 273 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					case BUDGIE_PANEL_POSITION_BOTTOM:
#line 1045 "IconButton.c"
					{
#line 282 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						if (i == 0) {
#line 283 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
							indicator_x = x;
#line 1051 "IconButton.c"
						} else {
#line 285 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
							indicator_x = previous_x;
#line 286 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
							indicator_x += length;
#line 287 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
							previous_x = indicator_x;
#line 288 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
							indicator_x += spacing;
#line 1061 "IconButton.c"
						}
#line 290 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						break;
#line 1065 "IconButton.c"
					}
					default:
					{
#line 292 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						break;
#line 1071 "IconButton.c"
					}
				}
#line 296 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				switch (self->priv->panel_position) {
#line 296 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					case BUDGIE_PANEL_POSITION_LEFT:
#line 296 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					case BUDGIE_PANEL_POSITION_RIGHT:
#line 1080 "IconButton.c"
					{
#line 299 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						if (i == 0) {
#line 300 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
							indicator_y = y;
#line 1086 "IconButton.c"
						} else {
#line 302 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
							indicator_y = previous_y;
#line 303 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
							indicator_y += length;
#line 304 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
							previous_y = indicator_y;
#line 305 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
							indicator_y += spacing;
#line 1096 "IconButton.c"
						}
#line 307 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						break;
#line 1100 "IconButton.c"
					}
#line 296 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					case BUDGIE_PANEL_POSITION_TOP:
#line 1104 "IconButton.c"
					{
#line 309 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						indicator_y = y + ICON_BUTTON_INDICATOR_PADDING;
#line 310 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						break;
#line 1110 "IconButton.c"
					}
#line 296 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					case BUDGIE_PANEL_POSITION_BOTTOM:
#line 1114 "IconButton.c"
					{
#line 312 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						indicator_y = (y + height) - ICON_BUTTON_INDICATOR_PADDING;
#line 313 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						break;
#line 1120 "IconButton.c"
					}
					default:
					{
#line 315 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						break;
#line 1126 "IconButton.c"
					}
				}
#line 321 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp19_ = self->priv->_has_active_window;
#line 321 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				if (_tmp19_) {
#line 1133 "IconButton.c"
					BudgieWindowingWindowGroup* _tmp20_ = NULL;
					BudgieWindowingWindowGroup* _tmp21_;
					XfwWindow* _tmp22_ = NULL;
					XfwWindow* _tmp24_;
#line 321 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					_tmp21_ = self->priv->window_group;
#line 321 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					_tmp20_ = _tmp21_;
#line 321 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					_tmp22_ = NULL;
#line 321 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					if (_tmp20_ != NULL) {
#line 1146 "IconButton.c"
						XfwWindow* _tmp23_;
#line 321 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						_tmp23_ = budgie_windowing_window_group_get_active_window (_tmp20_);
#line 321 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						_tmp22_ = _tmp23_;
#line 1152 "IconButton.c"
					}
#line 321 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					_tmp24_ = window;
#line 321 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					_tmp18_ = _tmp24_ == _tmp22_;
#line 1158 "IconButton.c"
				} else {
#line 321 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					_tmp18_ = FALSE;
#line 1162 "IconButton.c"
				}
#line 321 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				if (_tmp18_) {
#line 1166 "IconButton.c"
					GtkStyleContext* _tmp25_;
					GdkRGBA _tmp26_ = {0};
					gboolean _tmp27_;
#line 322 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					_tmp25_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 322 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					_tmp27_ = gtk_style_context_lookup_color (_tmp25_, "budgie_tasklist_indicator_color_active_window", &_tmp26_);
#line 322 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					color = _tmp26_;
#line 322 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					if (!_tmp27_) {
#line 323 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						gdk_rgba_parse (&color, "#5294E2");
#line 1180 "IconButton.c"
					}
				} else {
					gboolean _tmp28_;
#line 325 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					_tmp28_ = self->priv->_has_active_window;
#line 325 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					if (_tmp28_) {
#line 1188 "IconButton.c"
						GtkStyleContext* _tmp29_;
						GdkRGBA _tmp30_ = {0};
						gboolean _tmp31_;
#line 326 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						_tmp29_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 326 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						_tmp31_ = gtk_style_context_lookup_color (_tmp29_, "budgie_tasklist_indicator_color_active", &_tmp30_);
#line 326 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						color = _tmp30_;
#line 326 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						if (!_tmp31_) {
#line 327 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
							gdk_rgba_parse (&color, "#6BBFFF");
#line 1202 "IconButton.c"
						}
					} else {
						GtkStyleContext* _tmp32_;
						GdkRGBA _tmp33_ = {0};
						gboolean _tmp34_;
#line 330 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						_tmp32_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 330 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						_tmp34_ = gtk_style_context_lookup_color (_tmp32_, "budgie_tasklist_indicator_color", &_tmp33_);
#line 330 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						color = _tmp33_;
#line 330 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						if (!_tmp34_) {
#line 331 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
							gdk_rgba_parse (&color, "#3C6DA6");
#line 1218 "IconButton.c"
						}
					}
				}
#line 335 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				if (self->priv->urgent) {
#line 1224 "IconButton.c"
					GtkStyleContext* _tmp35_;
					GdkRGBA _tmp36_ = {0};
					gboolean _tmp37_;
#line 336 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					_tmp35_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 336 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					_tmp37_ = gtk_style_context_lookup_color (_tmp35_, "budgie_tasklist_indicator_color_attention", &_tmp36_);
#line 336 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					color = _tmp36_;
#line 336 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					if (!_tmp37_) {
#line 337 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						gdk_rgba_parse (&color, "#D84E4E");
#line 1238 "IconButton.c"
					}
				}
#line 341 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp38_ = color;
#line 341 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp39_ = color;
#line 341 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp40_ = color;
#line 341 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				cairo_set_source_rgba (ctx, _tmp38_.red, _tmp39_.green, _tmp40_.blue, (gdouble) 1);
#line 344 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				cairo_set_line_width (ctx, (gdouble) (ICON_BUTTON_INDICATOR_SIZE + 1));
#line 347 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				cairo_move_to (ctx, (gdouble) indicator_x, (gdouble) indicator_y);
#line 350 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				to = 0;
#line 351 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				switch (self->priv->panel_position) {
#line 351 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					case BUDGIE_PANEL_POSITION_LEFT:
#line 351 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					case BUDGIE_PANEL_POSITION_RIGHT:
#line 1261 "IconButton.c"
					{
#line 354 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						if (i == (count - 1)) {
#line 355 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
							to = y + height;
#line 1267 "IconButton.c"
						} else {
#line 357 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
							to = previous_y;
#line 358 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
							to += length;
#line 1273 "IconButton.c"
						}
#line 362 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						cairo_line_to (ctx, (gdouble) indicator_x, (gdouble) to);
#line 363 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						break;
#line 1279 "IconButton.c"
					}
					default:
					{
#line 365 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						if (i == (count - 1)) {
#line 366 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
							to = x + width;
#line 1287 "IconButton.c"
						} else {
#line 368 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
							to = previous_x;
#line 369 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
							to += length;
#line 1293 "IconButton.c"
						}
#line 373 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						cairo_line_to (ctx, (gdouble) to, (gdouble) indicator_y);
#line 374 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						break;
#line 1299 "IconButton.c"
					}
				}
#line 378 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				cairo_stroke (ctx);
#line 249 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_g_object_unref0 (window);
#line 1306 "IconButton.c"
			}
		}
	}
#line 381 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	result = GTK_WIDGET_CLASS (icon_button_parent_class)->draw ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_toggle_button_get_type (), GtkToggleButton), ctx);
#line 381 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 381 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	return result;
#line 1316 "IconButton.c"
}

gboolean
icon_button_draw_inactive (IconButton* self,
                           cairo_t* ctx)
{
	gint x = 0;
	GtkAllocation _tmp0_;
	gint y = 0;
	GtkAllocation _tmp1_;
	gint width = 0;
	GtkAllocation _tmp2_;
	gint height = 0;
	GtkAllocation _tmp3_;
	GList* windows = NULL;
	gboolean _tmp4_ = FALSE;
	BudgieWindowingWindowGroup* _tmp5_;
	GList* _tmp9_;
	gint count = 0;
	GList* _tmp10_;
	gboolean result;
#line 384 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 384 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_val_if_fail (ctx != NULL, FALSE);
#line 385 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp0_ = self->priv->definite_allocation;
#line 385 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	x = _tmp0_.x;
#line 386 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp1_ = self->priv->definite_allocation;
#line 386 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	y = _tmp1_.y;
#line 387 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp2_ = self->priv->definite_allocation;
#line 387 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	width = _tmp2_.width;
#line 388 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp3_ = self->priv->definite_allocation;
#line 388 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	height = _tmp3_.height;
#line 393 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp5_ = self->priv->window_group;
#line 393 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (_tmp5_ != NULL) {
#line 1362 "IconButton.c"
		BudgieWindowingWindowGroup* _tmp6_;
#line 393 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp6_ = self->priv->window_group;
#line 393 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp4_ = budgie_windowing_window_group_has_windows (_tmp6_);
#line 1368 "IconButton.c"
	} else {
#line 393 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp4_ = FALSE;
#line 1372 "IconButton.c"
	}
#line 393 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (_tmp4_) {
#line 1376 "IconButton.c"
		BudgieWindowingWindowGroup* _tmp7_;
		GList* _tmp8_;
#line 394 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp7_ = self->priv->window_group;
#line 394 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp8_ = budgie_windowing_window_group_get_windows (_tmp7_);
#line 394 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 394 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		windows = _tmp8_;
#line 1387 "IconButton.c"
	} else {
#line 396 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 396 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		windows = NULL;
#line 1393 "IconButton.c"
	}
#line 400 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp9_ = windows;
#line 400 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (vala_g_list_is_empty (_tmp9_)) {
#line 401 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		result = GTK_WIDGET_CLASS (icon_button_parent_class)->draw ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_toggle_button_get_type (), GtkToggleButton), ctx);
#line 401 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 401 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		return result;
#line 1405 "IconButton.c"
	}
#line 404 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp10_ = windows;
#line 404 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	count = MIN ((gint) g_list_length (_tmp10_), 5);
#line 1411 "IconButton.c"
	{
		gint i = 0;
#line 407 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		i = 0;
#line 1416 "IconButton.c"
		{
			gboolean _tmp11_ = FALSE;
#line 407 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp11_ = TRUE;
#line 407 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			while (TRUE) {
#line 1423 "IconButton.c"
				XfwWindow* window = NULL;
				GList* _tmp13_;
				gconstpointer _tmp14_;
				XfwWindow* _tmp15_;
				XfwWindow* _tmp16_;
				gint indicator_x = 0;
				gint indicator_y = 0;
				GdkRGBA color = {0};
				GdkRGBA _tmp23_;
				GdkRGBA _tmp24_;
				GdkRGBA _tmp25_;
#line 407 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				if (!_tmp11_) {
#line 1437 "IconButton.c"
					gint _tmp12_;
#line 407 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					_tmp12_ = i;
#line 407 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					i = _tmp12_ + 1;
#line 1443 "IconButton.c"
				}
#line 407 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp11_ = FALSE;
#line 407 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				if (!(i < count)) {
#line 407 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					break;
#line 1451 "IconButton.c"
				}
#line 408 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp13_ = windows;
#line 408 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp14_ = g_list_nth_data (_tmp13_, (guint) i);
#line 408 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp15_ = _g_object_ref0 ((XfwWindow*) _tmp14_);
#line 408 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				window = _tmp15_;
#line 411 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp16_ = window;
#line 411 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				if (xfw_window_is_skip_tasklist (_tmp16_)) {
#line 411 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					_g_object_unref0 (window);
#line 411 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					continue;
#line 1469 "IconButton.c"
				}
#line 414 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				indicator_x = 0;
#line 415 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				indicator_y = 0;
#line 418 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				switch (self->priv->panel_position) {
#line 418 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					case BUDGIE_PANEL_POSITION_TOP:
#line 418 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					case BUDGIE_PANEL_POSITION_BOTTOM:
#line 1481 "IconButton.c"
					{
#line 421 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						indicator_x = x + (width / 2);
#line 422 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						indicator_x -= ((count * (ICON_BUTTON_INDICATOR_SIZE + ICON_BUTTON_INACTIVE_INDICATOR_SPACING)) / 2) - ICON_BUTTON_INACTIVE_INDICATOR_SPACING;
#line 423 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						indicator_x += ((ICON_BUTTON_INDICATOR_SIZE + ICON_BUTTON_INACTIVE_INDICATOR_SPACING) * i) - 1;
#line 424 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						break;
#line 1491 "IconButton.c"
					}
#line 418 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					case BUDGIE_PANEL_POSITION_LEFT:
#line 1495 "IconButton.c"
					{
#line 426 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						indicator_x = (y + (ICON_BUTTON_INDICATOR_SIZE / 2)) - ICON_BUTTON_INDICATOR_PADDING;
#line 427 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						break;
#line 1501 "IconButton.c"
					}
#line 418 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					case BUDGIE_PANEL_POSITION_RIGHT:
#line 1505 "IconButton.c"
					{
#line 429 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						indicator_x = ((y + width) - (ICON_BUTTON_INDICATOR_SIZE / 2)) + ICON_BUTTON_INDICATOR_PADDING;
#line 430 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						break;
#line 1511 "IconButton.c"
					}
					default:
					{
#line 432 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						break;
#line 1517 "IconButton.c"
					}
				}
#line 436 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				switch (self->priv->panel_position) {
#line 436 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					case BUDGIE_PANEL_POSITION_TOP:
#line 1524 "IconButton.c"
					{
#line 438 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						indicator_y = (y + (ICON_BUTTON_INDICATOR_SIZE / 2)) + ICON_BUTTON_INDICATOR_PADDING;
#line 439 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						break;
#line 1530 "IconButton.c"
					}
#line 436 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					case BUDGIE_PANEL_POSITION_BOTTOM:
#line 1534 "IconButton.c"
					{
#line 441 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						indicator_y = ((y + height) - (ICON_BUTTON_INDICATOR_SIZE / 2)) - ICON_BUTTON_INDICATOR_PADDING;
#line 442 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						break;
#line 1540 "IconButton.c"
					}
#line 436 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					case BUDGIE_PANEL_POSITION_LEFT:
#line 1544 "IconButton.c"
					{
#line 444 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						indicator_y = x + (height / 2);
#line 445 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						indicator_y -= ((count * (ICON_BUTTON_INDICATOR_SIZE + ICON_BUTTON_INACTIVE_INDICATOR_SPACING)) / 2) - (ICON_BUTTON_INACTIVE_INDICATOR_SPACING * 2);
#line 446 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						indicator_y += (ICON_BUTTON_INDICATOR_SIZE + ICON_BUTTON_INACTIVE_INDICATOR_SPACING) * i;
#line 447 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						break;
#line 1554 "IconButton.c"
					}
#line 436 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					case BUDGIE_PANEL_POSITION_RIGHT:
#line 1558 "IconButton.c"
					{
#line 449 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						indicator_y = x + (height / 2);
#line 450 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						indicator_y -= ((count * (ICON_BUTTON_INDICATOR_SIZE + ICON_BUTTON_INACTIVE_INDICATOR_SPACING)) / 2) - ICON_BUTTON_INACTIVE_INDICATOR_SPACING;
#line 451 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						indicator_y += (ICON_BUTTON_INDICATOR_SIZE + ICON_BUTTON_INACTIVE_INDICATOR_SPACING) * i;
#line 452 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						break;
#line 1568 "IconButton.c"
					}
					default:
					{
#line 454 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						break;
#line 1574 "IconButton.c"
					}
				}
#line 460 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				if (self->priv->urgent) {
#line 1579 "IconButton.c"
					GtkStyleContext* _tmp17_;
					GdkRGBA _tmp18_ = {0};
					gboolean _tmp19_;
#line 461 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					_tmp17_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 461 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					_tmp19_ = gtk_style_context_lookup_color (_tmp17_, "budgie_tasklist_indicator_color_attention", &_tmp18_);
#line 461 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					color = _tmp18_;
#line 461 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					if (!_tmp19_) {
#line 462 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						gdk_rgba_parse (&color, "#D84E4E");
#line 1593 "IconButton.c"
					}
				} else {
					GtkStyleContext* _tmp20_;
					GdkRGBA _tmp21_ = {0};
					gboolean _tmp22_;
#line 465 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					_tmp20_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 465 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					_tmp22_ = gtk_style_context_lookup_color (_tmp20_, "budgie_tasklist_indicator_color", &_tmp21_);
#line 465 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					color = _tmp21_;
#line 465 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					if (!_tmp22_) {
#line 466 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
						gdk_rgba_parse (&color, "#3C6DA6");
#line 1609 "IconButton.c"
					}
				}
#line 470 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp23_ = color;
#line 470 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp24_ = color;
#line 470 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp25_ = color;
#line 470 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				cairo_set_source_rgba (ctx, _tmp23_.red, _tmp24_.green, _tmp25_.blue, (gdouble) 1);
#line 473 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				cairo_arc (ctx, (gdouble) indicator_x, (gdouble) indicator_y, (gdouble) ICON_BUTTON_INDICATOR_SIZE, (gdouble) 0, G_PI * 2);
#line 476 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				cairo_fill (ctx);
#line 407 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_g_object_unref0 (window);
#line 1626 "IconButton.c"
			}
		}
	}
#line 479 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	result = GTK_WIDGET_CLASS (icon_button_parent_class)->draw ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_toggle_button_get_type (), GtkToggleButton), ctx);
#line 479 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 479 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	return result;
#line 1636 "IconButton.c"
}

static void
icon_button_real_get_preferred_width (GtkWidget* base,
                                      gint* min,
                                      gint* nat)
{
	IconButton * self;
	gint _vala_min = 0;
	gint _vala_nat = 0;
#line 482 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	self = (IconButton*) base;
#line 483 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (self->priv->orientation == GTK_ORIENTATION_HORIZONTAL) {
#line 484 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_vala_nat = self->priv->panel_size;
#line 484 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_vala_min = _vala_nat;
#line 1655 "IconButton.c"
	} else {
		gint m = 0;
		gint n = 0;
		gint _tmp0_ = 0;
		gint _tmp1_ = 0;
#line 487 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		GTK_WIDGET_CLASS (icon_button_parent_class)->get_preferred_width ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_toggle_button_get_type (), GtkToggleButton), &_tmp0_, &_tmp1_);
#line 487 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		m = _tmp0_;
#line 487 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		n = _tmp1_;
#line 488 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_vala_min = m;
#line 489 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_vala_nat = n;
#line 1671 "IconButton.c"
	}
#line 482 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (min) {
#line 482 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		*min = _vala_min;
#line 1677 "IconButton.c"
	}
#line 482 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (nat) {
#line 482 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		*nat = _vala_nat;
#line 1683 "IconButton.c"
	}
}

static void
icon_button_real_get_preferred_height (GtkWidget* base,
                                       gint* min,
                                       gint* nat)
{
	IconButton * self;
	gint _vala_min = 0;
	gint _vala_nat = 0;
#line 493 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	self = (IconButton*) base;
#line 494 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (self->priv->orientation == GTK_ORIENTATION_VERTICAL) {
#line 495 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_vala_nat = self->priv->panel_size;
#line 495 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_vala_min = _vala_nat;
#line 1703 "IconButton.c"
	} else {
		gint m = 0;
		gint n = 0;
		gint _tmp0_ = 0;
		gint _tmp1_ = 0;
#line 498 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		GTK_WIDGET_CLASS (icon_button_parent_class)->get_preferred_height ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_toggle_button_get_type (), GtkToggleButton), &_tmp0_, &_tmp1_);
#line 498 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		m = _tmp0_;
#line 498 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		n = _tmp1_;
#line 499 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_vala_min = m;
#line 500 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_vala_nat = n;
#line 1719 "IconButton.c"
	}
#line 493 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (min) {
#line 493 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		*min = _vala_min;
#line 1725 "IconButton.c"
	}
#line 493 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (nat) {
#line 493 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		*nat = _vala_nat;
#line 1731 "IconButton.c"
	}
}

gboolean
icon_button_has_window (IconButton* self,
                        XfwWindow* window)
{
	gboolean _tmp0_ = FALSE;
	BudgieWindowingWindowGroup* _tmp1_;
	gboolean result;
#line 504 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 504 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_val_if_fail (window != NULL, FALSE);
#line 505 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp1_ = self->priv->window_group;
#line 505 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (_tmp1_ != NULL) {
#line 1750 "IconButton.c"
		BudgieWindowingWindowGroup* _tmp2_;
#line 505 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp2_ = self->priv->window_group;
#line 505 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp0_ = budgie_windowing_window_group_has_window (_tmp2_, window);
#line 1756 "IconButton.c"
	} else {
#line 505 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp0_ = FALSE;
#line 1760 "IconButton.c"
	}
#line 505 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	result = _tmp0_;
#line 505 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	return result;
#line 1766 "IconButton.c"
}

Icon*
icon_button_get_icon (IconButton* self)
{
	Icon* _tmp0_;
	Icon* _tmp1_;
	Icon* result;
#line 508 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 509 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp0_ = self->priv->icon;
#line 509 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 509 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	result = _tmp1_;
#line 509 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	return result;
#line 1785 "IconButton.c"
}

gboolean
icon_button_launch (IconButton* self)
{
	BudgieApplication* _tmp0_;
	gboolean _tmp1_;
	Icon* _tmp2_;
	Icon* _tmp3_;
	Icon* _tmp4_;
	BudgieApplication* _tmp5_;
	gboolean result;
#line 512 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 513 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp0_ = self->priv->_app;
#line 513 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (_tmp0_ == NULL) {
#line 513 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		result = FALSE;
#line 513 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		return result;
#line 1808 "IconButton.c"
	}
#line 515 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp1_ = self->priv->_pinned;
#line 515 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (!_tmp1_) {
#line 516 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		g_warning ("IconButton.vala:516: IconButton was clicked with no active windows, bu" \
"t is not pinned!");
#line 517 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		result = FALSE;
#line 517 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		return result;
#line 1820 "IconButton.c"
	}
#line 520 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp2_ = self->priv->icon;
#line 520 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	icon_animate_launch (_tmp2_, self->priv->panel_position);
#line 521 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp3_ = self->priv->icon;
#line 521 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp3_->waiting = TRUE;
#line 522 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp4_ = self->priv->icon;
#line 522 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	icon_animate_wait (_tmp4_);
#line 524 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp5_ = self->priv->_app;
#line 524 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	result = budgie_application_launch (_tmp5_);
#line 524 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	return result;
#line 1840 "IconButton.c"
}

void
icon_button_set_active_window (IconButton* self,
                               gboolean active)
{
#line 527 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 528 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	icon_button_set_has_active_window (self, active);
#line 1851 "IconButton.c"
}

void
icon_button_set_icon_size (IconButton* self,
                           gint size)
{
#line 531 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 532 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	self->priv->target_icon_size = size;
#line 1862 "IconButton.c"
}

void
icon_button_set_orientation (IconButton* self,
                             GtkOrientation orientation)
{
#line 535 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 536 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	self->priv->orientation = orientation;
#line 1873 "IconButton.c"
}

void
icon_button_set_panel_size (IconButton* self,
                            gint size)
{
#line 539 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 540 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	self->priv->panel_size = size;
#line 1884 "IconButton.c"
}

void
icon_button_set_panel_position (IconButton* self,
                                BudgiePanelPosition position)
{
#line 543 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 544 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	self->priv->panel_position = position;
#line 1895 "IconButton.c"
}

BudgieWindowingWindowGroup*
icon_button_get_window_group (IconButton* self)
{
	BudgieWindowingWindowGroup* _tmp0_;
	BudgieWindowingWindowGroup* _tmp1_;
	BudgieWindowingWindowGroup* result;
#line 547 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 548 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp0_ = self->priv->window_group;
#line 548 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 548 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	result = _tmp1_;
#line 548 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	return result;
#line 1914 "IconButton.c"
}

void
icon_button_set_urgent (IconButton* self,
                        gboolean urgent)
{
#line 551 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 552 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	self->priv->urgent = urgent;
#line 554 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (urgent) {
#line 1927 "IconButton.c"
		GtkStyleContext* _tmp0_;
		Icon* _tmp1_;
#line 555 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 555 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		gtk_style_context_add_class (_tmp0_, "needs-attention");
#line 556 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp1_ = self->priv->icon;
#line 556 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		icon_animate_attention (_tmp1_, &self->priv->panel_position);
#line 1938 "IconButton.c"
	} else {
		GtkStyleContext* _tmp2_;
#line 558 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 558 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		gtk_style_context_remove_class (_tmp2_, "needs-attention");
#line 1945 "IconButton.c"
	}
#line 561 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	icon_button_update (self);
#line 562 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 1951 "IconButton.c"
}

static void
__lambda22_ (IconButton* self,
             XfwWindow* window)
{
#line 589 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (window != NULL) {
#line 1960 "IconButton.c"
		const gchar* _tmp0_;
#line 590 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp0_ = xfw_window_get_name (window);
#line 590 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp0_);
#line 1966 "IconButton.c"
	}
}

static void
___lambda22__budgie_windowing_window_group_active_window_changed (BudgieWindowingWindowGroup* _sender,
                                                                  XfwWindow* window,
                                                                  gpointer self)
{
#line 588 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	__lambda22_ ((IconButton*) self, window);
#line 1977 "IconButton.c"
}

static void
__lambda23_ (IconButton* self)
{
#line 595 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	icon_button_update_icon (self);
#line 1985 "IconButton.c"
}

static void
___lambda23__budgie_windowing_window_group_app_icon_changed (BudgieWindowingWindowGroup* _sender,
                                                             gpointer self)
{
#line 594 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	__lambda23_ ((IconButton*) self);
#line 1994 "IconButton.c"
}

static void
__lambda25_ (IconButton* self,
             XfwWindowState changed_mask,
             XfwWindowState new_state)
{
#line 602 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (!((changed_mask & XFW_WINDOW_STATE_URGENT) == XFW_WINDOW_STATE_URGENT)) {
#line 603 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		return;
#line 2006 "IconButton.c"
	}
#line 606 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	self->priv->urgent = (new_state & XFW_WINDOW_STATE_URGENT) != 0;
#line 608 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	icon_button_set_urgent (self, self->priv->urgent);
#line 2012 "IconButton.c"
}

static void
___lambda25__libxfce4windowing_window_state_changed (XfwWindow* _sender,
                                                     XfwWindowState changed_mask,
                                                     XfwWindowState new_state,
                                                     gpointer self)
{
#line 601 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	__lambda25_ ((IconButton*) self, changed_mask, new_state);
#line 2023 "IconButton.c"
}

static void
__lambda24_ (IconButton* self,
             XfwWindow* window)
{
	ButtonPopover* _tmp0_;
#line 598 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_if_fail (window != NULL);
#line 599 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp0_ = self->priv->popover;
#line 599 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	button_popover_add_window (_tmp0_, window);
#line 601 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_signal_connect_object (window, "state-changed", (GCallback) ___lambda25__libxfce4windowing_window_state_changed, self, 0);
#line 611 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	icon_button_update (self);
#line 2041 "IconButton.c"
}

static void
___lambda24__budgie_windowing_window_group_window_added (BudgieWindowingWindowGroup* _sender,
                                                         XfwWindow* window,
                                                         gpointer self)
{
#line 598 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	__lambda24_ ((IconButton*) self, window);
#line 2051 "IconButton.c"
}

static void
__lambda26_ (IconButton* self,
             XfwWindow* window)
{
	ButtonPopover* _tmp0_;
#line 614 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_if_fail (window != NULL);
#line 615 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp0_ = self->priv->popover;
#line 615 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	button_popover_remove_window (_tmp0_, window);
#line 616 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	icon_button_update (self);
#line 2067 "IconButton.c"
}

static void
___lambda26__budgie_windowing_window_group_window_removed (BudgieWindowingWindowGroup* _sender,
                                                           XfwWindow* window,
                                                           gpointer self)
{
#line 614 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	__lambda26_ ((IconButton*) self, window);
#line 2077 "IconButton.c"
}

void
icon_button_set_window_group (IconButton* self,
                              BudgieWindowingWindowGroup* window_group)
{
	BudgieWindowingWindowGroup* _tmp0_;
	ButtonPopover* _tmp1_;
	GList* _tmp2_;
	BudgieWindowingWindowGroup* _tmp5_ = NULL;
	XfwWindow* _tmp6_ = NULL;
	XfwWindow* window = NULL;
	XfwWindow* _tmp8_;
	XfwWindow* _tmp9_;
#line 565 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 566 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp0_ = _g_object_ref0 (window_group);
#line 566 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_g_object_unref0 (self->priv->window_group);
#line 566 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	self->priv->window_group = _tmp0_;
#line 567 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp1_ = self->priv->popover;
#line 567 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	button_popover_set_group (_tmp1_, window_group);
#line 569 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (window_group == NULL) {
#line 569 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		return;
#line 2108 "IconButton.c"
	}
#line 571 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp2_ = budgie_windowing_window_group_get_windows (window_group);
#line 2112 "IconButton.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 571 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		window_collection = _tmp2_;
#line 571 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 2120 "IconButton.c"
			XfwWindow* window = NULL;
#line 571 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			window = (XfwWindow*) window_it->data;
#line 2124 "IconButton.c"
			{
				ButtonPopover* _tmp3_;
				XfwWindow* _tmp4_;
#line 572 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp3_ = self->priv->popover;
#line 572 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp4_ = window;
#line 572 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				button_popover_add_window (_tmp3_, _tmp4_);
#line 2134 "IconButton.c"
			}
		}
#line 571 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		(window_collection == NULL) ? NULL : (window_collection = (g_list_free (window_collection), NULL));
#line 2139 "IconButton.c"
	}
#line 579 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp5_ = window_group;
#line 579 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp6_ = NULL;
#line 579 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (_tmp5_ != NULL) {
#line 2147 "IconButton.c"
		XfwWindow* _tmp7_;
#line 579 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp7_ = budgie_windowing_window_group_get_active_window (_tmp5_);
#line 579 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp6_ = _tmp7_;
#line 2153 "IconButton.c"
	}
#line 579 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp8_ = _g_object_ref0 (_tmp6_);
#line 579 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	window = _tmp8_;
#line 581 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp9_ = window;
#line 581 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (_tmp9_ != NULL) {
#line 2163 "IconButton.c"
		XfwWindow* _tmp10_;
		const gchar* _tmp11_;
#line 582 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp10_ = window;
#line 582 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp11_ = xfw_window_get_name (_tmp10_);
#line 582 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp11_);
#line 2172 "IconButton.c"
	} else {
		XfwWindow* _tmp12_;
#line 583 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp12_ = budgie_windowing_window_group_get_last_active_window (window_group);
#line 583 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		if (_tmp12_ != NULL) {
#line 2179 "IconButton.c"
			XfwWindow* _tmp13_;
			XfwWindow* _tmp14_;
			XfwWindow* _tmp15_;
			const gchar* _tmp16_;
#line 584 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp13_ = budgie_windowing_window_group_get_last_active_window (window_group);
#line 584 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp14_ = _g_object_ref0 (_tmp13_);
#line 584 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_g_object_unref0 (window);
#line 584 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			window = _tmp14_;
#line 585 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp15_ = window;
#line 585 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp16_ = xfw_window_get_name (_tmp15_);
#line 585 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp16_);
#line 2198 "IconButton.c"
		}
	}
#line 588 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_signal_connect_object (window_group, "active-window-changed", (GCallback) ___lambda22__budgie_windowing_window_group_active_window_changed, self, 0);
#line 594 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_signal_connect_object (window_group, "app-icon-changed", (GCallback) ___lambda23__budgie_windowing_window_group_app_icon_changed, self, G_CONNECT_AFTER);
#line 598 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_signal_connect_object (window_group, "window-added", (GCallback) ___lambda24__budgie_windowing_window_group_window_added, self, 0);
#line 614 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_signal_connect_object (window_group, "window-removed", (GCallback) ___lambda26__budgie_windowing_window_group_window_removed, self, 0);
#line 565 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_g_object_unref0 (window);
#line 2211 "IconButton.c"
}

void
icon_button_update (IconButton* self)
{
	gboolean _tmp0_ = FALSE;
	BudgieWindowingWindowGroup* _tmp1_;
	gboolean _tmp30_;
#line 620 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 621 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp1_ = self->priv->window_group;
#line 621 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (_tmp1_ != NULL) {
#line 2226 "IconButton.c"
		BudgieWindowingWindowGroup* _tmp2_;
#line 621 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp2_ = self->priv->window_group;
#line 621 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp0_ = budgie_windowing_window_group_has_windows (_tmp2_);
#line 2232 "IconButton.c"
	} else {
#line 621 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp0_ = FALSE;
#line 2236 "IconButton.c"
	}
#line 621 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (_tmp0_) {
#line 2240 "IconButton.c"
		GtkStyleContext* _tmp3_;
#line 622 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 622 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		gtk_style_context_add_class (_tmp3_, "running");
#line 2246 "IconButton.c"
	} else {
		gboolean _tmp4_ = FALSE;
		BudgieWindowingWindowGroup* _tmp5_;
#line 623 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp5_ = self->priv->window_group;
#line 623 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		if (_tmp5_ != NULL) {
#line 2254 "IconButton.c"
			BudgieWindowingWindowGroup* _tmp6_;
#line 623 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp6_ = self->priv->window_group;
#line 623 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp4_ = !budgie_windowing_window_group_has_windows (_tmp6_);
#line 2260 "IconButton.c"
		} else {
#line 623 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp4_ = FALSE;
#line 2264 "IconButton.c"
		}
#line 623 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		if (_tmp4_) {
#line 2268 "IconButton.c"
			GtkStyleContext* _tmp7_;
			gboolean _tmp8_;
			BudgieWindowingWindowGroup* _tmp9_ = NULL;
			BudgieWindowingWindowGroup* _tmp10_;
			XfwWindow* _tmp11_ = NULL;
			XfwWindow* _tmp13_ = NULL;
			XfwWindow* active_window = NULL;
			XfwWindow* _tmp18_;
			BudgieApplication* _tmp19_ = NULL;
			BudgieApplication* _tmp20_;
			const gchar* _tmp21_ = NULL;
			const gchar* _tmp24_ = NULL;
#line 624 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp7_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 624 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			gtk_style_context_remove_class (_tmp7_, "running");
#line 626 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp8_ = self->priv->_pinned;
#line 626 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			if (!_tmp8_) {
#line 626 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				return;
#line 2291 "IconButton.c"
			}
#line 628 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp10_ = self->priv->window_group;
#line 628 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp9_ = _tmp10_;
#line 628 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp11_ = NULL;
#line 628 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			if (_tmp9_ != NULL) {
#line 2301 "IconButton.c"
				XfwWindow* _tmp12_;
#line 628 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp12_ = budgie_windowing_window_group_get_active_window (_tmp9_);
#line 628 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp11_ = _tmp12_;
#line 2307 "IconButton.c"
			}
#line 628 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp13_ = _tmp11_;
#line 628 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			if (_tmp13_ == NULL) {
#line 2313 "IconButton.c"
				BudgieWindowingWindowGroup* _tmp14_ = NULL;
				BudgieWindowingWindowGroup* _tmp15_;
				XfwWindow* _tmp16_ = NULL;
#line 628 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp15_ = self->priv->window_group;
#line 628 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp14_ = _tmp15_;
#line 628 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp16_ = NULL;
#line 628 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				if (_tmp14_ != NULL) {
#line 2325 "IconButton.c"
					XfwWindow* _tmp17_;
#line 628 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					_tmp17_ = budgie_windowing_window_group_get_last_active_window (_tmp14_);
#line 628 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					_tmp16_ = _tmp17_;
#line 2331 "IconButton.c"
				}
#line 628 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp13_ = _tmp16_;
#line 2335 "IconButton.c"
			}
#line 628 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp18_ = _g_object_ref0 (_tmp13_);
#line 628 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			active_window = _tmp18_;
#line 629 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp20_ = self->priv->_app;
#line 629 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp19_ = _tmp20_;
#line 629 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp21_ = NULL;
#line 629 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			if (_tmp19_ != NULL) {
#line 2349 "IconButton.c"
				const gchar* _tmp22_;
				const gchar* _tmp23_;
#line 629 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp22_ = budgie_application_get_name (_tmp19_);
#line 629 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp23_ = _tmp22_;
#line 629 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp21_ = _tmp23_;
#line 2358 "IconButton.c"
			}
#line 629 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp24_ = _tmp21_;
#line 629 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			if (_tmp24_ == NULL) {
#line 2364 "IconButton.c"
				XfwWindow* _tmp25_ = NULL;
				XfwWindow* _tmp26_;
				const gchar* _tmp27_ = NULL;
				const gchar* _tmp29_ = NULL;
#line 629 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp26_ = active_window;
#line 629 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp25_ = _tmp26_;
#line 629 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp27_ = NULL;
#line 629 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				if (_tmp25_ != NULL) {
#line 2377 "IconButton.c"
					const gchar* _tmp28_;
#line 629 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					_tmp28_ = xfw_window_get_name (_tmp25_);
#line 629 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					_tmp27_ = _tmp28_;
#line 2383 "IconButton.c"
				}
#line 629 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp29_ = _tmp27_;
#line 629 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				if (_tmp29_ == NULL) {
#line 629 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
					_tmp29_ = "";
#line 2391 "IconButton.c"
				}
#line 629 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp24_ = _tmp29_;
#line 2395 "IconButton.c"
			}
#line 629 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp24_);
#line 630 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_g_object_unref0 (self->priv->window_group);
#line 630 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			self->priv->window_group = NULL;
#line 623 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_g_object_unref0 (active_window);
#line 2405 "IconButton.c"
		}
	}
#line 633 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp30_ = self->priv->_has_active_window;
#line 633 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) self, _tmp30_);
#line 635 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	icon_button_update_icon (self);
#line 636 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	gtk_widget_queue_resize ((GtkWidget*) self);
#line 2416 "IconButton.c"
}

void
icon_button_update_icon (IconButton* self)
{
	gboolean _tmp0_ = FALSE;
	BudgieWindowingWindowGroup* _tmp1_;
	GdkPixbuf* pixbuf_icon = NULL;
	BudgieWindowingWindowGroup* _tmp4_;
	BudgieApplication* _tmp8_ = NULL;
	BudgieApplication* _tmp9_;
	GIcon* _tmp10_ = NULL;
	gint _tmp23_ = 0;
	Icon* _tmp24_;
#line 639 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 640 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp1_ = self->priv->window_group;
#line 640 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (_tmp1_ != NULL) {
#line 2437 "IconButton.c"
		BudgieWindowingWindowGroup* _tmp2_;
#line 640 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp2_ = self->priv->window_group;
#line 640 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp0_ = budgie_windowing_window_group_has_windows (_tmp2_);
#line 2443 "IconButton.c"
	} else {
#line 640 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp0_ = FALSE;
#line 2447 "IconButton.c"
	}
#line 640 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (_tmp0_) {
#line 2451 "IconButton.c"
		Icon* _tmp3_;
#line 641 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp3_ = self->priv->icon;
#line 641 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp3_->waiting = FALSE;
#line 2457 "IconButton.c"
	}
#line 644 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	pixbuf_icon = NULL;
#line 646 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp4_ = self->priv->window_group;
#line 646 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (_tmp4_ != NULL) {
#line 2465 "IconButton.c"
		gint _tmp5_ = 0;
		gint size = 0;
		BudgieWindowingWindowGroup* _tmp6_;
		GdkPixbuf* _tmp7_;
#line 647 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		if (self->priv->target_icon_size == 0) {
#line 647 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp5_ = ICON_BUTTON_DEFAULT_ICON_SIZE;
#line 2474 "IconButton.c"
		} else {
#line 647 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp5_ = self->priv->target_icon_size;
#line 2478 "IconButton.c"
		}
#line 647 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		size = _tmp5_;
#line 648 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp6_ = self->priv->window_group;
#line 648 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp7_ = budgie_windowing_window_group_get_icon (_tmp6_, size, 1);
#line 648 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_g_object_unref0 (pixbuf_icon);
#line 648 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		pixbuf_icon = _tmp7_;
#line 2490 "IconButton.c"
	}
#line 651 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp9_ = self->priv->_app;
#line 651 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp8_ = _tmp9_;
#line 651 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp10_ = NULL;
#line 651 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (_tmp8_ != NULL) {
#line 2500 "IconButton.c"
		GIcon* _tmp11_;
		GIcon* _tmp12_;
#line 651 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp11_ = budgie_application_get_icon (_tmp8_);
#line 651 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp12_ = _tmp11_;
#line 651 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp10_ = _tmp12_;
#line 2509 "IconButton.c"
	}
#line 651 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (_tmp10_ != NULL) {
#line 2513 "IconButton.c"
		BudgieApplication* _tmp13_ = NULL;
		BudgieApplication* _tmp14_;
		GIcon* _tmp15_ = NULL;
		Icon* _tmp18_;
#line 652 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp14_ = self->priv->_app;
#line 652 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp13_ = _tmp14_;
#line 652 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp15_ = NULL;
#line 652 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		if (_tmp13_ != NULL) {
#line 2526 "IconButton.c"
			GIcon* _tmp16_;
			GIcon* _tmp17_;
#line 652 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp16_ = budgie_application_get_icon (_tmp13_);
#line 652 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp17_ = _tmp16_;
#line 652 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp15_ = _tmp17_;
#line 2535 "IconButton.c"
		}
#line 652 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp18_ = self->priv->icon;
#line 652 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		gtk_image_set_from_gicon ((GtkImage*) _tmp18_, _tmp15_, (GtkIconSize) GTK_ICON_SIZE_INVALID);
#line 2541 "IconButton.c"
	} else {
		GdkPixbuf* _tmp19_;
#line 653 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp19_ = pixbuf_icon;
#line 653 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		if (_tmp19_ != NULL) {
#line 2548 "IconButton.c"
			Icon* _tmp20_;
			GdkPixbuf* _tmp21_;
#line 654 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp20_ = self->priv->icon;
#line 654 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp21_ = pixbuf_icon;
#line 654 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			gtk_image_set_from_pixbuf ((GtkImage*) _tmp20_, _tmp21_);
#line 2557 "IconButton.c"
		} else {
			Icon* _tmp22_;
#line 656 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp22_ = self->priv->icon;
#line 656 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			gtk_image_set_from_icon_name ((GtkImage*) _tmp22_, "image-missing", (GtkIconSize) GTK_ICON_SIZE_INVALID);
#line 2564 "IconButton.c"
		}
	}
#line 660 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (self->priv->target_icon_size > 0) {
#line 660 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp23_ = self->priv->target_icon_size;
#line 2571 "IconButton.c"
	} else {
#line 660 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp23_ = ICON_BUTTON_DEFAULT_ICON_SIZE;
#line 2575 "IconButton.c"
	}
#line 660 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp24_ = self->priv->icon;
#line 660 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	gtk_image_set_pixel_size ((GtkImage*) _tmp24_, _tmp23_);
#line 639 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_g_object_unref0 (pixbuf_icon);
#line 2583 "IconButton.c"
}

BudgieApplication*
icon_button_get_app (IconButton* self)
{
	BudgieApplication* result;
	BudgieApplication* _tmp0_;
#line 27 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp0_ = self->priv->_app;
#line 27 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	result = _tmp0_;
#line 27 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	return result;
#line 2599 "IconButton.c"
}

static void
icon_button_set_app (IconButton* self,
                     BudgieApplication* value)
{
	BudgieApplication* old_value;
#line 27 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	old_value = icon_button_get_app (self);
#line 27 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (old_value != value) {
#line 2613 "IconButton.c"
		BudgieApplication* _tmp0_;
#line 27 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 27 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_g_object_unref0 (self->priv->_app);
#line 27 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		self->priv->_app = _tmp0_;
#line 27 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		g_object_notify_by_pspec ((GObject *) self, icon_button_properties[ICON_BUTTON_APP_PROPERTY]);
#line 2623 "IconButton.c"
	}
}

BudgiePopoverManager*
icon_button_get_popover_manager (IconButton* self)
{
	BudgiePopoverManager* result;
	BudgiePopoverManager* _tmp0_;
#line 28 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp0_ = self->priv->_popover_manager;
#line 28 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	result = _tmp0_;
#line 28 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	return result;
#line 2640 "IconButton.c"
}

static void
icon_button_set_popover_manager (IconButton* self,
                                 BudgiePopoverManager* value)
{
	BudgiePopoverManager* old_value;
#line 28 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	old_value = icon_button_get_popover_manager (self);
#line 28 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (old_value != value) {
#line 28 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		self->priv->_popover_manager = value;
#line 28 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		g_object_notify_by_pspec ((GObject *) self, icon_button_properties[ICON_BUTTON_POPOVER_MANAGER_PROPERTY]);
#line 2658 "IconButton.c"
	}
}

gboolean
icon_button_get_pinned (IconButton* self)
{
	gboolean result;
#line 29 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 29 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	result = self->priv->_pinned;
#line 29 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	return result;
#line 2672 "IconButton.c"
}

void
icon_button_set_pinned (IconButton* self,
                        gboolean value)
{
	gboolean old_value;
#line 29 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	old_value = icon_button_get_pinned (self);
#line 29 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (old_value != value) {
#line 29 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		self->priv->_pinned = value;
#line 29 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		g_object_notify_by_pspec ((GObject *) self, icon_button_properties[ICON_BUTTON_PINNED_PROPERTY]);
#line 2690 "IconButton.c"
	}
}

gboolean
icon_button_get_has_active_window (IconButton* self)
{
	gboolean result;
#line 30 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 30 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	result = self->priv->_has_active_window;
#line 30 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	return result;
#line 2704 "IconButton.c"
}

static void
icon_button_set_has_active_window (IconButton* self,
                                   gboolean value)
{
	gboolean old_value;
#line 30 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	old_value = icon_button_get_has_active_window (self);
#line 30 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (old_value != value) {
#line 30 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		self->priv->_has_active_window = value;
#line 30 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		g_object_notify_by_pspec ((GObject *) self, icon_button_properties[ICON_BUTTON_HAS_ACTIVE_WINDOW_PROPERTY]);
#line 2722 "IconButton.c"
	}
}

static void
_icon_button____lambda27_ (IconButton* self)
{
	Icon* _tmp0_;
#line 88 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp0_ = self->priv->icon;
#line 88 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp0_->waiting = FALSE;
#line 2734 "IconButton.c"
}

static void
__icon_button____lambda27__budgie_application_launch_failed (BudgieApplication* _sender,
                                                             const gchar* startup_notify_id,
                                                             gpointer self)
{
#line 87 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_icon_button____lambda27_ ((IconButton*) self);
#line 2744 "IconButton.c"
}

static void
_icon_button_on_size_allocate_gtk_widget_size_allocate (GtkWidget* _sender,
                                                        GtkAllocation* allocation,
                                                        gpointer self)
{
#line 99 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	icon_button_on_size_allocate ((IconButton*) self, allocation);
#line 2754 "IconButton.c"
}

static GObject *
icon_button_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	IconButton * self;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	Icon* _tmp3_;
	Icon* _tmp4_;
	GtkStyleContext* _tmp5_;
	BudgieApplication* _tmp6_;
	BudgieWindowingWindowGroup* _tmp7_;
	gboolean _tmp8_;
	ButtonPopover* _tmp9_ = NULL;
	ButtonPopover* _tmp10_;
	BudgieApplication* _tmp11_;
	BudgiePopoverManager* _tmp29_;
	ButtonPopover* _tmp30_;
	Icon* _tmp31_;
#line 64 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	parent_class = G_OBJECT_CLASS (icon_button_parent_class);
#line 64 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 64 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ICON_BUTTON, IconButton);
#line 65 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 65 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	gtk_style_context_remove_class (_tmp0_, GTK_STYLE_CLASS_BUTTON);
#line 66 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 66 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	gtk_style_context_remove_class (_tmp1_, "toggle");
#line 67 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 67 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	gtk_style_context_add_class (_tmp2_, "launcher");
#line 69 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	gtk_widget_add_events ((GtkWidget*) self, (gint) GDK_SCROLL_MASK);
#line 71 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	self->priv->definite_allocation.width = 0;
#line 72 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	self->priv->definite_allocation.height = 0;
#line 74 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp3_ = icon_new ();
#line 74 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_object_ref_sink (_tmp3_);
#line 74 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_g_object_unref0 (self->priv->icon);
#line 74 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	self->priv->icon = _tmp3_;
#line 76 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp4_ = self->priv->icon;
#line 76 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
#line 76 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	gtk_style_context_add_class (_tmp5_, "icon");
#line 78 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp6_ = self->priv->_app;
#line 78 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp7_ = self->priv->window_group;
#line 78 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp8_ = self->priv->_pinned;
#line 78 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp9_ = button_popover_new (self, _tmp6_, _tmp7_);
#line 78 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	button_popover_set_pinned (_tmp9_, _tmp8_);
#line 78 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_object_ref_sink (_tmp9_);
#line 78 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_g_object_unref0 (self->priv->popover);
#line 78 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	self->priv->popover = _tmp9_;
#line 82 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp10_ = self->priv->popover;
#line 82 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp10_, "pinned", (GObject*) self, "pinned", G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 84 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp11_ = self->priv->_app;
#line 84 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	if (_tmp11_ != NULL) {
#line 2842 "IconButton.c"
		BudgieApplication* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		BudgieApplication* _tmp15_;
#line 85 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp12_ = self->priv->_app;
#line 85 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp13_ = budgie_application_get_name (_tmp12_);
#line 85 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp14_ = _tmp13_;
#line 85 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp14_);
#line 87 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp15_ = self->priv->_app;
#line 87 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		g_signal_connect_object (_tmp15_, "launch-failed", (GCallback) __icon_button____lambda27__budgie_application_launch_failed, self, G_CONNECT_AFTER);
#line 2859 "IconButton.c"
	} else {
		BudgieWindowingWindowGroup* _tmp16_ = NULL;
		BudgieWindowingWindowGroup* _tmp17_;
		XfwWindow* _tmp18_ = NULL;
		XfwWindow* _tmp20_ = NULL;
		XfwWindow* window = NULL;
		XfwWindow* _tmp25_;
		XfwWindow* _tmp26_;
#line 91 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp17_ = self->priv->window_group;
#line 91 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp16_ = _tmp17_;
#line 91 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp18_ = NULL;
#line 91 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		if (_tmp16_ != NULL) {
#line 2876 "IconButton.c"
			XfwWindow* _tmp19_;
#line 91 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp19_ = budgie_windowing_window_group_get_active_window (_tmp16_);
#line 91 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp18_ = _tmp19_;
#line 2882 "IconButton.c"
		}
#line 91 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp20_ = _tmp18_;
#line 91 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		if (_tmp20_ == NULL) {
#line 2888 "IconButton.c"
			BudgieWindowingWindowGroup* _tmp21_ = NULL;
			BudgieWindowingWindowGroup* _tmp22_;
			XfwWindow* _tmp23_ = NULL;
#line 91 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp22_ = self->priv->window_group;
#line 91 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp21_ = _tmp22_;
#line 91 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp23_ = NULL;
#line 91 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			if (_tmp21_ != NULL) {
#line 2900 "IconButton.c"
				XfwWindow* _tmp24_;
#line 91 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp24_ = budgie_windowing_window_group_get_last_active_window (_tmp21_);
#line 91 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
				_tmp23_ = _tmp24_;
#line 2906 "IconButton.c"
			}
#line 91 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp20_ = _tmp23_;
#line 2910 "IconButton.c"
		}
#line 91 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp25_ = _g_object_ref0 (_tmp20_);
#line 91 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		window = _tmp25_;
#line 92 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_tmp26_ = window;
#line 92 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		if (_tmp26_ != NULL) {
#line 2920 "IconButton.c"
			XfwWindow* _tmp27_;
			const gchar* _tmp28_;
#line 92 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp27_ = window;
#line 92 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			_tmp28_ = xfw_window_get_name (_tmp27_);
#line 92 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
			gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp28_);
#line 2929 "IconButton.c"
		}
#line 84 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		_g_object_unref0 (window);
#line 2933 "IconButton.c"
	}
#line 95 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp29_ = self->priv->_popover_manager;
#line 95 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp30_ = self->priv->popover;
#line 95 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	budgie_popover_manager_register_popover (_tmp29_, (GtkWidget*) self, (GtkPopover*) _tmp30_);
#line 97 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_tmp31_ = self->priv->icon;
#line 97 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp31_);
#line 99 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_signal_connect_object ((GtkWidget*) self, "size-allocate", (GCallback) _icon_button_on_size_allocate_gtk_widget_size_allocate, self, 0);
#line 64 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	return obj;
#line 2949 "IconButton.c"
}

static void
icon_button_class_init (IconButtonClass * klass,
                        gpointer klass_data)
{
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	icon_button_parent_class = g_type_class_peek_parent (klass);
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_type_class_adjust_private_offset (klass, &IconButton_private_offset);
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	((GtkWidgetClass *) klass)->scroll_event = (gboolean (*) (GtkWidget*, GdkEventScroll*)) icon_button_real_scroll_event;
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) icon_button_real_draw;
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget*, gint*, gint*)) icon_button_real_get_preferred_width;
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	((GtkWidgetClass *) klass)->get_preferred_height = (void (*) (GtkWidget*, gint*, gint*)) icon_button_real_get_preferred_height;
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_icon_button_get_property;
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_icon_button_set_property;
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	G_OBJECT_CLASS (klass)->constructor = icon_button_constructor;
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	G_OBJECT_CLASS (klass)->finalize = icon_button_finalize;
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ICON_BUTTON_APP_PROPERTY, icon_button_properties[ICON_BUTTON_APP_PROPERTY] = g_param_spec_object ("app", "app", "app", BUDGIE_TYPE_APPLICATION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ICON_BUTTON_POPOVER_MANAGER_PROPERTY, icon_button_properties[ICON_BUTTON_POPOVER_MANAGER_PROPERTY] = g_param_spec_object ("popover-manager", "popover-manager", "popover-manager", budgie_popover_manager_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ICON_BUTTON_PINNED_PROPERTY, icon_button_properties[ICON_BUTTON_PINNED_PROPERTY] = g_param_spec_boolean ("pinned", "pinned", "pinned", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ICON_BUTTON_HAS_ACTIVE_WINDOW_PROPERTY, icon_button_properties[ICON_BUTTON_HAS_ACTIVE_WINDOW_PROPERTY] = g_param_spec_boolean ("has-active-window", "has-active-window", "has-active-window", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2984 "IconButton.c"
}

static void
icon_button_instance_init (IconButton * self,
                           gpointer klass)
{
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	self->priv = icon_button_get_instance_private (self);
#line 29 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	self->priv->_pinned = FALSE;
#line 30 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	self->priv->_has_active_window = FALSE;
#line 32 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	self->priv->window_group = NULL;
#line 38 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	self->priv->target_icon_size = 0;
#line 39 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	self->priv->panel_size = 0;
#line 44 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	self->priv->last_scroll_time = (gint64) 0;
#line 45 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	self->priv->urgent = FALSE;
#line 3007 "IconButton.c"
}

static void
icon_button_finalize (GObject * obj)
{
	IconButton * self;
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ICON_BUTTON, IconButton);
#line 27 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_g_object_unref0 (self->priv->_app);
#line 32 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_g_object_unref0 (self->priv->window_group);
#line 34 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_g_object_unref0 (self->priv->icon);
#line 35 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	_g_object_unref0 (self->priv->popover);
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	G_OBJECT_CLASS (icon_button_parent_class)->finalize (obj);
#line 3026 "IconButton.c"
}

GType
icon_button_get_type (void)
{
	return icon_button_type_id;
}

GType
icon_button_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (IconButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) icon_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IconButton), 0, (GInstanceInitFunc) icon_button_instance_init, NULL };
	icon_button_type_id = g_type_module_register_type (module, gtk_toggle_button_get_type (), "IconButton", &g_define_type_info, 0);
	IconButton_private_offset = sizeof (IconButtonPrivate);
	return icon_button_type_id;
}

static void
_vala_icon_button_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	IconButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ICON_BUTTON, IconButton);
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	switch (property_id) {
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		case ICON_BUTTON_APP_PROPERTY:
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		g_value_set_object (value, icon_button_get_app (self));
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		break;
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		case ICON_BUTTON_POPOVER_MANAGER_PROPERTY:
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		g_value_set_object (value, icon_button_get_popover_manager (self));
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		break;
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		case ICON_BUTTON_PINNED_PROPERTY:
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		g_value_set_boolean (value, icon_button_get_pinned (self));
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		break;
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		case ICON_BUTTON_HAS_ACTIVE_WINDOW_PROPERTY:
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		g_value_set_boolean (value, icon_button_get_has_active_window (self));
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		break;
#line 3078 "IconButton.c"
		default:
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		break;
#line 3084 "IconButton.c"
	}
}

static void
_vala_icon_button_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	IconButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ICON_BUTTON, IconButton);
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
	switch (property_id) {
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		case ICON_BUTTON_APP_PROPERTY:
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		icon_button_set_app (self, g_value_get_object (value));
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		break;
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		case ICON_BUTTON_POPOVER_MANAGER_PROPERTY:
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		icon_button_set_popover_manager (self, g_value_get_object (value));
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		break;
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		case ICON_BUTTON_PINNED_PROPERTY:
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		icon_button_set_pinned (self, g_value_get_boolean (value));
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		break;
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		case ICON_BUTTON_HAS_ACTIVE_WINDOW_PROPERTY:
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		icon_button_set_has_active_window (self, g_value_get_boolean (value));
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		break;
#line 3122 "IconButton.c"
		default:
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 12 "../src/panel/applets/icon-tasklist/widgets/IconButton.vala"
		break;
#line 3128 "IconButton.c"
	}
}

