/* window_mapper.c generated by valac 0.56.17, the Vala compiler
 * generated from window_mapper.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright © Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include "windowing.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gdesktopappinfo.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <libxfce4windowing/libxfce4windowing.h>
#include <libwnck/libwnck.h>
#include <gdk/gdk.h>
#include <gdk/gdkx.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	BUDGIE_WINDOWING_WINDOW_MAPPER_0_PROPERTY,
	BUDGIE_WINDOWING_WINDOW_MAPPER_NUM_PROPERTIES
};
static GParamSpec* budgie_windowing_window_mapper_properties[BUDGIE_WINDOWING_WINDOW_MAPPER_NUM_PROPERTIES];
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _BudgieWindowingWindowMapperPrivate {
	GHashTable* applications;
	GHashTable* startup_infos;
	GHashTable* simpletons;
	GHashTable* pids;
	GAppInfoMonitor* monitor;
	GDBusConnection* bus;
	gboolean invalidated;
	GRecMutex __lock_invalidated;
};

static gint BudgieWindowingWindowMapper_private_offset;
static gpointer budgie_windowing_window_mapper_parent_class = NULL;

static void budgie_windowing_window_mapper_on_dbus_get (BudgieWindowingWindowMapper* self,
                                                 GObject* object,
                                                 GAsyncResult* res);
static void budgie_windowing_window_mapper_app_launched (BudgieWindowingWindowMapper* self,
                                                  GDBusConnection* conn,
                                                  const gchar* sender,
                                                  const gchar* object_path,
                                                  const gchar* interface_name,
                                                  const gchar* signal_name,
                                                  GVariant* parameters);
static void _budgie_windowing_window_mapper_app_launched_gd_bus_signal_callback (GDBusConnection* connection,
                                                                          const gchar* sender_name,
                                                                          const gchar* object_path,
                                                                          const gchar* interface_name,
                                                                          const gchar* signal_name,
                                                                          GVariant* parameters,
                                                                          gpointer self);
static gint64* _int64_dup (gint64* self);
static void budgie_windowing_window_mapper_check_invalidated (BudgieWindowingWindowMapper* self);
static void budgie_windowing_window_mapper_load_app_infos (BudgieWindowingWindowMapper* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static gchar* budgie_windowing_window_mapper_get_group_name (BudgieWindowingWindowMapper* self,
                                                      XfwWindow* window);
static gchar* budgie_windowing_window_mapper_query_atom_string (BudgieWindowingWindowMapper* self,
                                                         gulong xid,
                                                         GdkAtom atom,
                                                         gboolean utf8);
static GDesktopAppInfo* budgie_windowing_window_mapper_query_simpletons (BudgieWindowingWindowMapper* self,
                                                                  const gchar* name);
static GDesktopAppInfo* budgie_windowing_window_mapper_query_name (BudgieWindowingWindowMapper* self,
                                                            const gchar* name);
static GObject * budgie_windowing_window_mapper_constructor (GType type,
                                                      guint n_construct_properties,
                                                      GObjectConstructParam * construct_properties);
static void _g_free0_ (gpointer var);
static void _budgie_windowing_window_mapper_on_dbus_get_gasync_ready_callback (GObject* source_object,
                                                                        GAsyncResult* res,
                                                                        gpointer self);
static void _budgie_windowing_window_mapper___lambda4_ (BudgieWindowingWindowMapper* self);
static gboolean __lambda5_ (BudgieWindowingWindowMapper* self);
static gboolean ___lambda5__gsource_func (gpointer self);
static void __budgie_windowing_window_mapper___lambda4__g_app_info_monitor_changed (GAppInfoMonitor* _sender,
                                                                             gpointer self);
static void budgie_windowing_window_mapper_finalize (GObject * obj);
static GType budgie_windowing_window_mapper_get_type_once (void);
static gssize _vala_array_length (gpointer array);

static inline gpointer
budgie_windowing_window_mapper_get_instance_private (BudgieWindowingWindowMapper* self)
{
	return G_STRUCT_MEMBER_P (self, BudgieWindowingWindowMapper_private_offset);
}

static void
_budgie_windowing_window_mapper_app_launched_gd_bus_signal_callback (GDBusConnection* connection,
                                                                     const gchar* sender_name,
                                                                     const gchar* object_path,
                                                                     const gchar* interface_name,
                                                                     const gchar* signal_name,
                                                                     GVariant* parameters,
                                                                     gpointer self)
{
#line 60 "../src/windowing/window_mapper.vala"
	budgie_windowing_window_mapper_app_launched ((BudgieWindowingWindowMapper*) self, connection, sender_name, object_path, interface_name, signal_name, parameters);
#line 131 "window_mapper.c"
}

static void
budgie_windowing_window_mapper_on_dbus_get (BudgieWindowingWindowMapper* self,
                                            GObject* object,
                                            GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 56 "../src/windowing/window_mapper.vala"
	g_return_if_fail (self != NULL);
#line 142 "window_mapper.c"
	{
		GDBusConnection* _tmp0_ = NULL;
		GDBusConnection* _tmp1_;
		GDBusConnection* _tmp2_;
		GDBusConnection* _tmp3_;
#line 58 "../src/windowing/window_mapper.vala"
		_tmp1_ = g_bus_get_finish (res, &_inner_error0_);
#line 58 "../src/windowing/window_mapper.vala"
		_tmp0_ = _tmp1_;
#line 58 "../src/windowing/window_mapper.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 154 "window_mapper.c"
			goto __catch0_g_error;
		}
#line 58 "../src/windowing/window_mapper.vala"
		_tmp2_ = _tmp0_;
#line 58 "../src/windowing/window_mapper.vala"
		_tmp0_ = NULL;
#line 58 "../src/windowing/window_mapper.vala"
		_g_object_unref0 (self->priv->bus);
#line 58 "../src/windowing/window_mapper.vala"
		self->priv->bus = _tmp2_;
#line 60 "../src/windowing/window_mapper.vala"
		_tmp3_ = self->priv->bus;
#line 60 "../src/windowing/window_mapper.vala"
		g_dbus_connection_signal_subscribe (_tmp3_, NULL, "org.gtk.gio.DesktopAppInfo", "Launched", "/org/gtk/gio/DesktopAppInfo", NULL, 0, _budgie_windowing_window_mapper_app_launched_gd_bus_signal_callback, g_object_ref (self), g_object_unref);
#line 57 "../src/windowing/window_mapper.vala"
		_g_object_unref0 (_tmp0_);
#line 171 "window_mapper.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 57 "../src/windowing/window_mapper.vala"
		e = _inner_error0_;
#line 57 "../src/windowing/window_mapper.vala"
		_inner_error0_ = NULL;
#line 70 "../src/windowing/window_mapper.vala"
		_tmp4_ = e;
#line 70 "../src/windowing/window_mapper.vala"
		_tmp5_ = _tmp4_->message;
#line 70 "../src/windowing/window_mapper.vala"
		g_critical ("window_mapper.vala:70: Unable to get Session bus: %s", _tmp5_);
#line 57 "../src/windowing/window_mapper.vala"
		_g_error_free0 (e);
#line 191 "window_mapper.c"
	}
	__finally0:
#line 57 "../src/windowing/window_mapper.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 57 "../src/windowing/window_mapper.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 57 "../src/windowing/window_mapper.vala"
		g_clear_error (&_inner_error0_);
#line 57 "../src/windowing/window_mapper.vala"
		return;
#line 202 "window_mapper.c"
	}
}

static gint64*
_int64_dup (gint64* self)
{
	gint64* dup;
#line 91 "../src/windowing/window_mapper.vala"
	dup = g_new0 (gint64, 1);
#line 91 "../src/windowing/window_mapper.vala"
	memcpy (dup, self, sizeof (gint64));
#line 91 "../src/windowing/window_mapper.vala"
	return dup;
#line 216 "window_mapper.c"
}

static gpointer
__int64_dup0 (gpointer self)
{
#line 91 "../src/windowing/window_mapper.vala"
	return self ? _int64_dup (self) : NULL;
#line 224 "window_mapper.c"
}

static void
budgie_windowing_window_mapper_app_launched (BudgieWindowingWindowMapper* self,
                                             GDBusConnection* conn,
                                             const gchar* sender,
                                             const gchar* object_path,
                                             const gchar* interface_name,
                                             const gchar* signal_name,
                                             GVariant* parameters)
{
	GVariant* desktop_variant = NULL;
	gint64 pid = 0LL;
	GVariant* _tmp0_ = NULL;
	gint64 _tmp1_ = 0LL;
	gchar* desktop_file = NULL;
	GVariant* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_ = FALSE;
	const gchar* _tmp6_;
	GHashTable* _tmp7_;
	gint64* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
#line 74 "../src/windowing/window_mapper.vala"
	g_return_if_fail (self != NULL);
#line 74 "../src/windowing/window_mapper.vala"
	g_return_if_fail (conn != NULL);
#line 74 "../src/windowing/window_mapper.vala"
	g_return_if_fail (object_path != NULL);
#line 74 "../src/windowing/window_mapper.vala"
	g_return_if_fail (interface_name != NULL);
#line 74 "../src/windowing/window_mapper.vala"
	g_return_if_fail (signal_name != NULL);
#line 74 "../src/windowing/window_mapper.vala"
	g_return_if_fail (parameters != NULL);
#line 85 "../src/windowing/window_mapper.vala"
	g_variant_get (parameters, "(@aysxas@a{sv})", &_tmp0_, NULL, &_tmp1_, NULL, NULL, NULL);
#line 85 "../src/windowing/window_mapper.vala"
	_g_variant_unref0 (desktop_variant);
#line 85 "../src/windowing/window_mapper.vala"
	desktop_variant = _tmp0_;
#line 85 "../src/windowing/window_mapper.vala"
	pid = _tmp1_;
#line 87 "../src/windowing/window_mapper.vala"
	_tmp2_ = desktop_variant;
#line 87 "../src/windowing/window_mapper.vala"
	_tmp3_ = g_variant_get_bytestring (_tmp2_);
#line 87 "../src/windowing/window_mapper.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 87 "../src/windowing/window_mapper.vala"
	desktop_file = _tmp4_;
#line 89 "../src/windowing/window_mapper.vala"
	_tmp6_ = desktop_file;
#line 89 "../src/windowing/window_mapper.vala"
	if (g_strcmp0 (_tmp6_, "") == 0) {
#line 89 "../src/windowing/window_mapper.vala"
		_tmp5_ = TRUE;
#line 284 "window_mapper.c"
	} else {
#line 89 "../src/windowing/window_mapper.vala"
		_tmp5_ = pid == ((gint64) 0);
#line 288 "window_mapper.c"
	}
#line 89 "../src/windowing/window_mapper.vala"
	if (_tmp5_) {
#line 89 "../src/windowing/window_mapper.vala"
		_g_free0 (desktop_file);
#line 89 "../src/windowing/window_mapper.vala"
		_g_variant_unref0 (desktop_variant);
#line 89 "../src/windowing/window_mapper.vala"
		return;
#line 298 "window_mapper.c"
	}
#line 91 "../src/windowing/window_mapper.vala"
	_tmp7_ = self->priv->pids;
#line 91 "../src/windowing/window_mapper.vala"
	_tmp8_ = __int64_dup0 (&pid);
#line 91 "../src/windowing/window_mapper.vala"
	_tmp9_ = desktop_file;
#line 91 "../src/windowing/window_mapper.vala"
	_tmp10_ = g_strdup (_tmp9_);
#line 91 "../src/windowing/window_mapper.vala"
	g_hash_table_insert (_tmp7_, _tmp8_, _tmp10_);
#line 74 "../src/windowing/window_mapper.vala"
	_g_free0 (desktop_file);
#line 74 "../src/windowing/window_mapper.vala"
	_g_variant_unref0 (desktop_variant);
#line 314 "window_mapper.c"
}

/**
* We lazily check if at some point we became invalidated. In most cases
* a package operation or similar modified a desktop file, i.e. making it
* available or unavailable.
*
* Instead of immediately reloading the appsystem we wait until something
* is actually requested again, check if we're invalidated, reload and then
* set us validated again.
*/
static void
budgie_windowing_window_mapper_check_invalidated (BudgieWindowingWindowMapper* self)
{
	GError* _inner_error0_ = NULL;
#line 103 "../src/windowing/window_mapper.vala"
	g_return_if_fail (self != NULL);
#line 104 "../src/windowing/window_mapper.vala"
	if (self->priv->invalidated) {
#line 334 "window_mapper.c"
		{
#line 105 "../src/windowing/window_mapper.vala"
			g_rec_mutex_lock (&self->priv->__lock_invalidated);
#line 338 "window_mapper.c"
			{
#line 106 "../src/windowing/window_mapper.vala"
				budgie_windowing_window_mapper_load_app_infos (self);
#line 108 "../src/windowing/window_mapper.vala"
				self->priv->invalidated = FALSE;
#line 344 "window_mapper.c"
			}
			__finally0:
			{
#line 105 "../src/windowing/window_mapper.vala"
				g_rec_mutex_unlock (&self->priv->__lock_invalidated);
#line 350 "window_mapper.c"
			}
#line 105 "../src/windowing/window_mapper.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 105 "../src/windowing/window_mapper.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 105 "../src/windowing/window_mapper.vala"
				g_clear_error (&_inner_error0_);
#line 105 "../src/windowing/window_mapper.vala"
				return;
#line 360 "window_mapper.c"
			}
		}
	}
}

/**
* Reload and cache all the desktop IDs.
*/
static gpointer
_g_object_ref0 (gpointer self)
{
#line 121 "../src/windowing/window_mapper.vala"
	return self ? g_object_ref (self) : NULL;
#line 374 "window_mapper.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 121 "../src/windowing/window_mapper.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 382 "window_mapper.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 121 "../src/windowing/window_mapper.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 390 "window_mapper.c"
}

static void
budgie_windowing_window_mapper_load_app_infos (BudgieWindowingWindowMapper* self)
{
	GHashTable* _tmp0_;
	GHashTable* _tmp1_;
	GList* _tmp2_;
#line 116 "../src/windowing/window_mapper.vala"
	g_return_if_fail (self != NULL);
#line 117 "../src/windowing/window_mapper.vala"
	_tmp0_ = self->priv->applications;
#line 117 "../src/windowing/window_mapper.vala"
	g_hash_table_remove_all (_tmp0_);
#line 118 "../src/windowing/window_mapper.vala"
	_tmp1_ = self->priv->startup_infos;
#line 118 "../src/windowing/window_mapper.vala"
	g_hash_table_remove_all (_tmp1_);
#line 121 "../src/windowing/window_mapper.vala"
	_tmp2_ = g_app_info_get_all ();
#line 411 "window_mapper.c"
	{
		GList* app_info_collection = NULL;
		GList* app_info_it = NULL;
#line 121 "../src/windowing/window_mapper.vala"
		app_info_collection = _tmp2_;
#line 121 "../src/windowing/window_mapper.vala"
		for (app_info_it = app_info_collection; app_info_it != NULL; app_info_it = app_info_it->next) {
#line 419 "window_mapper.c"
			GAppInfo* _tmp3_;
			GAppInfo* app_info = NULL;
#line 121 "../src/windowing/window_mapper.vala"
			_tmp3_ = _g_object_ref0 ((GAppInfo*) app_info_it->data);
#line 121 "../src/windowing/window_mapper.vala"
			app_info = _tmp3_;
#line 426 "window_mapper.c"
			{
				GDesktopAppInfo* desktop_info = NULL;
				GAppInfo* _tmp4_;
				GDesktopAppInfo* _tmp5_;
				gchar* desktop_id = NULL;
				GDesktopAppInfo* _tmp6_;
				const gchar* _tmp7_;
				gchar* _tmp8_;
				GDesktopAppInfo* _tmp9_;
				const gchar* _tmp10_;
				GHashTable* _tmp17_;
				const gchar* _tmp18_;
				gchar* _tmp19_;
				GDesktopAppInfo* _tmp20_;
				GDesktopAppInfo* _tmp21_;
#line 122 "../src/windowing/window_mapper.vala"
				_tmp4_ = app_info;
#line 122 "../src/windowing/window_mapper.vala"
				_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, G_TYPE_DESKTOP_APP_INFO) ? ((GDesktopAppInfo*) _tmp4_) : NULL);
#line 122 "../src/windowing/window_mapper.vala"
				desktop_info = _tmp5_;
#line 123 "../src/windowing/window_mapper.vala"
				_tmp6_ = desktop_info;
#line 123 "../src/windowing/window_mapper.vala"
				_tmp7_ = g_app_info_get_id ((GAppInfo*) _tmp6_);
#line 123 "../src/windowing/window_mapper.vala"
				_tmp8_ = g_utf8_strdown (_tmp7_, (gssize) -1);
#line 123 "../src/windowing/window_mapper.vala"
				desktop_id = _tmp8_;
#line 125 "../src/windowing/window_mapper.vala"
				_tmp9_ = desktop_info;
#line 125 "../src/windowing/window_mapper.vala"
				_tmp10_ = g_desktop_app_info_get_startup_wm_class (_tmp9_);
#line 125 "../src/windowing/window_mapper.vala"
				if (_tmp10_ != NULL) {
#line 462 "window_mapper.c"
					GHashTable* _tmp11_;
					GDesktopAppInfo* _tmp12_;
					const gchar* _tmp13_;
					gchar* _tmp14_;
					GDesktopAppInfo* _tmp15_;
					GDesktopAppInfo* _tmp16_;
#line 126 "../src/windowing/window_mapper.vala"
					_tmp11_ = self->priv->startup_infos;
#line 126 "../src/windowing/window_mapper.vala"
					_tmp12_ = desktop_info;
#line 126 "../src/windowing/window_mapper.vala"
					_tmp13_ = g_desktop_app_info_get_startup_wm_class (_tmp12_);
#line 126 "../src/windowing/window_mapper.vala"
					_tmp14_ = g_utf8_strdown (_tmp13_, (gssize) -1);
#line 126 "../src/windowing/window_mapper.vala"
					_tmp15_ = desktop_info;
#line 126 "../src/windowing/window_mapper.vala"
					_tmp16_ = _g_object_ref0 (_tmp15_);
#line 126 "../src/windowing/window_mapper.vala"
					g_hash_table_insert (_tmp11_, _tmp14_, _tmp16_);
#line 483 "window_mapper.c"
				}
#line 129 "../src/windowing/window_mapper.vala"
				_tmp17_ = self->priv->applications;
#line 129 "../src/windowing/window_mapper.vala"
				_tmp18_ = desktop_id;
#line 129 "../src/windowing/window_mapper.vala"
				_tmp19_ = g_strdup (_tmp18_);
#line 129 "../src/windowing/window_mapper.vala"
				_tmp20_ = desktop_info;
#line 129 "../src/windowing/window_mapper.vala"
				_tmp21_ = _g_object_ref0 (_tmp20_);
#line 129 "../src/windowing/window_mapper.vala"
				g_hash_table_insert (_tmp17_, _tmp19_, _tmp21_);
#line 121 "../src/windowing/window_mapper.vala"
				_g_free0 (desktop_id);
#line 121 "../src/windowing/window_mapper.vala"
				_g_object_unref0 (desktop_info);
#line 121 "../src/windowing/window_mapper.vala"
				_g_object_unref0 (app_info);
#line 503 "window_mapper.c"
			}
		}
#line 121 "../src/windowing/window_mapper.vala"
		(app_info_collection == NULL) ? NULL : (app_info_collection = (_g_list_free__g_object_unref0_ (app_info_collection), NULL));
#line 508 "window_mapper.c"
	}
}

/**
 * Try to get application group from its WM_CLASS property or fallback to using
 * the app name when WM_CLASS isn't set (e.g. LibreOffice, Google Chrome, Android Studio emulator, maybe others)
 */
static gchar*
budgie_windowing_window_mapper_get_group_name (BudgieWindowingWindowMapper* self,
                                               XfwWindow* window)
{
	WnckWindow* wnck_window = NULL;
	WnckWindow* _tmp6_;
	gchar* name = NULL;
	WnckWindow* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gboolean _tmp10_ = FALSE;
	const gchar* _tmp11_;
	gboolean _tmp16_ = FALSE;
	const gchar* _tmp17_;
	const gchar* _tmp21_;
	const gchar* _tmp24_;
	gchar* result;
#line 137 "../src/windowing/window_mapper.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 137 "../src/windowing/window_mapper.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 138 "../src/windowing/window_mapper.vala"
	if (xfw_windowing_get () == XFW_WINDOWING_WAYLAND) {
#line 539 "window_mapper.c"
		const gchar* _tmp0_ = NULL;
		gchar** _tmp1_;
		gchar** _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp5_;
#line 139 "../src/windowing/window_mapper.vala"
		_tmp2_ = _tmp1_ = xfw_window_get_class_ids (window);
#line 139 "../src/windowing/window_mapper.vala"
		_tmp3_ = _tmp2_[0];
#line 139 "../src/windowing/window_mapper.vala"
		_tmp0_ = _tmp3_;
#line 139 "../src/windowing/window_mapper.vala"
		if (_tmp0_ == NULL) {
#line 553 "window_mapper.c"
			const gchar* _tmp4_;
#line 139 "../src/windowing/window_mapper.vala"
			_tmp4_ = xfw_window_get_name (window);
#line 139 "../src/windowing/window_mapper.vala"
			_tmp0_ = _tmp4_;
#line 559 "window_mapper.c"
		}
#line 139 "../src/windowing/window_mapper.vala"
		_tmp5_ = g_strdup (_tmp0_);
#line 139 "../src/windowing/window_mapper.vala"
		result = _tmp5_;
#line 139 "../src/windowing/window_mapper.vala"
		return result;
#line 567 "window_mapper.c"
	}
#line 143 "../src/windowing/window_mapper.vala"
	_tmp6_ = wnck_window_get ((gulong) xfw_window_x11_get_xid (window));
#line 143 "../src/windowing/window_mapper.vala"
	wnck_window = _tmp6_;
#line 147 "../src/windowing/window_mapper.vala"
	_tmp7_ = wnck_window;
#line 147 "../src/windowing/window_mapper.vala"
	_tmp8_ = wnck_window_get_class_group_name (_tmp7_);
#line 147 "../src/windowing/window_mapper.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 147 "../src/windowing/window_mapper.vala"
	name = _tmp9_;
#line 152 "../src/windowing/window_mapper.vala"
	_tmp11_ = name;
#line 152 "../src/windowing/window_mapper.vala"
	if (_tmp11_ == NULL) {
#line 152 "../src/windowing/window_mapper.vala"
		_tmp10_ = TRUE;
#line 587 "window_mapper.c"
	} else {
		const gchar* _tmp12_;
#line 152 "../src/windowing/window_mapper.vala"
		_tmp12_ = name;
#line 152 "../src/windowing/window_mapper.vala"
		_tmp10_ = g_strcmp0 (_tmp12_, "") == 0;
#line 594 "window_mapper.c"
	}
#line 152 "../src/windowing/window_mapper.vala"
	if (_tmp10_) {
#line 598 "window_mapper.c"
		WnckWindow* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
#line 153 "../src/windowing/window_mapper.vala"
		_tmp13_ = wnck_window;
#line 153 "../src/windowing/window_mapper.vala"
		_tmp14_ = wnck_window_get_class_instance_name (_tmp13_);
#line 153 "../src/windowing/window_mapper.vala"
		_tmp15_ = g_strdup (_tmp14_);
#line 153 "../src/windowing/window_mapper.vala"
		_g_free0 (name);
#line 153 "../src/windowing/window_mapper.vala"
		name = _tmp15_;
#line 612 "window_mapper.c"
	}
#line 158 "../src/windowing/window_mapper.vala"
	_tmp17_ = name;
#line 158 "../src/windowing/window_mapper.vala"
	if (_tmp17_ == NULL) {
#line 158 "../src/windowing/window_mapper.vala"
		_tmp16_ = TRUE;
#line 620 "window_mapper.c"
	} else {
		const gchar* _tmp18_;
#line 158 "../src/windowing/window_mapper.vala"
		_tmp18_ = name;
#line 158 "../src/windowing/window_mapper.vala"
		_tmp16_ = g_strcmp0 (_tmp18_, "") == 0;
#line 627 "window_mapper.c"
	}
#line 158 "../src/windowing/window_mapper.vala"
	if (_tmp16_) {
#line 631 "window_mapper.c"
		const gchar* _tmp19_;
		gchar* _tmp20_;
#line 159 "../src/windowing/window_mapper.vala"
		_tmp19_ = xfw_window_get_name (window);
#line 159 "../src/windowing/window_mapper.vala"
		_tmp20_ = g_strdup (_tmp19_);
#line 159 "../src/windowing/window_mapper.vala"
		_g_free0 (name);
#line 159 "../src/windowing/window_mapper.vala"
		name = _tmp20_;
#line 642 "window_mapper.c"
	}
#line 162 "../src/windowing/window_mapper.vala"
	_tmp21_ = name;
#line 162 "../src/windowing/window_mapper.vala"
	if (_tmp21_ != NULL) {
#line 648 "window_mapper.c"
		const gchar* _tmp22_;
		gchar* _tmp23_;
#line 163 "../src/windowing/window_mapper.vala"
		_tmp22_ = name;
#line 163 "../src/windowing/window_mapper.vala"
		_tmp23_ = g_utf8_strdown (_tmp22_, (gssize) -1);
#line 163 "../src/windowing/window_mapper.vala"
		_g_free0 (name);
#line 163 "../src/windowing/window_mapper.vala"
		name = _tmp23_;
#line 659 "window_mapper.c"
	}
#line 170 "../src/windowing/window_mapper.vala"
	_tmp24_ = name;
#line 170 "../src/windowing/window_mapper.vala"
	if (g_strcmp0 (_tmp24_, "google chrome") == 0) {
#line 665 "window_mapper.c"
		gchar* _tmp25_;
#line 171 "../src/windowing/window_mapper.vala"
		_tmp25_ = g_strdup ("google-chrome");
#line 171 "../src/windowing/window_mapper.vala"
		_g_free0 (name);
#line 171 "../src/windowing/window_mapper.vala"
		name = _tmp25_;
#line 673 "window_mapper.c"
	}
#line 174 "../src/windowing/window_mapper.vala"
	result = name;
#line 174 "../src/windowing/window_mapper.vala"
	return result;
#line 679 "window_mapper.c"
}

static gchar*
budgie_windowing_window_mapper_query_atom_string (BudgieWindowingWindowMapper* self,
                                                  gulong xid,
                                                  GdkAtom atom,
                                                  gboolean utf8)
{
	guint8* data = NULL;
	gint data_length1;
	gint _data_size_;
	GdkAtom type = (GdkAtom) 0U;
	gint format = 0;
	GdkX11Display* display = NULL;
	GdkDisplay* _tmp0_;
	GdkX11Display* _tmp1_;
	GdkAtom req_type = (GdkAtom) 0U;
	GdkWindow* foreign = NULL;
	GdkX11Display* _tmp2_;
	GdkX11Window* _tmp3_;
	GdkWindow* _tmp4_;
	GdkWindow* _tmp5_;
	GdkAtom _tmp6_ = (GdkAtom) 0U;
	gint _tmp7_ = 0;
	guint8* _tmp8_ = NULL;
	gint _tmp9_ = 0;
	const gchar* _tmp10_ = NULL;
	guint8* _tmp11_;
	gint _tmp11__length1;
	gchar* _tmp13_;
	gchar* result;
#line 177 "../src/windowing/window_mapper.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 178 "../src/windowing/window_mapper.vala"
	data = NULL;
#line 178 "../src/windowing/window_mapper.vala"
	data_length1 = 0;
#line 178 "../src/windowing/window_mapper.vala"
	_data_size_ = data_length1;
#line 181 "../src/windowing/window_mapper.vala"
	_tmp0_ = gdk_display_get_default ();
#line 181 "../src/windowing/window_mapper.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gdk_x11_display_get_type (), GdkX11Display));
#line 181 "../src/windowing/window_mapper.vala"
	display = _tmp1_;
#line 185 "../src/windowing/window_mapper.vala"
	if (utf8) {
#line 186 "../src/windowing/window_mapper.vala"
		req_type = gdk_atom_intern ("UTF8_STRING", FALSE);
#line 729 "window_mapper.c"
	} else {
#line 188 "../src/windowing/window_mapper.vala"
		req_type = gdk_atom_intern ("STRING", FALSE);
#line 733 "window_mapper.c"
	}
#line 192 "../src/windowing/window_mapper.vala"
	_tmp2_ = display;
#line 192 "../src/windowing/window_mapper.vala"
	_tmp3_ = (GdkX11Window*) gdk_x11_window_foreign_new_for_display (_tmp2_, (Window) xid);
#line 192 "../src/windowing/window_mapper.vala"
	foreign = (GdkWindow*) _tmp3_;
#line 195 "../src/windowing/window_mapper.vala"
	_tmp4_ = foreign;
#line 195 "../src/windowing/window_mapper.vala"
	if (_tmp4_ == NULL) {
#line 195 "../src/windowing/window_mapper.vala"
		result = NULL;
#line 195 "../src/windowing/window_mapper.vala"
		_g_object_unref0 (foreign);
#line 195 "../src/windowing/window_mapper.vala"
		_g_object_unref0 (display);
#line 195 "../src/windowing/window_mapper.vala"
		data = (g_free (data), NULL);
#line 195 "../src/windowing/window_mapper.vala"
		return result;
#line 755 "window_mapper.c"
	}
#line 198 "../src/windowing/window_mapper.vala"
	_tmp5_ = foreign;
#line 198 "../src/windowing/window_mapper.vala"
	gdk_property_get (_tmp5_, atom, req_type, (gulong) 0, (gulong) G_MAXLONG, 0, &_tmp6_, &_tmp7_, &_tmp9_, &_tmp8_);
#line 198 "../src/windowing/window_mapper.vala"
	type = _tmp6_;
#line 198 "../src/windowing/window_mapper.vala"
	format = _tmp7_;
#line 198 "../src/windowing/window_mapper.vala"
	data = (g_free (data), NULL);
#line 198 "../src/windowing/window_mapper.vala"
	data = _tmp8_;
#line 198 "../src/windowing/window_mapper.vala"
	data_length1 = _tmp9_;
#line 198 "../src/windowing/window_mapper.vala"
	_data_size_ = data_length1;
#line 210 "../src/windowing/window_mapper.vala"
	_tmp11_ = data;
#line 210 "../src/windowing/window_mapper.vala"
	_tmp11__length1 = data_length1;
#line 210 "../src/windowing/window_mapper.vala"
	if (_tmp11_ != NULL) {
#line 779 "window_mapper.c"
		guint8* _tmp12_;
		gint _tmp12__length1;
#line 210 "../src/windowing/window_mapper.vala"
		_tmp12_ = data;
#line 210 "../src/windowing/window_mapper.vala"
		_tmp12__length1 = data_length1;
#line 210 "../src/windowing/window_mapper.vala"
		_tmp10_ = (const gchar*) _tmp12_;
#line 788 "window_mapper.c"
	} else {
#line 210 "../src/windowing/window_mapper.vala"
		_tmp10_ = NULL;
#line 792 "window_mapper.c"
	}
#line 210 "../src/windowing/window_mapper.vala"
	_tmp13_ = g_strdup (_tmp10_);
#line 210 "../src/windowing/window_mapper.vala"
	result = _tmp13_;
#line 210 "../src/windowing/window_mapper.vala"
	_g_object_unref0 (foreign);
#line 210 "../src/windowing/window_mapper.vala"
	_g_object_unref0 (display);
#line 210 "../src/windowing/window_mapper.vala"
	data = (g_free (data), NULL);
#line 210 "../src/windowing/window_mapper.vala"
	return result;
#line 806 "window_mapper.c"
}

/**
 * Try to get the DesktopAppInfo for a name by looking at our
 * list of simpletons. This function also tries some special
 * cases to try to get the correct match.
 */
static GDesktopAppInfo*
budgie_windowing_window_mapper_query_simpletons (BudgieWindowingWindowMapper* self,
                                                 const gchar* name)
{
	GDesktopAppInfo* info = NULL;
	gchar* desktop_name = NULL;
	GHashTable* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	GDesktopAppInfo* _tmp21_;
	GDesktopAppInfo* result;
#line 218 "../src/windowing/window_mapper.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 218 "../src/windowing/window_mapper.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 219 "../src/windowing/window_mapper.vala"
	info = NULL;
#line 220 "../src/windowing/window_mapper.vala"
	desktop_name = NULL;
#line 223 "../src/windowing/window_mapper.vala"
	_tmp0_ = self->priv->simpletons;
#line 223 "../src/windowing/window_mapper.vala"
	_tmp1_ = g_utf8_strdown (name, (gssize) -1);
#line 223 "../src/windowing/window_mapper.vala"
	_tmp2_ = _tmp1_;
#line 223 "../src/windowing/window_mapper.vala"
	_tmp3_ = g_hash_table_contains (_tmp0_, _tmp2_);
#line 223 "../src/windowing/window_mapper.vala"
	_g_free0 (_tmp2_);
#line 223 "../src/windowing/window_mapper.vala"
	if (_tmp3_) {
#line 846 "window_mapper.c"
		GHashTable* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gconstpointer _tmp7_;
		gchar* _tmp8_;
		GHashTable* _tmp9_;
		const gchar* _tmp10_;
#line 224 "../src/windowing/window_mapper.vala"
		_tmp4_ = self->priv->simpletons;
#line 224 "../src/windowing/window_mapper.vala"
		_tmp5_ = g_utf8_strdown (name, (gssize) -1);
#line 224 "../src/windowing/window_mapper.vala"
		_tmp6_ = _tmp5_;
#line 224 "../src/windowing/window_mapper.vala"
		_tmp7_ = g_hash_table_lookup (_tmp4_, _tmp6_);
#line 224 "../src/windowing/window_mapper.vala"
		_tmp8_ = g_strconcat ((const gchar*) _tmp7_, ".desktop", NULL);
#line 224 "../src/windowing/window_mapper.vala"
		_g_free0 (desktop_name);
#line 224 "../src/windowing/window_mapper.vala"
		desktop_name = _tmp8_;
#line 224 "../src/windowing/window_mapper.vala"
		_g_free0 (_tmp6_);
#line 226 "../src/windowing/window_mapper.vala"
		_tmp9_ = self->priv->applications;
#line 226 "../src/windowing/window_mapper.vala"
		_tmp10_ = desktop_name;
#line 226 "../src/windowing/window_mapper.vala"
		if (g_hash_table_contains (_tmp9_, _tmp10_)) {
#line 876 "window_mapper.c"
			GHashTable* _tmp11_;
			const gchar* _tmp12_;
			gconstpointer _tmp13_;
			GDesktopAppInfo* _tmp14_;
#line 227 "../src/windowing/window_mapper.vala"
			_tmp11_ = self->priv->applications;
#line 227 "../src/windowing/window_mapper.vala"
			_tmp12_ = desktop_name;
#line 227 "../src/windowing/window_mapper.vala"
			_tmp13_ = g_hash_table_lookup (_tmp11_, _tmp12_);
#line 227 "../src/windowing/window_mapper.vala"
			_tmp14_ = _g_object_ref0 ((GDesktopAppInfo*) _tmp13_);
#line 227 "../src/windowing/window_mapper.vala"
			_g_object_unref0 (info);
#line 227 "../src/windowing/window_mapper.vala"
			info = _tmp14_;
#line 893 "window_mapper.c"
		} else {
			GHashTable* _tmp15_;
			const gchar* _tmp16_;
#line 228 "../src/windowing/window_mapper.vala"
			_tmp15_ = self->priv->startup_infos;
#line 228 "../src/windowing/window_mapper.vala"
			_tmp16_ = desktop_name;
#line 228 "../src/windowing/window_mapper.vala"
			if (g_hash_table_contains (_tmp15_, _tmp16_)) {
#line 903 "window_mapper.c"
				GHashTable* _tmp17_;
				const gchar* _tmp18_;
				gconstpointer _tmp19_;
				GDesktopAppInfo* _tmp20_;
#line 229 "../src/windowing/window_mapper.vala"
				_tmp17_ = self->priv->startup_infos;
#line 229 "../src/windowing/window_mapper.vala"
				_tmp18_ = desktop_name;
#line 229 "../src/windowing/window_mapper.vala"
				_tmp19_ = g_hash_table_lookup (_tmp17_, _tmp18_);
#line 229 "../src/windowing/window_mapper.vala"
				_tmp20_ = _g_object_ref0 ((GDesktopAppInfo*) _tmp19_);
#line 229 "../src/windowing/window_mapper.vala"
				_g_object_unref0 (info);
#line 229 "../src/windowing/window_mapper.vala"
				info = _tmp20_;
#line 920 "window_mapper.c"
			}
		}
	}
#line 234 "../src/windowing/window_mapper.vala"
	_tmp21_ = info;
#line 234 "../src/windowing/window_mapper.vala"
	if (_tmp21_ == NULL) {
#line 928 "window_mapper.c"
		const gchar* _tmp22_;
		GQuark _tmp24_ = 0U;
#line 235 "../src/windowing/window_mapper.vala"
		static GQuark _tmp23_label0 = 0;
#line 235 "../src/windowing/window_mapper.vala"
		static GQuark _tmp23_label1 = 0;
#line 235 "../src/windowing/window_mapper.vala"
		_tmp22_ = name;
#line 235 "../src/windowing/window_mapper.vala"
		_tmp24_ = (NULL == _tmp22_) ? 0 : g_quark_from_string (_tmp22_);
#line 235 "../src/windowing/window_mapper.vala"
		if (_tmp24_ == ((0 != _tmp23_label0) ? _tmp23_label0 : (_tmp23_label0 = g_quark_from_static_string ("google-chrome")))) {
#line 235 "../src/windowing/window_mapper.vala"
			switch (0) {
#line 943 "window_mapper.c"
				default:
				{
					gchar* _tmp25_;
					const gchar* _tmp26_;
					gchar* _tmp27_;
					gchar* _tmp28_;
					GDesktopAppInfo* _tmp29_;
#line 237 "../src/windowing/window_mapper.vala"
					_tmp25_ = g_strdup ("com.google.Chrome");
#line 237 "../src/windowing/window_mapper.vala"
					_g_free0 (desktop_name);
#line 237 "../src/windowing/window_mapper.vala"
					desktop_name = _tmp25_;
#line 238 "../src/windowing/window_mapper.vala"
					_tmp26_ = desktop_name;
#line 238 "../src/windowing/window_mapper.vala"
					_tmp27_ = g_strconcat (_tmp26_, ".desktop", NULL);
#line 238 "../src/windowing/window_mapper.vala"
					_tmp28_ = _tmp27_;
#line 238 "../src/windowing/window_mapper.vala"
					_tmp29_ = g_desktop_app_info_new (_tmp28_);
#line 238 "../src/windowing/window_mapper.vala"
					_g_object_unref0 (info);
#line 238 "../src/windowing/window_mapper.vala"
					info = _tmp29_;
#line 238 "../src/windowing/window_mapper.vala"
					_g_free0 (_tmp28_);
#line 239 "../src/windowing/window_mapper.vala"
					break;
#line 973 "window_mapper.c"
				}
			}
		} else if (_tmp24_ == ((0 != _tmp23_label1) ? _tmp23_label1 : (_tmp23_label1 = g_quark_from_static_string ("google-chrome-unstable")))) {
#line 235 "../src/windowing/window_mapper.vala"
			switch (0) {
#line 979 "window_mapper.c"
				default:
				{
					gchar* _tmp30_;
					const gchar* _tmp31_;
					gchar* _tmp32_;
					gchar* _tmp33_;
					GDesktopAppInfo* _tmp34_;
#line 241 "../src/windowing/window_mapper.vala"
					_tmp30_ = g_strdup ("com.google.ChromeDev");
#line 241 "../src/windowing/window_mapper.vala"
					_g_free0 (desktop_name);
#line 241 "../src/windowing/window_mapper.vala"
					desktop_name = _tmp30_;
#line 242 "../src/windowing/window_mapper.vala"
					_tmp31_ = desktop_name;
#line 242 "../src/windowing/window_mapper.vala"
					_tmp32_ = g_strconcat (_tmp31_, ".desktop", NULL);
#line 242 "../src/windowing/window_mapper.vala"
					_tmp33_ = _tmp32_;
#line 242 "../src/windowing/window_mapper.vala"
					_tmp34_ = g_desktop_app_info_new (_tmp33_);
#line 242 "../src/windowing/window_mapper.vala"
					_g_object_unref0 (info);
#line 242 "../src/windowing/window_mapper.vala"
					info = _tmp34_;
#line 242 "../src/windowing/window_mapper.vala"
					_g_free0 (_tmp33_);
#line 243 "../src/windowing/window_mapper.vala"
					break;
#line 1009 "window_mapper.c"
				}
			}
		} else {
#line 235 "../src/windowing/window_mapper.vala"
			switch (0) {
#line 1015 "window_mapper.c"
				default:
				{
#line 245 "../src/windowing/window_mapper.vala"
					break;
#line 1020 "window_mapper.c"
				}
			}
		}
	}
#line 249 "../src/windowing/window_mapper.vala"
	result = info;
#line 249 "../src/windowing/window_mapper.vala"
	_g_free0 (desktop_name);
#line 249 "../src/windowing/window_mapper.vala"
	return result;
#line 1031 "window_mapper.c"
}

/**
 * Try to get the DesktopAppInfo for a name. The name used
 * is generally the window's class group name or instance name.
 *
 * The function looks at our started applications and cached
 * applications. If both of those fail, then it looks at
 * the simpleton applications.
 */
static GDesktopAppInfo*
budgie_windowing_window_mapper_query_name (BudgieWindowingWindowMapper* self,
                                           const gchar* name)
{
	GHashTable* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	GHashTable* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gboolean _tmp15_;
	GDesktopAppInfo* simpleton = NULL;
	GDesktopAppInfo* _tmp24_;
	GDesktopAppInfo* _tmp25_;
	GDesktopAppInfo* result;
#line 260 "../src/windowing/window_mapper.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 260 "../src/windowing/window_mapper.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 261 "../src/windowing/window_mapper.vala"
	_tmp0_ = self->priv->startup_infos;
#line 261 "../src/windowing/window_mapper.vala"
	_tmp1_ = g_utf8_strdown (name, (gssize) -1);
#line 261 "../src/windowing/window_mapper.vala"
	_tmp2_ = _tmp1_;
#line 261 "../src/windowing/window_mapper.vala"
	_tmp3_ = g_hash_table_contains (_tmp0_, _tmp2_);
#line 261 "../src/windowing/window_mapper.vala"
	_g_free0 (_tmp2_);
#line 261 "../src/windowing/window_mapper.vala"
	if (_tmp3_) {
#line 1076 "window_mapper.c"
		GHashTable* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gconstpointer _tmp7_;
		GDesktopAppInfo* _tmp8_;
		GDesktopAppInfo* _tmp9_;
#line 262 "../src/windowing/window_mapper.vala"
		_tmp4_ = self->priv->startup_infos;
#line 262 "../src/windowing/window_mapper.vala"
		_tmp5_ = g_utf8_strdown (name, (gssize) -1);
#line 262 "../src/windowing/window_mapper.vala"
		_tmp6_ = _tmp5_;
#line 262 "../src/windowing/window_mapper.vala"
		_tmp7_ = g_hash_table_lookup (_tmp4_, _tmp6_);
#line 262 "../src/windowing/window_mapper.vala"
		_tmp8_ = _g_object_ref0 ((GDesktopAppInfo*) _tmp7_);
#line 262 "../src/windowing/window_mapper.vala"
		_tmp9_ = _tmp8_;
#line 262 "../src/windowing/window_mapper.vala"
		_g_free0 (_tmp6_);
#line 262 "../src/windowing/window_mapper.vala"
		result = _tmp9_;
#line 262 "../src/windowing/window_mapper.vala"
		return result;
#line 1101 "window_mapper.c"
	}
#line 265 "../src/windowing/window_mapper.vala"
	_tmp10_ = self->priv->applications;
#line 265 "../src/windowing/window_mapper.vala"
	_tmp11_ = g_utf8_strdown (name, (gssize) -1);
#line 265 "../src/windowing/window_mapper.vala"
	_tmp12_ = _tmp11_;
#line 265 "../src/windowing/window_mapper.vala"
	_tmp13_ = g_strconcat (_tmp12_, ".desktop", NULL);
#line 265 "../src/windowing/window_mapper.vala"
	_tmp14_ = _tmp13_;
#line 265 "../src/windowing/window_mapper.vala"
	_tmp15_ = g_hash_table_contains (_tmp10_, _tmp14_);
#line 265 "../src/windowing/window_mapper.vala"
	_g_free0 (_tmp14_);
#line 265 "../src/windowing/window_mapper.vala"
	_g_free0 (_tmp12_);
#line 265 "../src/windowing/window_mapper.vala"
	if (_tmp15_) {
#line 1121 "window_mapper.c"
		GHashTable* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gconstpointer _tmp21_;
		GDesktopAppInfo* _tmp22_;
		GDesktopAppInfo* _tmp23_;
#line 266 "../src/windowing/window_mapper.vala"
		_tmp16_ = self->priv->applications;
#line 266 "../src/windowing/window_mapper.vala"
		_tmp17_ = g_utf8_strdown (name, (gssize) -1);
#line 266 "../src/windowing/window_mapper.vala"
		_tmp18_ = _tmp17_;
#line 266 "../src/windowing/window_mapper.vala"
		_tmp19_ = g_strconcat (_tmp18_, ".desktop", NULL);
#line 266 "../src/windowing/window_mapper.vala"
		_tmp20_ = _tmp19_;
#line 266 "../src/windowing/window_mapper.vala"
		_tmp21_ = g_hash_table_lookup (_tmp16_, _tmp20_);
#line 266 "../src/windowing/window_mapper.vala"
		_tmp22_ = _g_object_ref0 ((GDesktopAppInfo*) _tmp21_);
#line 266 "../src/windowing/window_mapper.vala"
		_tmp23_ = _tmp22_;
#line 266 "../src/windowing/window_mapper.vala"
		_g_free0 (_tmp20_);
#line 266 "../src/windowing/window_mapper.vala"
		_g_free0 (_tmp18_);
#line 266 "../src/windowing/window_mapper.vala"
		result = _tmp23_;
#line 266 "../src/windowing/window_mapper.vala"
		return result;
#line 1154 "window_mapper.c"
	}
#line 269 "../src/windowing/window_mapper.vala"
	_tmp24_ = budgie_windowing_window_mapper_query_simpletons (self, name);
#line 269 "../src/windowing/window_mapper.vala"
	simpleton = _tmp24_;
#line 271 "../src/windowing/window_mapper.vala"
	_tmp25_ = simpleton;
#line 271 "../src/windowing/window_mapper.vala"
	if (_tmp25_ != NULL) {
#line 272 "../src/windowing/window_mapper.vala"
		result = simpleton;
#line 272 "../src/windowing/window_mapper.vala"
		return result;
#line 1168 "window_mapper.c"
	}
#line 275 "../src/windowing/window_mapper.vala"
	result = NULL;
#line 275 "../src/windowing/window_mapper.vala"
	_g_object_unref0 (simpleton);
#line 275 "../src/windowing/window_mapper.vala"
	return result;
#line 1176 "window_mapper.c"
}

/**
* Attempt to gain the DesktopAppInfo relating to a given window.
*/
GDesktopAppInfo*
budgie_windowing_window_mapper_query_window (BudgieWindowingWindowMapper* self,
                                             XfwWindow* window)
{
	XfwApplicationInstance* instance = NULL;
	XfwApplication* _tmp0_;
	XfwApplication* _tmp1_;
	XfwApplication* _tmp2_;
	XfwApplicationInstance* _tmp3_;
	XfwApplicationInstance* _tmp4_;
	XfwApplicationInstance* _tmp5_;
	gint pid = 0;
	XfwApplicationInstance* _tmp6_;
	GHashTable* _tmp7_;
	gint64 _tmp8_;
	gchar* gtk_id = NULL;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	WnckWindow* wnck_window = NULL;
	WnckWindow* _tmp28_;
	gchar* class_group_name = NULL;
	WnckWindow* _tmp29_;
	const gchar* _tmp30_;
	gchar* _tmp31_;
	const gchar* _tmp32_;
	const gchar* _tmp34_;
	const gchar* instance_name = NULL;
	WnckWindow* _tmp38_;
	const gchar* _tmp39_;
	const gchar* _tmp40_;
	GDesktopAppInfo* result;
#line 281 "../src/windowing/window_mapper.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 281 "../src/windowing/window_mapper.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 282 "../src/windowing/window_mapper.vala"
	g_object_get (window, "application", &_tmp0_, NULL);
#line 282 "../src/windowing/window_mapper.vala"
	_tmp1_ = _tmp0_;
#line 282 "../src/windowing/window_mapper.vala"
	_tmp2_ = _tmp1_;
#line 282 "../src/windowing/window_mapper.vala"
	_tmp3_ = xfw_application_get_instance (_tmp2_, window);
#line 282 "../src/windowing/window_mapper.vala"
	_tmp4_ = _tmp3_;
#line 282 "../src/windowing/window_mapper.vala"
	_g_object_unref0 (_tmp2_);
#line 282 "../src/windowing/window_mapper.vala"
	instance = _tmp4_;
#line 284 "../src/windowing/window_mapper.vala"
	_tmp5_ = instance;
#line 284 "../src/windowing/window_mapper.vala"
	if (_tmp5_ == NULL) {
#line 284 "../src/windowing/window_mapper.vala"
		result = NULL;
#line 284 "../src/windowing/window_mapper.vala"
		return result;
#line 1239 "window_mapper.c"
	}
#line 286 "../src/windowing/window_mapper.vala"
	_tmp6_ = instance;
#line 286 "../src/windowing/window_mapper.vala"
	pid = xfw_application_instance_get_pid (_tmp6_);
#line 289 "../src/windowing/window_mapper.vala"
	_tmp7_ = self->priv->pids;
#line 289 "../src/windowing/window_mapper.vala"
	_tmp8_ = (gint64) pid;
#line 289 "../src/windowing/window_mapper.vala"
	if (g_hash_table_contains (_tmp7_, &_tmp8_)) {
#line 1251 "window_mapper.c"
		gchar* file_name = NULL;
		GHashTable* _tmp9_;
		gint64 _tmp10_;
		gconstpointer _tmp11_;
		gchar* _tmp12_;
		const gchar* _tmp13_;
		GDesktopAppInfo* _tmp14_;
#line 290 "../src/windowing/window_mapper.vala"
		_tmp9_ = self->priv->pids;
#line 290 "../src/windowing/window_mapper.vala"
		_tmp10_ = (gint64) pid;
#line 290 "../src/windowing/window_mapper.vala"
		_tmp11_ = g_hash_table_lookup (_tmp9_, &_tmp10_);
#line 290 "../src/windowing/window_mapper.vala"
		_tmp12_ = g_strdup ((const gchar*) _tmp11_);
#line 290 "../src/windowing/window_mapper.vala"
		file_name = _tmp12_;
#line 292 "../src/windowing/window_mapper.vala"
		_tmp13_ = file_name;
#line 292 "../src/windowing/window_mapper.vala"
		_tmp14_ = g_desktop_app_info_new_from_filename (_tmp13_);
#line 292 "../src/windowing/window_mapper.vala"
		result = _tmp14_;
#line 292 "../src/windowing/window_mapper.vala"
		_g_free0 (file_name);
#line 292 "../src/windowing/window_mapper.vala"
		return result;
#line 1279 "window_mapper.c"
	}
#line 296 "../src/windowing/window_mapper.vala"
	budgie_windowing_window_mapper_check_invalidated (self);
#line 299 "../src/windowing/window_mapper.vala"
	_tmp15_ = budgie_windowing_window_mapper_query_atom_string (self, (gulong) xfw_window_x11_get_xid (window), gdk_atom_intern ("_GTK_APPLICATION_ID", FALSE), TRUE);
#line 299 "../src/windowing/window_mapper.vala"
	gtk_id = _tmp15_;
#line 301 "../src/windowing/window_mapper.vala"
	_tmp16_ = gtk_id;
#line 301 "../src/windowing/window_mapper.vala"
	if (_tmp16_ != NULL) {
#line 1291 "window_mapper.c"
		gchar* desktop_id = NULL;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		GHashTable* _tmp22_;
		const gchar* _tmp23_;
#line 302 "../src/windowing/window_mapper.vala"
		_tmp17_ = gtk_id;
#line 302 "../src/windowing/window_mapper.vala"
		_tmp18_ = g_utf8_strdown (_tmp17_, (gssize) -1);
#line 302 "../src/windowing/window_mapper.vala"
		_tmp19_ = _tmp18_;
#line 302 "../src/windowing/window_mapper.vala"
		_tmp20_ = g_strconcat (_tmp19_, ".desktop", NULL);
#line 302 "../src/windowing/window_mapper.vala"
		_tmp21_ = _tmp20_;
#line 302 "../src/windowing/window_mapper.vala"
		_g_free0 (_tmp19_);
#line 302 "../src/windowing/window_mapper.vala"
		desktop_id = _tmp21_;
#line 304 "../src/windowing/window_mapper.vala"
		_tmp22_ = self->priv->applications;
#line 304 "../src/windowing/window_mapper.vala"
		_tmp23_ = desktop_id;
#line 304 "../src/windowing/window_mapper.vala"
		if (g_hash_table_contains (_tmp22_, _tmp23_)) {
#line 1320 "window_mapper.c"
			GHashTable* _tmp24_;
			const gchar* _tmp25_;
			gconstpointer _tmp26_;
			GDesktopAppInfo* _tmp27_;
#line 304 "../src/windowing/window_mapper.vala"
			_tmp24_ = self->priv->applications;
#line 304 "../src/windowing/window_mapper.vala"
			_tmp25_ = desktop_id;
#line 304 "../src/windowing/window_mapper.vala"
			_tmp26_ = g_hash_table_lookup (_tmp24_, _tmp25_);
#line 304 "../src/windowing/window_mapper.vala"
			_tmp27_ = _g_object_ref0 ((GDesktopAppInfo*) _tmp26_);
#line 304 "../src/windowing/window_mapper.vala"
			result = _tmp27_;
#line 304 "../src/windowing/window_mapper.vala"
			_g_free0 (desktop_id);
#line 304 "../src/windowing/window_mapper.vala"
			_g_free0 (gtk_id);
#line 304 "../src/windowing/window_mapper.vala"
			return result;
#line 1341 "window_mapper.c"
		}
#line 301 "../src/windowing/window_mapper.vala"
		_g_free0 (desktop_id);
#line 1345 "window_mapper.c"
	}
#line 307 "../src/windowing/window_mapper.vala"
	_tmp28_ = wnck_window_get ((gulong) xfw_window_x11_get_xid (window));
#line 307 "../src/windowing/window_mapper.vala"
	wnck_window = _tmp28_;
#line 308 "../src/windowing/window_mapper.vala"
	_tmp29_ = wnck_window;
#line 308 "../src/windowing/window_mapper.vala"
	_tmp30_ = wnck_window_get_class_group_name (_tmp29_);
#line 308 "../src/windowing/window_mapper.vala"
	_tmp31_ = g_strdup (_tmp30_);
#line 308 "../src/windowing/window_mapper.vala"
	class_group_name = _tmp31_;
#line 310 "../src/windowing/window_mapper.vala"
	_tmp32_ = class_group_name;
#line 310 "../src/windowing/window_mapper.vala"
	if (_tmp32_ == NULL) {
#line 1363 "window_mapper.c"
		gchar* _tmp33_;
#line 311 "../src/windowing/window_mapper.vala"
		_tmp33_ = budgie_windowing_window_mapper_get_group_name (self, window);
#line 311 "../src/windowing/window_mapper.vala"
		_g_free0 (class_group_name);
#line 311 "../src/windowing/window_mapper.vala"
		class_group_name = _tmp33_;
#line 1371 "window_mapper.c"
	}
#line 315 "../src/windowing/window_mapper.vala"
	_tmp34_ = class_group_name;
#line 315 "../src/windowing/window_mapper.vala"
	if (_tmp34_ != NULL) {
#line 1377 "window_mapper.c"
		GDesktopAppInfo* info = NULL;
		const gchar* _tmp35_;
		GDesktopAppInfo* _tmp36_;
		GDesktopAppInfo* _tmp37_;
#line 316 "../src/windowing/window_mapper.vala"
		_tmp35_ = class_group_name;
#line 316 "../src/windowing/window_mapper.vala"
		_tmp36_ = budgie_windowing_window_mapper_query_name (self, _tmp35_);
#line 316 "../src/windowing/window_mapper.vala"
		info = _tmp36_;
#line 318 "../src/windowing/window_mapper.vala"
		_tmp37_ = info;
#line 318 "../src/windowing/window_mapper.vala"
		if (_tmp37_ != NULL) {
#line 318 "../src/windowing/window_mapper.vala"
			result = info;
#line 318 "../src/windowing/window_mapper.vala"
			_g_free0 (class_group_name);
#line 318 "../src/windowing/window_mapper.vala"
			_g_free0 (gtk_id);
#line 318 "../src/windowing/window_mapper.vala"
			return result;
#line 1400 "window_mapper.c"
		}
#line 315 "../src/windowing/window_mapper.vala"
		_g_object_unref0 (info);
#line 1404 "window_mapper.c"
	}
#line 322 "../src/windowing/window_mapper.vala"
	_tmp38_ = wnck_window;
#line 322 "../src/windowing/window_mapper.vala"
	_tmp39_ = wnck_window_get_class_instance_name (_tmp38_);
#line 322 "../src/windowing/window_mapper.vala"
	instance_name = _tmp39_;
#line 324 "../src/windowing/window_mapper.vala"
	_tmp40_ = instance_name;
#line 324 "../src/windowing/window_mapper.vala"
	if (_tmp40_ != NULL) {
#line 1416 "window_mapper.c"
		GDesktopAppInfo* info = NULL;
		const gchar* _tmp41_;
		GDesktopAppInfo* _tmp42_;
		GDesktopAppInfo* _tmp43_;
#line 325 "../src/windowing/window_mapper.vala"
		_tmp41_ = instance_name;
#line 325 "../src/windowing/window_mapper.vala"
		_tmp42_ = budgie_windowing_window_mapper_query_name (self, _tmp41_);
#line 325 "../src/windowing/window_mapper.vala"
		info = _tmp42_;
#line 327 "../src/windowing/window_mapper.vala"
		_tmp43_ = info;
#line 327 "../src/windowing/window_mapper.vala"
		if (_tmp43_ != NULL) {
#line 327 "../src/windowing/window_mapper.vala"
			result = info;
#line 327 "../src/windowing/window_mapper.vala"
			_g_free0 (class_group_name);
#line 327 "../src/windowing/window_mapper.vala"
			_g_free0 (gtk_id);
#line 327 "../src/windowing/window_mapper.vala"
			return result;
#line 1439 "window_mapper.c"
		}
#line 324 "../src/windowing/window_mapper.vala"
		_g_object_unref0 (info);
#line 1443 "window_mapper.c"
	}
#line 330 "../src/windowing/window_mapper.vala"
	result = NULL;
#line 330 "../src/windowing/window_mapper.vala"
	_g_free0 (class_group_name);
#line 330 "../src/windowing/window_mapper.vala"
	_g_free0 (gtk_id);
#line 330 "../src/windowing/window_mapper.vala"
	return result;
#line 1453 "window_mapper.c"
}

BudgieWindowingWindowMapper*
budgie_windowing_window_mapper_construct (GType object_type)
{
	BudgieWindowingWindowMapper * self = NULL;
#line 13 "../src/windowing/window_mapper.vala"
	self = (BudgieWindowingWindowMapper*) g_object_new (object_type, NULL);
#line 13 "../src/windowing/window_mapper.vala"
	return self;
#line 1464 "window_mapper.c"
}

BudgieWindowingWindowMapper*
budgie_windowing_window_mapper_new (void)
{
#line 13 "../src/windowing/window_mapper.vala"
	return budgie_windowing_window_mapper_construct (BUDGIE_WINDOWING_TYPE_WINDOW_MAPPER);
#line 1472 "window_mapper.c"
}

static void
_g_free0_ (gpointer var)
{
#line 26 "../src/windowing/window_mapper.vala"
	var = (g_free (var), NULL);
#line 1480 "window_mapper.c"
}

static void
_budgie_windowing_window_mapper_on_dbus_get_gasync_ready_callback (GObject* source_object,
                                                                   GAsyncResult* res,
                                                                   gpointer self)
{
#line 39 "../src/windowing/window_mapper.vala"
	budgie_windowing_window_mapper_on_dbus_get ((BudgieWindowingWindowMapper*) self, source_object, res);
#line 39 "../src/windowing/window_mapper.vala"
	g_object_unref (self);
#line 1492 "window_mapper.c"
}

static gboolean
__lambda5_ (BudgieWindowingWindowMapper* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
	{
#line 45 "../src/windowing/window_mapper.vala"
		g_rec_mutex_lock (&self->priv->__lock_invalidated);
#line 1503 "window_mapper.c"
		{
#line 46 "../src/windowing/window_mapper.vala"
			self->priv->invalidated = TRUE;
#line 1507 "window_mapper.c"
		}
		__finally0:
		{
#line 45 "../src/windowing/window_mapper.vala"
			g_rec_mutex_unlock (&self->priv->__lock_invalidated);
#line 1513 "window_mapper.c"
		}
#line 45 "../src/windowing/window_mapper.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1517 "window_mapper.c"
			gboolean _tmp0_ = FALSE;
#line 45 "../src/windowing/window_mapper.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 45 "../src/windowing/window_mapper.vala"
			g_clear_error (&_inner_error0_);
#line 45 "../src/windowing/window_mapper.vala"
			return _tmp0_;
#line 1525 "window_mapper.c"
		}
	}
#line 49 "../src/windowing/window_mapper.vala"
	result = G_SOURCE_REMOVE;
#line 49 "../src/windowing/window_mapper.vala"
	return result;
#line 1532 "window_mapper.c"
}

static gboolean
___lambda5__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda5_ ((BudgieWindowingWindowMapper*) self);
#line 44 "../src/windowing/window_mapper.vala"
	return result;
#line 1542 "window_mapper.c"
}

static void
_budgie_windowing_window_mapper___lambda4_ (BudgieWindowingWindowMapper* self)
{
#line 44 "../src/windowing/window_mapper.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda5__gsource_func, g_object_ref (self), g_object_unref);
#line 1550 "window_mapper.c"
}

static void
__budgie_windowing_window_mapper___lambda4__g_app_info_monitor_changed (GAppInfoMonitor* _sender,
                                                                        gpointer self)
{
#line 43 "../src/windowing/window_mapper.vala"
	_budgie_windowing_window_mapper___lambda4_ ((BudgieWindowingWindowMapper*) self);
#line 1559 "window_mapper.c"
}

static GObject *
budgie_windowing_window_mapper_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BudgieWindowingWindowMapper * self;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GHashFunc _tmp3_;
	GEqualFunc _tmp4_;
	GHashTable* _tmp5_;
	GHashFunc _tmp6_;
	GEqualFunc _tmp7_;
	GHashTable* _tmp8_;
	GHashFunc _tmp9_;
	GEqualFunc _tmp10_;
	GHashTable* _tmp11_;
	GHashTable* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GHashTable* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GHashTable* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GHashTable* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	GHashTable* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	GHashTable* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	GHashTable* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	GAppInfoMonitor* _tmp33_;
	GAppInfoMonitor* _tmp34_;
#line 25 "../src/windowing/window_mapper.vala"
	parent_class = G_OBJECT_CLASS (budgie_windowing_window_mapper_parent_class);
#line 25 "../src/windowing/window_mapper.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 25 "../src/windowing/window_mapper.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BUDGIE_WINDOWING_TYPE_WINDOW_MAPPER, BudgieWindowingWindowMapper);
#line 26 "../src/windowing/window_mapper.vala"
	_tmp0_ = g_str_hash;
#line 26 "../src/windowing/window_mapper.vala"
	_tmp1_ = g_str_equal;
#line 26 "../src/windowing/window_mapper.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_object_unref0_);
#line 26 "../src/windowing/window_mapper.vala"
	_g_hash_table_unref0 (self->priv->applications);
#line 26 "../src/windowing/window_mapper.vala"
	self->priv->applications = _tmp2_;
#line 27 "../src/windowing/window_mapper.vala"
	_tmp3_ = g_str_hash;
#line 27 "../src/windowing/window_mapper.vala"
	_tmp4_ = g_str_equal;
#line 27 "../src/windowing/window_mapper.vala"
	_tmp5_ = g_hash_table_new_full (_tmp3_, _tmp4_, _g_free0_, _g_object_unref0_);
#line 27 "../src/windowing/window_mapper.vala"
	_g_hash_table_unref0 (self->priv->startup_infos);
#line 27 "../src/windowing/window_mapper.vala"
	self->priv->startup_infos = _tmp5_;
#line 28 "../src/windowing/window_mapper.vala"
	_tmp6_ = g_str_hash;
#line 28 "../src/windowing/window_mapper.vala"
	_tmp7_ = g_str_equal;
#line 28 "../src/windowing/window_mapper.vala"
	_tmp8_ = g_hash_table_new_full (_tmp6_, _tmp7_, _g_free0_, _g_free0_);
#line 28 "../src/windowing/window_mapper.vala"
	_g_hash_table_unref0 (self->priv->simpletons);
#line 28 "../src/windowing/window_mapper.vala"
	self->priv->simpletons = _tmp8_;
#line 29 "../src/windowing/window_mapper.vala"
	_tmp9_ = g_str_hash;
#line 29 "../src/windowing/window_mapper.vala"
	_tmp10_ = g_str_equal;
#line 29 "../src/windowing/window_mapper.vala"
	_tmp11_ = g_hash_table_new_full (_tmp9_, _tmp10_, _g_free0_, _g_free0_);
#line 29 "../src/windowing/window_mapper.vala"
	_g_hash_table_unref0 (self->priv->pids);
#line 29 "../src/windowing/window_mapper.vala"
	self->priv->pids = _tmp11_;
#line 31 "../src/windowing/window_mapper.vala"
	_tmp12_ = self->priv->simpletons;
#line 31 "../src/windowing/window_mapper.vala"
	_tmp13_ = g_strdup ("google-chrome-stable");
#line 31 "../src/windowing/window_mapper.vala"
	_tmp14_ = g_strdup ("google-chrome");
#line 31 "../src/windowing/window_mapper.vala"
	g_hash_table_insert (_tmp12_, _tmp13_, _tmp14_);
#line 32 "../src/windowing/window_mapper.vala"
	_tmp15_ = self->priv->simpletons;
#line 32 "../src/windowing/window_mapper.vala"
	_tmp16_ = g_strdup ("calibre-gui");
#line 32 "../src/windowing/window_mapper.vala"
	_tmp17_ = g_strdup ("calibre");
#line 32 "../src/windowing/window_mapper.vala"
	g_hash_table_insert (_tmp15_, _tmp16_, _tmp17_);
#line 33 "../src/windowing/window_mapper.vala"
	_tmp18_ = self->priv->simpletons;
#line 33 "../src/windowing/window_mapper.vala"
	_tmp19_ = g_strdup ("code - oss");
#line 33 "../src/windowing/window_mapper.vala"
	_tmp20_ = g_strdup ("vscode-oss");
#line 33 "../src/windowing/window_mapper.vala"
	g_hash_table_insert (_tmp18_, _tmp19_, _tmp20_);
#line 34 "../src/windowing/window_mapper.vala"
	_tmp21_ = self->priv->simpletons;
#line 34 "../src/windowing/window_mapper.vala"
	_tmp22_ = g_strdup ("code");
#line 34 "../src/windowing/window_mapper.vala"
	_tmp23_ = g_strdup ("vscode");
#line 34 "../src/windowing/window_mapper.vala"
	g_hash_table_insert (_tmp21_, _tmp22_, _tmp23_);
#line 35 "../src/windowing/window_mapper.vala"
	_tmp24_ = self->priv->simpletons;
#line 35 "../src/windowing/window_mapper.vala"
	_tmp25_ = g_strdup ("psppire");
#line 35 "../src/windowing/window_mapper.vala"
	_tmp26_ = g_strdup ("pspp");
#line 35 "../src/windowing/window_mapper.vala"
	g_hash_table_insert (_tmp24_, _tmp25_, _tmp26_);
#line 36 "../src/windowing/window_mapper.vala"
	_tmp27_ = self->priv->simpletons;
#line 36 "../src/windowing/window_mapper.vala"
	_tmp28_ = g_strdup ("gnome-twitch");
#line 36 "../src/windowing/window_mapper.vala"
	_tmp29_ = g_strdup ("com.vinszent.gnometwitch");
#line 36 "../src/windowing/window_mapper.vala"
	g_hash_table_insert (_tmp27_, _tmp28_, _tmp29_);
#line 37 "../src/windowing/window_mapper.vala"
	_tmp30_ = self->priv->simpletons;
#line 37 "../src/windowing/window_mapper.vala"
	_tmp31_ = g_strdup ("anoise.py");
#line 37 "../src/windowing/window_mapper.vala"
	_tmp32_ = g_strdup ("anoise");
#line 37 "../src/windowing/window_mapper.vala"
	g_hash_table_insert (_tmp30_, _tmp31_, _tmp32_);
#line 39 "../src/windowing/window_mapper.vala"
	g_bus_get (G_BUS_TYPE_SESSION, NULL, _budgie_windowing_window_mapper_on_dbus_get_gasync_ready_callback, g_object_ref (self));
#line 41 "../src/windowing/window_mapper.vala"
	_tmp33_ = g_app_info_monitor_get ();
#line 41 "../src/windowing/window_mapper.vala"
	_g_object_unref0 (self->priv->monitor);
#line 41 "../src/windowing/window_mapper.vala"
	self->priv->monitor = _tmp33_;
#line 43 "../src/windowing/window_mapper.vala"
	_tmp34_ = self->priv->monitor;
#line 43 "../src/windowing/window_mapper.vala"
	g_signal_connect_object (_tmp34_, "changed", (GCallback) __budgie_windowing_window_mapper___lambda4__g_app_info_monitor_changed, self, 0);
#line 53 "../src/windowing/window_mapper.vala"
	budgie_windowing_window_mapper_load_app_infos (self);
#line 25 "../src/windowing/window_mapper.vala"
	return obj;
#line 1723 "window_mapper.c"
}

static void
budgie_windowing_window_mapper_class_init (BudgieWindowingWindowMapperClass * klass,
                                           gpointer klass_data)
{
#line 13 "../src/windowing/window_mapper.vala"
	budgie_windowing_window_mapper_parent_class = g_type_class_peek_parent (klass);
#line 13 "../src/windowing/window_mapper.vala"
	g_type_class_adjust_private_offset (klass, &BudgieWindowingWindowMapper_private_offset);
#line 13 "../src/windowing/window_mapper.vala"
	G_OBJECT_CLASS (klass)->constructor = budgie_windowing_window_mapper_constructor;
#line 13 "../src/windowing/window_mapper.vala"
	G_OBJECT_CLASS (klass)->finalize = budgie_windowing_window_mapper_finalize;
#line 1738 "window_mapper.c"
}

static void
budgie_windowing_window_mapper_instance_init (BudgieWindowingWindowMapper * self,
                                              gpointer klass)
{
#line 13 "../src/windowing/window_mapper.vala"
	self->priv = budgie_windowing_window_mapper_get_instance_private (self);
#line 23 "../src/windowing/window_mapper.vala"
	g_rec_mutex_init (&self->priv->__lock_invalidated);
#line 23 "../src/windowing/window_mapper.vala"
	self->priv->invalidated = FALSE;
#line 1751 "window_mapper.c"
}

static void
budgie_windowing_window_mapper_finalize (GObject * obj)
{
	BudgieWindowingWindowMapper * self;
#line 13 "../src/windowing/window_mapper.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BUDGIE_WINDOWING_TYPE_WINDOW_MAPPER, BudgieWindowingWindowMapper);
#line 15 "../src/windowing/window_mapper.vala"
	_g_hash_table_unref0 (self->priv->applications);
#line 16 "../src/windowing/window_mapper.vala"
	_g_hash_table_unref0 (self->priv->startup_infos);
#line 17 "../src/windowing/window_mapper.vala"
	_g_hash_table_unref0 (self->priv->simpletons);
#line 18 "../src/windowing/window_mapper.vala"
	_g_hash_table_unref0 (self->priv->pids);
#line 20 "../src/windowing/window_mapper.vala"
	_g_object_unref0 (self->priv->monitor);
#line 21 "../src/windowing/window_mapper.vala"
	_g_object_unref0 (self->priv->bus);
#line 23 "../src/windowing/window_mapper.vala"
	g_rec_mutex_clear (&self->priv->__lock_invalidated);
#line 13 "../src/windowing/window_mapper.vala"
	G_OBJECT_CLASS (budgie_windowing_window_mapper_parent_class)->finalize (obj);
#line 1776 "window_mapper.c"
}

static GType
budgie_windowing_window_mapper_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BudgieWindowingWindowMapperClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) budgie_windowing_window_mapper_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BudgieWindowingWindowMapper), 0, (GInstanceInitFunc) budgie_windowing_window_mapper_instance_init, NULL };
	GType budgie_windowing_window_mapper_type_id;
	budgie_windowing_window_mapper_type_id = g_type_register_static (G_TYPE_OBJECT, "BudgieWindowingWindowMapper", &g_define_type_info, 0);
	BudgieWindowingWindowMapper_private_offset = g_type_add_instance_private (budgie_windowing_window_mapper_type_id, sizeof (BudgieWindowingWindowMapperPrivate));
	return budgie_windowing_window_mapper_type_id;
}

GType
budgie_windowing_window_mapper_get_type (void)
{
	static volatile gsize budgie_windowing_window_mapper_type_id__once = 0;
	if (g_once_init_enter (&budgie_windowing_window_mapper_type_id__once)) {
		GType budgie_windowing_window_mapper_type_id;
		budgie_windowing_window_mapper_type_id = budgie_windowing_window_mapper_get_type_once ();
		g_once_init_leave (&budgie_windowing_window_mapper_type_id__once, budgie_windowing_window_mapper_type_id);
	}
	return budgie_windowing_window_mapper_type_id__once;
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

