/* windowing.c generated by valac 0.56.17, the Vala compiler
 * generated from windowing.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "windowing.h"
#include <libxfce4windowing/libxfce4windowing.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <gio/gdesktopappinfo.h>

#define BUDGIE_WINDOWING_NOTIFICATIONS_DBUS_NAME "org.budgie_desktop.Notifications"
#define BUDGIE_WINDOWING_NOTIFICATIONS_DBUS_OBJECT_PATH "/org/budgie_desktop/Notifications"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	BUDGIE_WINDOWING_WINDOWING_0_PROPERTY,
	BUDGIE_WINDOWING_WINDOWING_HAS_WINDOWS_PROPERTY,
	BUDGIE_WINDOWING_WINDOWING_WINDOWS_PROPERTY,
	BUDGIE_WINDOWING_WINDOWING_NUM_PROPERTIES
};
static GParamSpec* budgie_windowing_windowing_properties[BUDGIE_WINDOWING_WINDOWING_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	BUDGIE_WINDOWING_WINDOWING_ACTIVE_WINDOW_CHANGED_SIGNAL,
	BUDGIE_WINDOWING_WINDOWING_ACTIVE_WORKSPACE_CHANGED_SIGNAL,
	BUDGIE_WINDOWING_WINDOWING_WINDOW_GROUP_ADDED_SIGNAL,
	BUDGIE_WINDOWING_WINDOWING_WINDOW_GROUP_REMOVED_SIGNAL,
	BUDGIE_WINDOWING_WINDOWING_WINDOW_ADDED_SIGNAL,
	BUDGIE_WINDOWING_WINDOWING_WINDOW_REMOVED_SIGNAL,
	BUDGIE_WINDOWING_WINDOWING_WINDOW_STATE_CHANGED_SIGNAL,
	BUDGIE_WINDOWING_WINDOWING_WORKSPACE_CREATED_SIGNAL,
	BUDGIE_WINDOWING_WINDOWING_WORKSPACE_DESTROYED_SIGNAL,
	BUDGIE_WINDOWING_WINDOWING_NUM_SIGNALS
};
static guint budgie_windowing_windowing_signals[BUDGIE_WINDOWING_WINDOWING_NUM_SIGNALS] = {0};

struct _BudgieWindowingWindowingPrivate {
	XfwScreen* screen;
	XfwWorkspaceManager* workspace_manager;
	GHashTable* applications;
	GList* fullscreen_windows;
	XfwWindow* last_active_window;
	BudgieWindowingWindowMapper* window_mapper;
	BudgieWindowingNotificationDispatcher* dispatcher;
	GSettings* color_settings;
	GSettings* wm_settings;
	gulong night_light_setting_handler;
	gboolean pause_night_light;
	gboolean pause_notifications;
	gboolean previous_color_setting;
	gboolean _has_windows;
};

static gint BudgieWindowingWindowing_private_offset;
static gpointer budgie_windowing_windowing_parent_class = NULL;

static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void budgie_windowing_windowing_on_dbus_get (BudgieWindowingWindowing* self,
                                             GObject* object,
                                             GAsyncResult* _result_);
static void budgie_windowing_windowing_setup_workspace_listener (BudgieWindowingWindowing* self);
static void budgie_windowing_windowing_on_active_workspace_changed (BudgieWindowingWindowing* self,
                                                             XfwWorkspace* previous_workspace);
static void _budgie_windowing_windowing_on_active_workspace_changed_libxfce4windowing_workspace_group_active_workspace_changed (XfwWorkspaceGroup* _sender,
                                                                                                                         XfwWorkspace* previously_active_workspace,
                                                                                                                         gpointer self);
static void budgie_windowing_windowing_on_workspace_created (BudgieWindowingWindowing* self,
                                                      XfwWorkspace* workspace);
static void _budgie_windowing_windowing_on_workspace_created_libxfce4windowing_workspace_group_workspace_added (XfwWorkspaceGroup* _sender,
                                                                                                         XfwWorkspace* workspace,
                                                                                                         gpointer self);
static void budgie_windowing_windowing_on_workspace_destroyed (BudgieWindowingWindowing* self,
                                                        XfwWorkspace* workspace);
static void _budgie_windowing_windowing_on_workspace_destroyed_libxfce4windowing_workspace_group_workspace_removed (XfwWorkspaceGroup* _sender,
                                                                                                             XfwWorkspace* workspace,
                                                                                                             gpointer self);
static void budgie_windowing_windowing_on_active_window_changed (BudgieWindowingWindowing* self,
                                                          XfwWindow* old_window);
static void budgie_windowing_windowing_on_window_added (BudgieWindowingWindowing* self,
                                                 XfwWindow* window);
static void budgie_windowing_windowing_set_has_windows (BudgieWindowingWindowing* self,
                                                 gboolean value);
static void budgie_windowing_windowing_on_window_state_changed (BudgieWindowingWindowing* self,
                                                         XfwWindow* window,
                                                         XfwWindowState changed_mask,
                                                         XfwWindowState new_state);
static void _budgie_windowing_windowing_on_window_state_changed_budgie_windowing_window_group_window_state_changed (BudgieWindowingWindowGroup* _sender,
                                                                                                             XfwWindow* window,
                                                                                                             XfwWindowState changed_mask,
                                                                                                             XfwWindowState new_state,
                                                                                                             gpointer self);
static void budgie_windowing_windowing_on_window_removed (BudgieWindowingWindowing* self,
                                                   XfwWindow* window);
static void budgie_windowing_windowing_handle_fullscreen_changed (BudgieWindowingWindowing* self,
                                                           gboolean fullscreen);
static void budgie_windowing_windowing_night_light_enabled_changed (BudgieWindowingWindowing* self,
                                                             const gchar* key);
static void budgie_windowing_windowing_wm_settings_changed (BudgieWindowingWindowing* self,
                                                     const gchar* key);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_FLAGS_FLAGS (GClosure * closure,
                                                       GValue * return_value,
                                                       guint n_param_values,
                                                       const GValue * param_values,
                                                       gpointer invocation_hint,
                                                       gpointer marshal_data);
static GObject * budgie_windowing_windowing_constructor (GType type,
                                                  guint n_construct_properties,
                                                  GObjectConstructParam * construct_properties);
static void _budgie_windowing_windowing_on_dbus_get_gasync_ready_callback (GObject* source_object,
                                                                    GAsyncResult* res,
                                                                    gpointer self);
static void _budgie_windowing_windowing_on_window_added_gfunc (gconstpointer data,
                                                        gpointer self);
static void _budgie_windowing_windowing_on_active_window_changed_libxfce4windowing_screen_active_window_changed (XfwScreen* _sender,
                                                                                                          XfwWindow* window,
                                                                                                          gpointer self);
static void _budgie_windowing_windowing_on_window_added_libxfce4windowing_screen_window_opened (XfwScreen* _sender,
                                                                                         XfwWindow* window,
                                                                                         gpointer self);
static void _budgie_windowing_windowing_on_window_removed_libxfce4windowing_screen_window_closed (XfwScreen* _sender,
                                                                                           XfwWindow* window,
                                                                                           gpointer self);
static void _budgie_windowing_windowing_night_light_enabled_changed_g_settings_changed (GSettings* _sender,
                                                                                 const gchar* key,
                                                                                 gpointer self);
static void _budgie_windowing_windowing_wm_settings_changed_g_settings_changed (GSettings* _sender,
                                                                         const gchar* key,
                                                                         gpointer self);
static void budgie_windowing_windowing_finalize (GObject * obj);
static GType budgie_windowing_windowing_get_type_once (void);
static void _vala_budgie_windowing_windowing_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_budgie_windowing_windowing_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);

static inline gpointer
budgie_windowing_windowing_get_instance_private (BudgieWindowingWindowing* self)
{
	return G_STRUCT_MEMBER_P (self, BudgieWindowingWindowing_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 27 "../src/windowing/windowing.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 182 "windowing.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 27 "../src/windowing/windowing.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 190 "windowing.c"
}

/**
 * Creates a new Windowing object. This is the entry point into
 * this library.
 */
BudgieWindowingWindowing*
budgie_windowing_windowing_construct (GType object_type)
{
	BudgieWindowingWindowing * self = NULL;
#line 93 "../src/windowing/windowing.vala"
	self = (BudgieWindowingWindowing*) g_object_new (object_type, NULL);
#line 92 "../src/windowing/windowing.vala"
	return self;
#line 205 "windowing.c"
}

BudgieWindowingWindowing*
budgie_windowing_windowing_new (void)
{
#line 92 "../src/windowing/windowing.vala"
	return budgie_windowing_windowing_construct (BUDGIE_WINDOWING_TYPE_WINDOWING);
#line 213 "windowing.c"
}

static void
budgie_windowing_windowing_on_dbus_get (BudgieWindowingWindowing* self,
                                        GObject* object,
                                        GAsyncResult* _result_)
{
	GError* _inner_error0_ = NULL;
#line 135 "../src/windowing/windowing.vala"
	g_return_if_fail (self != NULL);
#line 224 "windowing.c"
	{
		BudgieWindowingNotificationDispatcher* _tmp0_ = NULL;
		BudgieWindowingNotificationDispatcher* _tmp1_;
		BudgieWindowingNotificationDispatcher* _tmp2_;
		BudgieWindowingNotificationDispatcher* _tmp3_;
#line 137 "../src/windowing/windowing.vala"
		_tmp1_ = g_async_result_get_source_object (_result_);
#line 137 "../src/windowing/windowing.vala"
		_tmp2_ = (BudgieWindowingNotificationDispatcher*) g_async_initable_new_finish ((GAsyncInitable *) _tmp1_, _result_, &_inner_error0_);
#line 137 "../src/windowing/windowing.vala"
		g_object_unref (_tmp1_);
#line 137 "../src/windowing/windowing.vala"
		_tmp0_ = (BudgieWindowingNotificationDispatcher*) _tmp2_;
#line 137 "../src/windowing/windowing.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 240 "windowing.c"
			goto __catch0_g_error;
		}
#line 137 "../src/windowing/windowing.vala"
		_tmp3_ = _tmp0_;
#line 137 "../src/windowing/windowing.vala"
		_tmp0_ = NULL;
#line 137 "../src/windowing/windowing.vala"
		_g_object_unref0 (self->priv->dispatcher);
#line 137 "../src/windowing/windowing.vala"
		self->priv->dispatcher = _tmp3_;
#line 136 "../src/windowing/windowing.vala"
		_g_object_unref0 (_tmp0_);
#line 253 "windowing.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 136 "../src/windowing/windowing.vala"
		e = _inner_error0_;
#line 136 "../src/windowing/windowing.vala"
		_inner_error0_ = NULL;
#line 139 "../src/windowing/windowing.vala"
		_tmp4_ = e;
#line 139 "../src/windowing/windowing.vala"
		_tmp5_ = _tmp4_->message;
#line 139 "../src/windowing/windowing.vala"
		g_critical ("windowing.vala:139: Error getting notification dispatcher: %s", _tmp5_);
#line 136 "../src/windowing/windowing.vala"
		_g_error_free0 (e);
#line 273 "windowing.c"
	}
	__finally0:
#line 136 "../src/windowing/windowing.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 136 "../src/windowing/windowing.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 136 "../src/windowing/windowing.vala"
		g_clear_error (&_inner_error0_);
#line 136 "../src/windowing/windowing.vala"
		return;
#line 284 "windowing.c"
	}
}

/**
 * Get the first workspace group. X11 has no concept of
 * workspace groups, so the first one is guaranteed to
 * be the only one.
 */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 155 "../src/windowing/windowing.vala"
	return self ? g_object_ref (self) : NULL;
#line 298 "windowing.c"
}

XfwWorkspaceGroup*
budgie_windowing_windowing_get_workspace_group (BudgieWindowingWindowing* self)
{
	GList* groups = NULL;
	XfwWorkspaceManager* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	GList* element = NULL;
	GList* _tmp3_;
	GList* _tmp4_;
	GList* _tmp5_;
	gconstpointer _tmp6_;
	XfwWorkspaceGroup* _tmp7_;
	XfwWorkspaceGroup* _tmp8_;
	XfwWorkspaceGroup* result;
#line 148 "../src/windowing/windowing.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 149 "../src/windowing/windowing.vala"
	_tmp0_ = self->priv->workspace_manager;
#line 149 "../src/windowing/windowing.vala"
	_tmp1_ = xfw_workspace_manager_list_workspace_groups (_tmp0_);
#line 149 "../src/windowing/windowing.vala"
	groups = _tmp1_;
#line 151 "../src/windowing/windowing.vala"
	_tmp2_ = groups;
#line 151 "../src/windowing/windowing.vala"
	if (_tmp2_ == NULL) {
#line 151 "../src/windowing/windowing.vala"
		result = NULL;
#line 151 "../src/windowing/windowing.vala"
		return result;
#line 332 "windowing.c"
	}
#line 153 "../src/windowing/windowing.vala"
	_tmp3_ = groups;
#line 153 "../src/windowing/windowing.vala"
	_tmp4_ = g_list_first (_tmp3_);
#line 153 "../src/windowing/windowing.vala"
	element = _tmp4_;
#line 155 "../src/windowing/windowing.vala"
	_tmp5_ = element;
#line 155 "../src/windowing/windowing.vala"
	_tmp6_ = _tmp5_->data;
#line 155 "../src/windowing/windowing.vala"
	_tmp7_ = (XfwWorkspaceGroup*) _tmp6_;
#line 155 "../src/windowing/windowing.vala"
	_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, xfw_workspace_group_get_type ()) ? ((XfwWorkspaceGroup*) _tmp7_) : NULL);
#line 155 "../src/windowing/windowing.vala"
	result = _tmp8_;
#line 155 "../src/windowing/windowing.vala"
	return result;
#line 352 "windowing.c"
}

static void
_budgie_windowing_windowing_on_active_workspace_changed_libxfce4windowing_workspace_group_active_workspace_changed (XfwWorkspaceGroup* _sender,
                                                                                                                    XfwWorkspace* previously_active_workspace,
                                                                                                                    gpointer self)
{
#line 164 "../src/windowing/windowing.vala"
	budgie_windowing_windowing_on_active_workspace_changed ((BudgieWindowingWindowing*) self, previously_active_workspace);
#line 362 "windowing.c"
}

static void
_budgie_windowing_windowing_on_workspace_created_libxfce4windowing_workspace_group_workspace_added (XfwWorkspaceGroup* _sender,
                                                                                                    XfwWorkspace* workspace,
                                                                                                    gpointer self)
{
#line 165 "../src/windowing/windowing.vala"
	budgie_windowing_windowing_on_workspace_created ((BudgieWindowingWindowing*) self, workspace);
#line 372 "windowing.c"
}

static void
_budgie_windowing_windowing_on_workspace_destroyed_libxfce4windowing_workspace_group_workspace_removed (XfwWorkspaceGroup* _sender,
                                                                                                        XfwWorkspace* workspace,
                                                                                                        gpointer self)
{
#line 166 "../src/windowing/windowing.vala"
	budgie_windowing_windowing_on_workspace_destroyed ((BudgieWindowingWindowing*) self, workspace);
#line 382 "windowing.c"
}

static void
budgie_windowing_windowing_setup_workspace_listener (BudgieWindowingWindowing* self)
{
	XfwScreen* _tmp0_;
	XfwWorkspaceManager* _tmp1_;
	XfwWorkspaceManager* _tmp2_;
	XfwWorkspaceGroup* group = NULL;
	XfwWorkspaceGroup* _tmp3_;
	XfwWorkspaceGroup* _tmp4_;
	XfwWorkspaceGroup* _tmp5_;
	XfwWorkspaceGroup* _tmp6_;
	XfwWorkspaceGroup* _tmp7_;
#line 158 "../src/windowing/windowing.vala"
	g_return_if_fail (self != NULL);
#line 159 "../src/windowing/windowing.vala"
	_tmp0_ = self->priv->screen;
#line 159 "../src/windowing/windowing.vala"
	_tmp1_ = xfw_screen_get_workspace_manager (_tmp0_);
#line 159 "../src/windowing/windowing.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 159 "../src/windowing/windowing.vala"
	_g_object_unref0 (self->priv->workspace_manager);
#line 159 "../src/windowing/windowing.vala"
	self->priv->workspace_manager = _tmp2_;
#line 160 "../src/windowing/windowing.vala"
	_tmp3_ = budgie_windowing_windowing_get_workspace_group (self);
#line 160 "../src/windowing/windowing.vala"
	group = _tmp3_;
#line 162 "../src/windowing/windowing.vala"
	_tmp4_ = group;
#line 162 "../src/windowing/windowing.vala"
	if (_tmp4_ == NULL) {
#line 162 "../src/windowing/windowing.vala"
		_g_object_unref0 (group);
#line 162 "../src/windowing/windowing.vala"
		return;
#line 421 "windowing.c"
	}
#line 164 "../src/windowing/windowing.vala"
	_tmp5_ = group;
#line 164 "../src/windowing/windowing.vala"
	g_signal_connect_object (_tmp5_, "active-workspace-changed", (GCallback) _budgie_windowing_windowing_on_active_workspace_changed_libxfce4windowing_workspace_group_active_workspace_changed, self, 0);
#line 165 "../src/windowing/windowing.vala"
	_tmp6_ = group;
#line 165 "../src/windowing/windowing.vala"
	g_signal_connect_object (_tmp6_, "workspace-added", (GCallback) _budgie_windowing_windowing_on_workspace_created_libxfce4windowing_workspace_group_workspace_added, self, 0);
#line 166 "../src/windowing/windowing.vala"
	_tmp7_ = group;
#line 166 "../src/windowing/windowing.vala"
	g_signal_connect_object (_tmp7_, "workspace-removed", (GCallback) _budgie_windowing_windowing_on_workspace_destroyed_libxfce4windowing_workspace_group_workspace_removed, self, 0);
#line 158 "../src/windowing/windowing.vala"
	_g_object_unref0 (group);
#line 437 "windowing.c"
}

static void
budgie_windowing_windowing_on_active_window_changed (BudgieWindowingWindowing* self,
                                                     XfwWindow* old_window)
{
	XfwWindow* new_window = NULL;
	XfwScreen* _tmp0_;
	XfwWindow* _tmp1_;
	XfwWindow* _tmp2_;
	GHashTable* _tmp3_;
	GList* _tmp4_;
	XfwWindow* _tmp12_;
	XfwWindow* _tmp13_;
#line 169 "../src/windowing/windowing.vala"
	g_return_if_fail (self != NULL);
#line 170 "../src/windowing/windowing.vala"
	_tmp0_ = self->priv->screen;
#line 170 "../src/windowing/windowing.vala"
	_tmp1_ = xfw_screen_get_active_window (_tmp0_);
#line 170 "../src/windowing/windowing.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 170 "../src/windowing/windowing.vala"
	new_window = _tmp2_;
#line 172 "../src/windowing/windowing.vala"
	_tmp3_ = self->priv->applications;
#line 172 "../src/windowing/windowing.vala"
	_tmp4_ = g_hash_table_get_values (_tmp3_);
#line 466 "windowing.c"
	{
		GList* group_collection = NULL;
		GList* group_it = NULL;
#line 172 "../src/windowing/windowing.vala"
		group_collection = _tmp4_;
#line 172 "../src/windowing/windowing.vala"
		for (group_it = group_collection; group_it != NULL; group_it = group_it->next) {
#line 474 "windowing.c"
			BudgieWindowingWindowGroup* group = NULL;
#line 172 "../src/windowing/windowing.vala"
			group = (BudgieWindowingWindowGroup*) group_it->data;
#line 478 "windowing.c"
			{
				BudgieWindowingWindowGroup* _tmp5_;
				XfwWindow* _tmp6_;
				gboolean _tmp9_ = FALSE;
#line 173 "../src/windowing/windowing.vala"
				_tmp5_ = group;
#line 173 "../src/windowing/windowing.vala"
				_tmp6_ = new_window;
#line 173 "../src/windowing/windowing.vala"
				if (budgie_windowing_window_group_has_window (_tmp5_, _tmp6_)) {
#line 489 "windowing.c"
					BudgieWindowingWindowGroup* _tmp7_;
					XfwWindow* _tmp8_;
#line 174 "../src/windowing/windowing.vala"
					_tmp7_ = group;
#line 174 "../src/windowing/windowing.vala"
					_tmp8_ = new_window;
#line 174 "../src/windowing/windowing.vala"
					budgie_windowing_window_group_set_active_window (_tmp7_, _tmp8_);
#line 498 "windowing.c"
				}
#line 177 "../src/windowing/windowing.vala"
				if (old_window != NULL) {
#line 502 "windowing.c"
					BudgieWindowingWindowGroup* _tmp10_;
#line 177 "../src/windowing/windowing.vala"
					_tmp10_ = group;
#line 177 "../src/windowing/windowing.vala"
					_tmp9_ = budgie_windowing_window_group_has_window (_tmp10_, old_window);
#line 508 "windowing.c"
				} else {
#line 177 "../src/windowing/windowing.vala"
					_tmp9_ = FALSE;
#line 512 "windowing.c"
				}
#line 177 "../src/windowing/windowing.vala"
				if (_tmp9_) {
#line 516 "windowing.c"
					BudgieWindowingWindowGroup* _tmp11_;
#line 178 "../src/windowing/windowing.vala"
					_tmp11_ = group;
#line 178 "../src/windowing/windowing.vala"
					budgie_windowing_window_group_set_last_active_window (_tmp11_, old_window);
#line 522 "windowing.c"
				}
			}
		}
#line 172 "../src/windowing/windowing.vala"
		(group_collection == NULL) ? NULL : (group_collection = (g_list_free (group_collection), NULL));
#line 528 "windowing.c"
	}
#line 182 "../src/windowing/windowing.vala"
	_tmp12_ = _g_object_ref0 (old_window);
#line 182 "../src/windowing/windowing.vala"
	_g_object_unref0 (self->priv->last_active_window);
#line 182 "../src/windowing/windowing.vala"
	self->priv->last_active_window = _tmp12_;
#line 184 "../src/windowing/windowing.vala"
	_tmp13_ = new_window;
#line 184 "../src/windowing/windowing.vala"
	g_signal_emit (self, budgie_windowing_windowing_signals[BUDGIE_WINDOWING_WINDOWING_ACTIVE_WINDOW_CHANGED_SIGNAL], 0, old_window, _tmp13_);
#line 169 "../src/windowing/windowing.vala"
	_g_object_unref0 (new_window);
#line 542 "windowing.c"
}

static void
budgie_windowing_windowing_on_active_workspace_changed (BudgieWindowingWindowing* self,
                                                        XfwWorkspace* previous_workspace)
{
#line 187 "../src/windowing/windowing.vala"
	g_return_if_fail (self != NULL);
#line 188 "../src/windowing/windowing.vala"
	g_signal_emit (self, budgie_windowing_windowing_signals[BUDGIE_WINDOWING_WINDOWING_ACTIVE_WORKSPACE_CHANGED_SIGNAL], 0, previous_workspace);
#line 553 "windowing.c"
}

static void
budgie_windowing_windowing_on_workspace_created (BudgieWindowingWindowing* self,
                                                 XfwWorkspace* workspace)
{
#line 191 "../src/windowing/windowing.vala"
	g_return_if_fail (self != NULL);
#line 191 "../src/windowing/windowing.vala"
	g_return_if_fail (workspace != NULL);
#line 192 "../src/windowing/windowing.vala"
	g_signal_emit (self, budgie_windowing_windowing_signals[BUDGIE_WINDOWING_WINDOWING_WORKSPACE_CREATED_SIGNAL], 0, workspace);
#line 566 "windowing.c"
}

static void
budgie_windowing_windowing_on_workspace_destroyed (BudgieWindowingWindowing* self,
                                                   XfwWorkspace* workspace)
{
#line 195 "../src/windowing/windowing.vala"
	g_return_if_fail (self != NULL);
#line 195 "../src/windowing/windowing.vala"
	g_return_if_fail (workspace != NULL);
#line 196 "../src/windowing/windowing.vala"
	g_signal_emit (self, budgie_windowing_windowing_signals[BUDGIE_WINDOWING_WINDOWING_WORKSPACE_DESTROYED_SIGNAL], 0, workspace);
#line 579 "windowing.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 592 "windowing.c"
}

static void
_budgie_windowing_windowing_on_window_state_changed_budgie_windowing_window_group_window_state_changed (BudgieWindowingWindowGroup* _sender,
                                                                                                        XfwWindow* window,
                                                                                                        XfwWindowState changed_mask,
                                                                                                        XfwWindowState new_state,
                                                                                                        gpointer self)
{
#line 221 "../src/windowing/windowing.vala"
	budgie_windowing_windowing_on_window_state_changed ((BudgieWindowingWindowing*) self, window, changed_mask, new_state);
#line 604 "windowing.c"
}

static void
budgie_windowing_windowing_on_window_added (BudgieWindowingWindowing* self,
                                            XfwWindow* window)
{
	XfwApplication* application = NULL;
	XfwApplication* _tmp0_;
	XfwApplication* _tmp1_;
	BudgieWindowingWindowGroup* group = NULL;
	GHashTable* _tmp2_;
	XfwApplication* _tmp3_;
	gconstpointer _tmp4_;
	BudgieWindowingWindowGroup* _tmp5_;
	BudgieWindowingWindowGroup* _tmp6_;
	XfwApplication* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	GDesktopAppInfo* app_info = NULL;
	BudgieWindowingWindowMapper* _tmp13_;
	GDesktopAppInfo* _tmp14_;
	XfwApplication* _tmp15_;
	GDesktopAppInfo* _tmp16_;
	BudgieWindowingWindowGroup* _tmp17_;
	BudgieWindowingWindowGroup* _tmp18_;
	BudgieWindowingWindowGroup* _tmp19_;
	GHashTable* _tmp20_;
	XfwApplication* _tmp21_;
	XfwApplication* _tmp22_;
	BudgieWindowingWindowGroup* _tmp23_;
	BudgieWindowingWindowGroup* _tmp24_;
	BudgieWindowingWindowGroup* _tmp25_;
#line 199 "../src/windowing/windowing.vala"
	g_return_if_fail (self != NULL);
#line 199 "../src/windowing/windowing.vala"
	g_return_if_fail (window != NULL);
#line 200 "../src/windowing/windowing.vala"
	if (xfw_window_is_skip_tasklist (window)) {
#line 200 "../src/windowing/windowing.vala"
		return;
#line 647 "windowing.c"
	}
#line 201 "../src/windowing/windowing.vala"
	g_signal_emit (self, budgie_windowing_windowing_signals[BUDGIE_WINDOWING_WINDOWING_WINDOW_ADDED_SIGNAL], 0, window);
#line 202 "../src/windowing/windowing.vala"
	budgie_windowing_windowing_set_has_windows (self, TRUE);
#line 204 "../src/windowing/windowing.vala"
	_tmp0_ = xfw_window_get_application (window);
#line 204 "../src/windowing/windowing.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 204 "../src/windowing/windowing.vala"
	application = _tmp1_;
#line 207 "../src/windowing/windowing.vala"
	_tmp2_ = self->priv->applications;
#line 207 "../src/windowing/windowing.vala"
	_tmp3_ = application;
#line 207 "../src/windowing/windowing.vala"
	_tmp4_ = g_hash_table_lookup (_tmp2_, _tmp3_);
#line 207 "../src/windowing/windowing.vala"
	_tmp5_ = _g_object_ref0 ((BudgieWindowingWindowGroup*) _tmp4_);
#line 207 "../src/windowing/windowing.vala"
	group = _tmp5_;
#line 208 "../src/windowing/windowing.vala"
	_tmp6_ = group;
#line 208 "../src/windowing/windowing.vala"
	if (_tmp6_ != NULL) {
#line 673 "windowing.c"
		BudgieWindowingWindowGroup* _tmp7_;
#line 210 "../src/windowing/windowing.vala"
		_tmp7_ = group;
#line 210 "../src/windowing/windowing.vala"
		budgie_windowing_window_group_add_window (_tmp7_, window);
#line 211 "../src/windowing/windowing.vala"
		_g_object_unref0 (group);
#line 211 "../src/windowing/windowing.vala"
		_g_object_unref0 (application);
#line 211 "../src/windowing/windowing.vala"
		return;
#line 685 "windowing.c"
	}
#line 215 "../src/windowing/windowing.vala"
	_tmp8_ = application;
#line 215 "../src/windowing/windowing.vala"
	_tmp9_ = xfw_application_get_name (_tmp8_);
#line 215 "../src/windowing/windowing.vala"
	_tmp10_ = string_to_string (_tmp9_);
#line 215 "../src/windowing/windowing.vala"
	_tmp11_ = g_strconcat ("creating new WindowGroup for application: ", _tmp10_, NULL);
#line 215 "../src/windowing/windowing.vala"
	_tmp12_ = _tmp11_;
#line 215 "../src/windowing/windowing.vala"
	g_debug ("windowing.vala:215: %s", _tmp12_);
#line 215 "../src/windowing/windowing.vala"
	_g_free0 (_tmp12_);
#line 217 "../src/windowing/windowing.vala"
	_tmp13_ = self->priv->window_mapper;
#line 217 "../src/windowing/windowing.vala"
	_tmp14_ = budgie_windowing_window_mapper_query_window (_tmp13_, window);
#line 217 "../src/windowing/windowing.vala"
	app_info = _tmp14_;
#line 218 "../src/windowing/windowing.vala"
	_tmp15_ = application;
#line 218 "../src/windowing/windowing.vala"
	_tmp16_ = app_info;
#line 218 "../src/windowing/windowing.vala"
	_tmp17_ = budgie_windowing_window_group_new (_tmp15_, _tmp16_);
#line 218 "../src/windowing/windowing.vala"
	_g_object_unref0 (group);
#line 218 "../src/windowing/windowing.vala"
	group = _tmp17_;
#line 220 "../src/windowing/windowing.vala"
	_tmp18_ = group;
#line 220 "../src/windowing/windowing.vala"
	budgie_windowing_window_group_add_window (_tmp18_, window);
#line 221 "../src/windowing/windowing.vala"
	_tmp19_ = group;
#line 221 "../src/windowing/windowing.vala"
	g_signal_connect_object (_tmp19_, "window-state-changed", (GCallback) _budgie_windowing_windowing_on_window_state_changed_budgie_windowing_window_group_window_state_changed, self, 0);
#line 222 "../src/windowing/windowing.vala"
	_tmp20_ = self->priv->applications;
#line 222 "../src/windowing/windowing.vala"
	_tmp21_ = application;
#line 222 "../src/windowing/windowing.vala"
	_tmp22_ = _g_object_ref0 (_tmp21_);
#line 222 "../src/windowing/windowing.vala"
	_tmp23_ = group;
#line 222 "../src/windowing/windowing.vala"
	_tmp24_ = _g_object_ref0 (_tmp23_);
#line 222 "../src/windowing/windowing.vala"
	g_hash_table_insert (_tmp20_, _tmp22_, _tmp24_);
#line 223 "../src/windowing/windowing.vala"
	_tmp25_ = group;
#line 223 "../src/windowing/windowing.vala"
	g_signal_emit (self, budgie_windowing_windowing_signals[BUDGIE_WINDOWING_WINDOWING_WINDOW_GROUP_ADDED_SIGNAL], 0, _tmp25_);
#line 199 "../src/windowing/windowing.vala"
	_g_object_unref0 (app_info);
#line 199 "../src/windowing/windowing.vala"
	_g_object_unref0 (group);
#line 199 "../src/windowing/windowing.vala"
	_g_object_unref0 (application);
#line 747 "windowing.c"
}

static GList*
vala_g_list_remove_full (GList* self,
                         gconstpointer data,
                         GFreeFunc func)
{
	GList* l = NULL;
	GList* result;
#line 5230 "glib-2.0.vapi"
	l = self;
#line 5231 "glib-2.0.vapi"
	while (TRUE) {
#line 761 "windowing.c"
		GList* _tmp0_;
		GList* _tmp1_;
		gconstpointer _tmp2_;
#line 5231 "glib-2.0.vapi"
		_tmp0_ = l;
#line 5231 "glib-2.0.vapi"
		if (!(_tmp0_ != NULL)) {
#line 5231 "glib-2.0.vapi"
			break;
#line 771 "windowing.c"
		}
#line 5232 "glib-2.0.vapi"
		_tmp1_ = l;
#line 5232 "glib-2.0.vapi"
		_tmp2_ = ((GList*) _tmp1_)->data;
#line 5232 "glib-2.0.vapi"
		if (_tmp2_ != data) {
#line 779 "windowing.c"
			GList* _tmp3_;
			GList* _tmp4_;
#line 5233 "glib-2.0.vapi"
			_tmp3_ = l;
#line 5233 "glib-2.0.vapi"
			_tmp4_ = ((GList*) _tmp3_)->next;
#line 5233 "glib-2.0.vapi"
			l = _tmp4_;
#line 788 "windowing.c"
		} else {
			GList* _tmp5_;
			gconstpointer _tmp6_;
			GList* _tmp7_;
#line 5235 "glib-2.0.vapi"
			_tmp5_ = l;
#line 5235 "glib-2.0.vapi"
			_tmp6_ = ((GList*) _tmp5_)->data;
#line 5235 "glib-2.0.vapi"
			func (_tmp6_);
#line 5236 "glib-2.0.vapi"
			_tmp7_ = l;
#line 5236 "glib-2.0.vapi"
			self = g_list_delete_link (self, (GList*) _tmp7_);
#line 5237 "glib-2.0.vapi"
			break;
#line 805 "windowing.c"
		}
	}
#line 5240 "glib-2.0.vapi"
	result = self;
#line 5240 "glib-2.0.vapi"
	return result;
#line 812 "windowing.c"
}

static void
budgie_windowing_windowing_on_window_removed (BudgieWindowingWindowing* self,
                                              XfwWindow* window)
{
	XfwScreen* _tmp0_;
	GList* _tmp1_;
	XfwApplication* application = NULL;
	XfwApplication* _tmp2_;
	XfwApplication* _tmp3_;
	BudgieWindowingWindowGroup* group = NULL;
	GHashTable* _tmp4_;
	XfwApplication* _tmp5_;
	gconstpointer _tmp6_;
	BudgieWindowingWindowGroup* _tmp7_;
	BudgieWindowingWindowGroup* _tmp8_;
	BudgieWindowingWindowGroup* _tmp9_;
	BudgieWindowingWindowGroup* _tmp10_;
#line 226 "../src/windowing/windowing.vala"
	g_return_if_fail (self != NULL);
#line 226 "../src/windowing/windowing.vala"
	g_return_if_fail (window != NULL);
#line 227 "../src/windowing/windowing.vala"
	_tmp0_ = self->priv->screen;
#line 227 "../src/windowing/windowing.vala"
	_tmp1_ = xfw_screen_get_windows (_tmp0_);
#line 227 "../src/windowing/windowing.vala"
	budgie_windowing_windowing_set_has_windows (self, g_list_length (_tmp1_) > ((guint) 0));
#line 229 "../src/windowing/windowing.vala"
	if (xfw_window_is_skip_tasklist (window)) {
#line 229 "../src/windowing/windowing.vala"
		return;
#line 846 "windowing.c"
	}
#line 230 "../src/windowing/windowing.vala"
	g_signal_emit (self, budgie_windowing_windowing_signals[BUDGIE_WINDOWING_WINDOWING_WINDOW_REMOVED_SIGNAL], 0, window);
#line 232 "../src/windowing/windowing.vala"
	_tmp2_ = xfw_window_get_application (window);
#line 232 "../src/windowing/windowing.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 232 "../src/windowing/windowing.vala"
	application = _tmp3_;
#line 235 "../src/windowing/windowing.vala"
	_tmp4_ = self->priv->applications;
#line 235 "../src/windowing/windowing.vala"
	_tmp5_ = application;
#line 235 "../src/windowing/windowing.vala"
	_tmp6_ = g_hash_table_lookup (_tmp4_, _tmp5_);
#line 235 "../src/windowing/windowing.vala"
	_tmp7_ = _g_object_ref0 ((BudgieWindowingWindowGroup*) _tmp6_);
#line 235 "../src/windowing/windowing.vala"
	group = _tmp7_;
#line 236 "../src/windowing/windowing.vala"
	_tmp8_ = group;
#line 236 "../src/windowing/windowing.vala"
	if (_tmp8_ == NULL) {
#line 236 "../src/windowing/windowing.vala"
		_g_object_unref0 (group);
#line 236 "../src/windowing/windowing.vala"
		_g_object_unref0 (application);
#line 236 "../src/windowing/windowing.vala"
		return;
#line 876 "windowing.c"
	}
#line 239 "../src/windowing/windowing.vala"
	_tmp9_ = group;
#line 239 "../src/windowing/windowing.vala"
	budgie_windowing_window_group_remove_window (_tmp9_, window);
#line 243 "../src/windowing/windowing.vala"
	self->priv->fullscreen_windows = vala_g_list_remove_full (self->priv->fullscreen_windows, window, _g_object_unref0_);
#line 246 "../src/windowing/windowing.vala"
	_tmp10_ = group;
#line 246 "../src/windowing/windowing.vala"
	if (!budgie_windowing_window_group_has_windows (_tmp10_)) {
#line 888 "windowing.c"
		XfwApplication* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		BudgieWindowingWindowGroup* _tmp16_;
		GHashTable* _tmp17_;
		XfwApplication* _tmp18_;
#line 247 "../src/windowing/windowing.vala"
		_tmp11_ = application;
#line 247 "../src/windowing/windowing.vala"
		_tmp12_ = xfw_application_get_name (_tmp11_);
#line 247 "../src/windowing/windowing.vala"
		_tmp13_ = string_to_string (_tmp12_);
#line 247 "../src/windowing/windowing.vala"
		_tmp14_ = g_strconcat ("removing WindowGroup for application: ", _tmp13_, NULL);
#line 247 "../src/windowing/windowing.vala"
		_tmp15_ = _tmp14_;
#line 247 "../src/windowing/windowing.vala"
		g_debug ("windowing.vala:247: %s", _tmp15_);
#line 247 "../src/windowing/windowing.vala"
		_g_free0 (_tmp15_);
#line 248 "../src/windowing/windowing.vala"
		_tmp16_ = group;
#line 248 "../src/windowing/windowing.vala"
		g_signal_emit (self, budgie_windowing_windowing_signals[BUDGIE_WINDOWING_WINDOWING_WINDOW_GROUP_REMOVED_SIGNAL], 0, _tmp16_);
#line 249 "../src/windowing/windowing.vala"
		_tmp17_ = self->priv->applications;
#line 249 "../src/windowing/windowing.vala"
		_tmp18_ = application;
#line 249 "../src/windowing/windowing.vala"
		g_hash_table_remove (_tmp17_, _tmp18_);
#line 921 "windowing.c"
	}
#line 226 "../src/windowing/windowing.vala"
	_g_object_unref0 (group);
#line 226 "../src/windowing/windowing.vala"
	_g_object_unref0 (application);
#line 927 "windowing.c"
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result;
#line 37 "glib-2.0.vapi"
	if (self) {
#line 936 "windowing.c"
		gchar* _tmp0_;
#line 38 "glib-2.0.vapi"
		_tmp0_ = g_strdup ("true");
#line 38 "glib-2.0.vapi"
		result = _tmp0_;
#line 38 "glib-2.0.vapi"
		return result;
#line 944 "windowing.c"
	} else {
		gchar* _tmp1_;
#line 40 "glib-2.0.vapi"
		_tmp1_ = g_strdup ("false");
#line 40 "glib-2.0.vapi"
		result = _tmp1_;
#line 40 "glib-2.0.vapi"
		return result;
#line 953 "windowing.c"
	}
}

static void
budgie_windowing_windowing_on_window_state_changed (BudgieWindowingWindowing* self,
                                                    XfwWindow* window,
                                                    XfwWindowState changed_mask,
                                                    XfwWindowState new_state)
{
	gboolean _tmp0_ = FALSE;
	gboolean is_fullscreen = FALSE;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	XfwWindow* _tmp8_;
#line 253 "../src/windowing/windowing.vala"
	g_return_if_fail (self != NULL);
#line 253 "../src/windowing/windowing.vala"
	g_return_if_fail (window != NULL);
#line 254 "../src/windowing/windowing.vala"
	g_signal_emit (self, budgie_windowing_windowing_signals[BUDGIE_WINDOWING_WINDOWING_WINDOW_STATE_CHANGED_SIGNAL], 0, window, changed_mask, new_state);
#line 257 "../src/windowing/windowing.vala"
	if (!((changed_mask & XFW_WINDOW_STATE_FULLSCREEN) == XFW_WINDOW_STATE_FULLSCREEN)) {
#line 257 "../src/windowing/windowing.vala"
		return;
#line 982 "windowing.c"
	}
#line 260 "../src/windowing/windowing.vala"
	if ((new_state & XFW_WINDOW_STATE_FULLSCREEN) == XFW_WINDOW_STATE_FULLSCREEN) {
#line 986 "windowing.c"
		gboolean _tmp1_ = FALSE;
#line 260 "../src/windowing/windowing.vala"
		if ((new_state & XFW_WINDOW_STATE_MINIMIZED) == XFW_WINDOW_STATE_MINIMIZED) {
#line 260 "../src/windowing/windowing.vala"
			_tmp1_ = TRUE;
#line 992 "windowing.c"
		} else {
#line 260 "../src/windowing/windowing.vala"
			_tmp1_ = (new_state & XFW_WINDOW_STATE_SHADED) == XFW_WINDOW_STATE_SHADED;
#line 996 "windowing.c"
		}
#line 260 "../src/windowing/windowing.vala"
		_tmp0_ = !_tmp1_;
#line 1000 "windowing.c"
	} else {
#line 260 "../src/windowing/windowing.vala"
		_tmp0_ = FALSE;
#line 1004 "windowing.c"
	}
#line 260 "../src/windowing/windowing.vala"
	is_fullscreen = _tmp0_;
#line 262 "../src/windowing/windowing.vala"
	_tmp2_ = xfw_window_get_name (window);
#line 262 "../src/windowing/windowing.vala"
	_tmp3_ = string_to_string (_tmp2_);
#line 262 "../src/windowing/windowing.vala"
	_tmp4_ = bool_to_string (is_fullscreen);
#line 262 "../src/windowing/windowing.vala"
	_tmp5_ = _tmp4_;
#line 262 "../src/windowing/windowing.vala"
	_tmp6_ = g_strconcat ("window '", _tmp3_, "' fullscreen changed: is fullscreen = ", _tmp5_, NULL);
#line 262 "../src/windowing/windowing.vala"
	_tmp7_ = _tmp6_;
#line 262 "../src/windowing/windowing.vala"
	g_debug ("windowing.vala:262: %s", _tmp7_);
#line 262 "../src/windowing/windowing.vala"
	_g_free0 (_tmp7_);
#line 262 "../src/windowing/windowing.vala"
	_g_free0 (_tmp5_);
#line 265 "../src/windowing/windowing.vala"
	budgie_windowing_windowing_handle_fullscreen_changed (self, is_fullscreen);
#line 268 "../src/windowing/windowing.vala"
	if (!is_fullscreen) {
#line 269 "../src/windowing/windowing.vala"
		self->priv->fullscreen_windows = vala_g_list_remove_full (self->priv->fullscreen_windows, window, _g_object_unref0_);
#line 270 "../src/windowing/windowing.vala"
		return;
#line 1034 "windowing.c"
	}
#line 274 "../src/windowing/windowing.vala"
	_tmp8_ = _g_object_ref0 (window);
#line 274 "../src/windowing/windowing.vala"
	self->priv->fullscreen_windows = g_list_append (self->priv->fullscreen_windows, _tmp8_);
#line 1040 "windowing.c"
}

static void
budgie_windowing_windowing_handle_fullscreen_changed (BudgieWindowingWindowing* self,
                                                      gboolean fullscreen)
{
	GSettings* _tmp0_;
	GSettings* _tmp5_;
#line 277 "../src/windowing/windowing.vala"
	g_return_if_fail (self != NULL);
#line 279 "../src/windowing/windowing.vala"
	_tmp0_ = self->priv->color_settings;
#line 279 "../src/windowing/windowing.vala"
	g_signal_handler_block (_tmp0_, self->priv->night_light_setting_handler);
#line 281 "../src/windowing/windowing.vala"
	if (fullscreen) {
#line 283 "../src/windowing/windowing.vala"
		if (self->priv->pause_night_light) {
#line 1059 "windowing.c"
			GSettings* _tmp1_;
#line 284 "../src/windowing/windowing.vala"
			_tmp1_ = self->priv->color_settings;
#line 284 "../src/windowing/windowing.vala"
			g_settings_set_boolean (_tmp1_, "night-light-enabled", FALSE);
#line 1065 "windowing.c"
		}
#line 287 "../src/windowing/windowing.vala"
		if (self->priv->pause_notifications) {
#line 1069 "windowing.c"
			BudgieWindowingNotificationDispatcher* _tmp2_;
#line 288 "../src/windowing/windowing.vala"
			_tmp2_ = self->priv->dispatcher;
#line 288 "../src/windowing/windowing.vala"
			budgie_windowing_notification_dispatcher_set_notifications_paused (_tmp2_, TRUE);
#line 1075 "windowing.c"
		}
	} else {
#line 292 "../src/windowing/windowing.vala"
		if (self->priv->pause_night_light) {
#line 1080 "windowing.c"
			GSettings* _tmp3_;
#line 293 "../src/windowing/windowing.vala"
			_tmp3_ = self->priv->color_settings;
#line 293 "../src/windowing/windowing.vala"
			g_settings_set_boolean (_tmp3_, "night-light-enabled", self->priv->previous_color_setting);
#line 1086 "windowing.c"
		}
#line 296 "../src/windowing/windowing.vala"
		if (self->priv->pause_notifications) {
#line 1090 "windowing.c"
			BudgieWindowingNotificationDispatcher* _tmp4_;
#line 297 "../src/windowing/windowing.vala"
			_tmp4_ = self->priv->dispatcher;
#line 297 "../src/windowing/windowing.vala"
			budgie_windowing_notification_dispatcher_set_notifications_paused (_tmp4_, FALSE);
#line 1096 "windowing.c"
		}
	}
#line 302 "../src/windowing/windowing.vala"
	_tmp5_ = self->priv->color_settings;
#line 302 "../src/windowing/windowing.vala"
	g_signal_handler_unblock (_tmp5_, self->priv->night_light_setting_handler);
#line 1103 "windowing.c"
}

static void
budgie_windowing_windowing_night_light_enabled_changed (BudgieWindowingWindowing* self,
                                                        const gchar* key)
{
	GSettings* _tmp0_;
#line 305 "../src/windowing/windowing.vala"
	g_return_if_fail (self != NULL);
#line 305 "../src/windowing/windowing.vala"
	g_return_if_fail (key != NULL);
#line 306 "../src/windowing/windowing.vala"
	_tmp0_ = self->priv->color_settings;
#line 306 "../src/windowing/windowing.vala"
	self->priv->previous_color_setting = g_settings_get_boolean (_tmp0_, key);
#line 1119 "windowing.c"
}

static void
budgie_windowing_windowing_wm_settings_changed (BudgieWindowingWindowing* self,
                                                const gchar* key)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 310 "../src/windowing/windowing.vala"
	static GQuark _tmp1_label0 = 0;
#line 310 "../src/windowing/windowing.vala"
	static GQuark _tmp1_label1 = 0;
#line 309 "../src/windowing/windowing.vala"
	g_return_if_fail (self != NULL);
#line 309 "../src/windowing/windowing.vala"
	g_return_if_fail (key != NULL);
#line 310 "../src/windowing/windowing.vala"
	_tmp0_ = key;
#line 310 "../src/windowing/windowing.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 310 "../src/windowing/windowing.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("disable-night-light-on-fullscreen")))) {
#line 310 "../src/windowing/windowing.vala"
		switch (0) {
#line 1144 "windowing.c"
			default:
			{
				GSettings* _tmp3_;
#line 312 "../src/windowing/windowing.vala"
				_tmp3_ = self->priv->wm_settings;
#line 312 "../src/windowing/windowing.vala"
				self->priv->pause_night_light = g_settings_get_boolean (_tmp3_, key);
#line 313 "../src/windowing/windowing.vala"
				break;
#line 1154 "windowing.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("pause-notifications-on-fullscreen")))) {
#line 310 "../src/windowing/windowing.vala"
		switch (0) {
#line 1160 "windowing.c"
			default:
			{
				GSettings* _tmp4_;
#line 315 "../src/windowing/windowing.vala"
				_tmp4_ = self->priv->wm_settings;
#line 315 "../src/windowing/windowing.vala"
				self->priv->pause_notifications = g_settings_get_boolean (_tmp4_, key);
#line 316 "../src/windowing/windowing.vala"
				break;
#line 1170 "windowing.c"
			}
		}
	} else {
#line 310 "../src/windowing/windowing.vala"
		switch (0) {
#line 1176 "windowing.c"
			default:
			{
#line 318 "../src/windowing/windowing.vala"
				g_warning ("windowing.vala:318: Unknown setting changed: %s", key);
#line 319 "../src/windowing/windowing.vala"
				break;
#line 1183 "windowing.c"
			}
		}
	}
}

/**
 * Get the currently active window.
 *
 * Returns: the active window, or NULL
 */
XfwWindow*
budgie_windowing_windowing_get_active_window (BudgieWindowingWindowing* self)
{
	XfwScreen* _tmp0_;
	XfwWindow* _tmp1_;
	XfwWindow* result;
#line 328 "../src/windowing/windowing.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 329 "../src/windowing/windowing.vala"
	_tmp0_ = self->priv->screen;
#line 329 "../src/windowing/windowing.vala"
	_tmp1_ = xfw_screen_get_active_window (_tmp0_);
#line 329 "../src/windowing/windowing.vala"
	result = _tmp1_;
#line 329 "../src/windowing/windowing.vala"
	return result;
#line 1210 "windowing.c"
}

/**
 * Get a list of all current #WindowGroups.
 *
 * Returns: the list of window groups
 */
GList*
budgie_windowing_windowing_get_window_groups (BudgieWindowingWindowing* self)
{
	GHashTable* _tmp0_;
	GList* _tmp1_;
	GList* result;
#line 337 "../src/windowing/windowing.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 338 "../src/windowing/windowing.vala"
	_tmp0_ = self->priv->applications;
#line 338 "../src/windowing/windowing.vala"
	_tmp1_ = g_hash_table_get_values (_tmp0_);
#line 338 "../src/windowing/windowing.vala"
	result = _tmp1_;
#line 338 "../src/windowing/windowing.vala"
	return result;
#line 1234 "windowing.c"
}

/**
 * Get the currently active workspace.
 *
 * Returns: the active workspace, or NULL
 */
XfwWorkspace*
budgie_windowing_windowing_get_active_workspace (BudgieWindowingWindowing* self)
{
	XfwWorkspaceGroup* group = NULL;
	XfwWorkspaceGroup* _tmp0_;
	XfwWorkspaceGroup* _tmp1_;
	XfwWorkspaceGroup* _tmp2_;
	XfwWorkspace* _tmp3_;
	XfwWorkspace* _tmp4_;
	XfwWorkspace* result;
#line 346 "../src/windowing/windowing.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 347 "../src/windowing/windowing.vala"
	_tmp0_ = budgie_windowing_windowing_get_workspace_group (self);
#line 347 "../src/windowing/windowing.vala"
	group = _tmp0_;
#line 349 "../src/windowing/windowing.vala"
	_tmp1_ = group;
#line 349 "../src/windowing/windowing.vala"
	if (_tmp1_ == NULL) {
#line 349 "../src/windowing/windowing.vala"
		result = NULL;
#line 349 "../src/windowing/windowing.vala"
		_g_object_unref0 (group);
#line 349 "../src/windowing/windowing.vala"
		return result;
#line 1268 "windowing.c"
	}
#line 351 "../src/windowing/windowing.vala"
	_tmp2_ = group;
#line 351 "../src/windowing/windowing.vala"
	_tmp3_ = xfw_workspace_group_get_active_workspace (_tmp2_);
#line 351 "../src/windowing/windowing.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 351 "../src/windowing/windowing.vala"
	result = _tmp4_;
#line 351 "../src/windowing/windowing.vala"
	_g_object_unref0 (group);
#line 351 "../src/windowing/windowing.vala"
	return result;
#line 1282 "windowing.c"
}

gboolean
budgie_windowing_windowing_get_has_windows (BudgieWindowingWindowing* self)
{
	gboolean result;
#line 41 "../src/windowing/windowing.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 41 "../src/windowing/windowing.vala"
	result = self->priv->_has_windows;
#line 41 "../src/windowing/windowing.vala"
	return result;
#line 1295 "windowing.c"
}

static void
budgie_windowing_windowing_set_has_windows (BudgieWindowingWindowing* self,
                                            gboolean value)
{
	gboolean old_value;
#line 41 "../src/windowing/windowing.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/windowing/windowing.vala"
	old_value = budgie_windowing_windowing_get_has_windows (self);
#line 41 "../src/windowing/windowing.vala"
	if (old_value != value) {
#line 41 "../src/windowing/windowing.vala"
		self->priv->_has_windows = value;
#line 41 "../src/windowing/windowing.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_windowing_windowing_properties[BUDGIE_WINDOWING_WINDOWING_HAS_WINDOWS_PROPERTY]);
#line 1313 "windowing.c"
	}
}

GList*
budgie_windowing_windowing_get_windows (BudgieWindowingWindowing* self)
{
	GList* result;
	XfwScreen* _tmp0_;
	GList* _tmp1_;
#line 42 "../src/windowing/windowing.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "../src/windowing/windowing.vala"
	_tmp0_ = self->priv->screen;
#line 42 "../src/windowing/windowing.vala"
	_tmp1_ = xfw_screen_get_windows (_tmp0_);
#line 42 "../src/windowing/windowing.vala"
	result = _tmp1_;
#line 42 "../src/windowing/windowing.vala"
	return result;
#line 1333 "windowing.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 23 "../src/windowing/windowing.vala"
	g_return_if_fail (n_param_values == 3);
#line 23 "../src/windowing/windowing.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 23 "../src/windowing/windowing.vala"
		data1 = closure->data;
#line 23 "../src/windowing/windowing.vala"
		data2 = param_values->data[0].v_pointer;
#line 1358 "windowing.c"
	} else {
#line 23 "../src/windowing/windowing.vala"
		data1 = param_values->data[0].v_pointer;
#line 23 "../src/windowing/windowing.vala"
		data2 = closure->data;
#line 1364 "windowing.c"
	}
#line 23 "../src/windowing/windowing.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 23 "../src/windowing/windowing.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 1370 "windowing.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_FLAGS_FLAGS (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_FLAGS_FLAGS) (gpointer data1, gpointer arg_1, guint arg_2, guint arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_FLAGS_FLAGS callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 23 "../src/windowing/windowing.vala"
	g_return_if_fail (n_param_values == 4);
#line 23 "../src/windowing/windowing.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 23 "../src/windowing/windowing.vala"
		data1 = closure->data;
#line 23 "../src/windowing/windowing.vala"
		data2 = param_values->data[0].v_pointer;
#line 1395 "windowing.c"
	} else {
#line 23 "../src/windowing/windowing.vala"
		data1 = param_values->data[0].v_pointer;
#line 23 "../src/windowing/windowing.vala"
		data2 = closure->data;
#line 1401 "windowing.c"
	}
#line 23 "../src/windowing/windowing.vala"
	callback = (GMarshalFunc_VOID__OBJECT_FLAGS_FLAGS) (marshal_data ? marshal_data : cc->callback);
#line 23 "../src/windowing/windowing.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_flags (param_values + 2), g_value_get_flags (param_values + 3), data2);
#line 1407 "windowing.c"
}

static void
_budgie_windowing_windowing_on_dbus_get_gasync_ready_callback (GObject* source_object,
                                                               GAsyncResult* res,
                                                               gpointer self)
{
#line 100 "../src/windowing/windowing.vala"
	budgie_windowing_windowing_on_dbus_get ((BudgieWindowingWindowing*) self, source_object, res);
#line 100 "../src/windowing/windowing.vala"
	g_object_unref (self);
#line 1419 "windowing.c"
}

static void
_budgie_windowing_windowing_on_window_added_gfunc (gconstpointer data,
                                                   gpointer self)
{
#line 116 "../src/windowing/windowing.vala"
	budgie_windowing_windowing_on_window_added ((BudgieWindowingWindowing*) self, (XfwWindow*) data);
#line 1428 "windowing.c"
}

static void
_budgie_windowing_windowing_on_active_window_changed_libxfce4windowing_screen_active_window_changed (XfwScreen* _sender,
                                                                                                     XfwWindow* window,
                                                                                                     gpointer self)
{
#line 118 "../src/windowing/windowing.vala"
	budgie_windowing_windowing_on_active_window_changed ((BudgieWindowingWindowing*) self, window);
#line 1438 "windowing.c"
}

static void
_budgie_windowing_windowing_on_window_added_libxfce4windowing_screen_window_opened (XfwScreen* _sender,
                                                                                    XfwWindow* window,
                                                                                    gpointer self)
{
#line 119 "../src/windowing/windowing.vala"
	budgie_windowing_windowing_on_window_added ((BudgieWindowingWindowing*) self, window);
#line 1448 "windowing.c"
}

static void
_budgie_windowing_windowing_on_window_removed_libxfce4windowing_screen_window_closed (XfwScreen* _sender,
                                                                                      XfwWindow* window,
                                                                                      gpointer self)
{
#line 120 "../src/windowing/windowing.vala"
	budgie_windowing_windowing_on_window_removed ((BudgieWindowingWindowing*) self, window);
#line 1458 "windowing.c"
}

static void
_budgie_windowing_windowing_night_light_enabled_changed_g_settings_changed (GSettings* _sender,
                                                                            const gchar* key,
                                                                            gpointer self)
{
#line 126 "../src/windowing/windowing.vala"
	budgie_windowing_windowing_night_light_enabled_changed ((BudgieWindowingWindowing*) self, key);
#line 1468 "windowing.c"
}

static void
_budgie_windowing_windowing_wm_settings_changed_g_settings_changed (GSettings* _sender,
                                                                    const gchar* key,
                                                                    gpointer self)
{
#line 131 "../src/windowing/windowing.vala"
	budgie_windowing_windowing_wm_settings_changed ((BudgieWindowingWindowing*) self, key);
#line 1478 "windowing.c"
}

static GObject *
budgie_windowing_windowing_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BudgieWindowingWindowing * self;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GHashFunc _tmp2_;
	GEqualFunc _tmp3_;
	GHashTable* _tmp4_;
	BudgieWindowingWindowMapper* _tmp5_;
	XfwScreen* _tmp6_;
	XfwScreen* _tmp7_;
	GList* _tmp8_;
	XfwScreen* _tmp9_;
	XfwScreen* _tmp10_;
	XfwScreen* _tmp11_;
	GSettings* _tmp12_;
	GSettings* _tmp13_;
	gulong _tmp14_;
	GSettings* _tmp15_;
	GSettings* _tmp16_;
	GSettings* _tmp17_;
	GSettings* _tmp18_;
	GError* _inner_error0_ = NULL;
#line 96 "../src/windowing/windowing.vala"
	parent_class = G_OBJECT_CLASS (budgie_windowing_windowing_parent_class);
#line 96 "../src/windowing/windowing.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 96 "../src/windowing/windowing.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BUDGIE_WINDOWING_TYPE_WINDOWING, BudgieWindowingWindowing);
#line 97 "../src/windowing/windowing.vala"
	_tmp0_ = g_settings_new ("org.gnome.settings-daemon.plugins.color");
#line 97 "../src/windowing/windowing.vala"
	_g_object_unref0 (self->priv->color_settings);
#line 97 "../src/windowing/windowing.vala"
	self->priv->color_settings = _tmp0_;
#line 98 "../src/windowing/windowing.vala"
	_tmp1_ = g_settings_new ("com.solus-project.budgie-wm");
#line 98 "../src/windowing/windowing.vala"
	_g_object_unref0 (self->priv->wm_settings);
#line 98 "../src/windowing/windowing.vala"
	self->priv->wm_settings = _tmp1_;
#line 100 "../src/windowing/windowing.vala"
	g_async_initable_new_async (BUDGIE_WINDOWING_TYPE_NOTIFICATION_DISPATCHER_PROXY, 0, NULL, _budgie_windowing_windowing_on_dbus_get_gasync_ready_callback, g_object_ref (self), "g-flags", G_DBUS_PROXY_FLAGS_NONE, "g-name", BUDGIE_WINDOWING_NOTIFICATIONS_DBUS_NAME, "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", BUDGIE_WINDOWING_NOTIFICATIONS_DBUS_OBJECT_PATH, "g-interface-name", "org.buddiesofbudgie.budgie.Dispatcher", NULL);
#line 109 "../src/windowing/windowing.vala"
	_tmp2_ = g_direct_hash;
#line 109 "../src/windowing/windowing.vala"
	_tmp3_ = g_direct_equal;
#line 109 "../src/windowing/windowing.vala"
	_tmp4_ = g_hash_table_new_full (_tmp2_, _tmp3_, _g_object_unref0_, _g_object_unref0_);
#line 109 "../src/windowing/windowing.vala"
	_g_hash_table_unref0 (self->priv->applications);
#line 109 "../src/windowing/windowing.vala"
	self->priv->applications = _tmp4_;
#line 110 "../src/windowing/windowing.vala"
	(self->priv->fullscreen_windows == NULL) ? NULL : (self->priv->fullscreen_windows = (_g_list_free__g_object_unref0_ (self->priv->fullscreen_windows), NULL));
#line 110 "../src/windowing/windowing.vala"
	self->priv->fullscreen_windows = NULL;
#line 112 "../src/windowing/windowing.vala"
	_tmp5_ = budgie_windowing_window_mapper_new ();
#line 112 "../src/windowing/windowing.vala"
	_g_object_unref0 (self->priv->window_mapper);
#line 112 "../src/windowing/windowing.vala"
	self->priv->window_mapper = _tmp5_;
#line 114 "../src/windowing/windowing.vala"
	_tmp6_ = xfw_screen_get_default ();
#line 114 "../src/windowing/windowing.vala"
	_g_object_unref0 (self->priv->screen);
#line 114 "../src/windowing/windowing.vala"
	self->priv->screen = _tmp6_;
#line 116 "../src/windowing/windowing.vala"
	_tmp7_ = self->priv->screen;
#line 116 "../src/windowing/windowing.vala"
	_tmp8_ = xfw_screen_get_windows (_tmp7_);
#line 116 "../src/windowing/windowing.vala"
	g_list_foreach (_tmp8_, _budgie_windowing_windowing_on_window_added_gfunc, self);
#line 118 "../src/windowing/windowing.vala"
	_tmp9_ = self->priv->screen;
#line 118 "../src/windowing/windowing.vala"
	g_signal_connect_object (_tmp9_, "active-window-changed", (GCallback) _budgie_windowing_windowing_on_active_window_changed_libxfce4windowing_screen_active_window_changed, self, 0);
#line 119 "../src/windowing/windowing.vala"
	_tmp10_ = self->priv->screen;
#line 119 "../src/windowing/windowing.vala"
	g_signal_connect_object (_tmp10_, "window-opened", (GCallback) _budgie_windowing_windowing_on_window_added_libxfce4windowing_screen_window_opened, self, 0);
#line 120 "../src/windowing/windowing.vala"
	_tmp11_ = self->priv->screen;
#line 120 "../src/windowing/windowing.vala"
	g_signal_connect_object (_tmp11_, "window-closed", (GCallback) _budgie_windowing_windowing_on_window_removed_libxfce4windowing_screen_window_closed, self, 0);
#line 122 "../src/windowing/windowing.vala"
	budgie_windowing_windowing_setup_workspace_listener (self);
#line 125 "../src/windowing/windowing.vala"
	_tmp12_ = self->priv->color_settings;
#line 125 "../src/windowing/windowing.vala"
	self->priv->previous_color_setting = g_settings_get_boolean (_tmp12_, "night-light-enabled");
#line 126 "../src/windowing/windowing.vala"
	_tmp13_ = self->priv->color_settings;
#line 126 "../src/windowing/windowing.vala"
	_tmp14_ = g_signal_connect_object (_tmp13_, "changed::night-light-enabled", (GCallback) _budgie_windowing_windowing_night_light_enabled_changed_g_settings_changed, self, 0);
#line 126 "../src/windowing/windowing.vala"
	self->priv->night_light_setting_handler = _tmp14_;
#line 129 "../src/windowing/windowing.vala"
	_tmp15_ = self->priv->wm_settings;
#line 129 "../src/windowing/windowing.vala"
	self->priv->pause_night_light = g_settings_get_boolean (_tmp15_, "disable-night-light-on-fullscreen");
#line 130 "../src/windowing/windowing.vala"
	_tmp16_ = self->priv->wm_settings;
#line 130 "../src/windowing/windowing.vala"
	self->priv->pause_notifications = g_settings_get_boolean (_tmp16_, "pause-notifications-on-fullscreen");
#line 131 "../src/windowing/windowing.vala"
	_tmp17_ = self->priv->wm_settings;
#line 131 "../src/windowing/windowing.vala"
	g_signal_connect_object (_tmp17_, "changed::disable-night-light-on-fullscreen", (GCallback) _budgie_windowing_windowing_wm_settings_changed_g_settings_changed, self, 0);
#line 132 "../src/windowing/windowing.vala"
	_tmp18_ = self->priv->wm_settings;
#line 132 "../src/windowing/windowing.vala"
	g_signal_connect_object (_tmp18_, "changed::pause-notifications-on-fullscreen", (GCallback) _budgie_windowing_windowing_wm_settings_changed_g_settings_changed, self, 0);
#line 96 "../src/windowing/windowing.vala"
	return obj;
#line 1603 "windowing.c"
}

static void
budgie_windowing_windowing_class_init (BudgieWindowingWindowingClass * klass,
                                       gpointer klass_data)
{
#line 23 "../src/windowing/windowing.vala"
	budgie_windowing_windowing_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/windowing/windowing.vala"
	g_type_class_adjust_private_offset (klass, &BudgieWindowingWindowing_private_offset);
#line 23 "../src/windowing/windowing.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_budgie_windowing_windowing_get_property;
#line 23 "../src/windowing/windowing.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_budgie_windowing_windowing_set_property;
#line 23 "../src/windowing/windowing.vala"
	G_OBJECT_CLASS (klass)->constructor = budgie_windowing_windowing_constructor;
#line 23 "../src/windowing/windowing.vala"
	G_OBJECT_CLASS (klass)->finalize = budgie_windowing_windowing_finalize;
#line 23 "../src/windowing/windowing.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_WINDOWING_WINDOWING_HAS_WINDOWS_PROPERTY, budgie_windowing_windowing_properties[BUDGIE_WINDOWING_WINDOWING_HAS_WINDOWS_PROPERTY] = g_param_spec_boolean ("has-windows", "has-windows", "has-windows", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/windowing/windowing.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_WINDOWING_WINDOWING_WINDOWS_PROPERTY, budgie_windowing_windowing_properties[BUDGIE_WINDOWING_WINDOWING_WINDOWS_PROPERTY] = g_param_spec_pointer ("windows", "windows", "windows", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1626 "windowing.c"
	/**
	 * Emitted when the currently active window has changed.
	 */
#line 23 "../src/windowing/windowing.vala"
	budgie_windowing_windowing_signals[BUDGIE_WINDOWING_WINDOWING_ACTIVE_WINDOW_CHANGED_SIGNAL] = g_signal_new ("active-window-changed", BUDGIE_WINDOWING_TYPE_WINDOWING, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, xfw_window_get_type (), xfw_window_get_type ());
#line 1632 "windowing.c"
	/**
	 * Emitted when the currently active workspace has changed.
	 */
#line 23 "../src/windowing/windowing.vala"
	budgie_windowing_windowing_signals[BUDGIE_WINDOWING_WINDOWING_ACTIVE_WORKSPACE_CHANGED_SIGNAL] = g_signal_new ("active-workspace-changed", BUDGIE_WINDOWING_TYPE_WINDOWING, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, xfw_workspace_get_type ());
#line 1638 "windowing.c"
	/**
	 * Emitted when a WindowGroup has been created.
	 */
#line 23 "../src/windowing/windowing.vala"
	budgie_windowing_windowing_signals[BUDGIE_WINDOWING_WINDOWING_WINDOW_GROUP_ADDED_SIGNAL] = g_signal_new ("window-group-added", BUDGIE_WINDOWING_TYPE_WINDOWING, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, BUDGIE_WINDOWING_TYPE_WINDOW_GROUP);
#line 1644 "windowing.c"
	/**
	 * Emitted when a WindowGroup has been removed.
	 */
#line 23 "../src/windowing/windowing.vala"
	budgie_windowing_windowing_signals[BUDGIE_WINDOWING_WINDOWING_WINDOW_GROUP_REMOVED_SIGNAL] = g_signal_new ("window-group-removed", BUDGIE_WINDOWING_TYPE_WINDOWING, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, BUDGIE_WINDOWING_TYPE_WINDOW_GROUP);
#line 1650 "windowing.c"
	/**
	 * Emitted when a window is added to the windowing system.
	 */
#line 23 "../src/windowing/windowing.vala"
	budgie_windowing_windowing_signals[BUDGIE_WINDOWING_WINDOWING_WINDOW_ADDED_SIGNAL] = g_signal_new ("window-added", BUDGIE_WINDOWING_TYPE_WINDOWING, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, xfw_window_get_type ());
#line 1656 "windowing.c"
	/**
	 * Emitted when a window is removed from the windowing system.
	 */
#line 23 "../src/windowing/windowing.vala"
	budgie_windowing_windowing_signals[BUDGIE_WINDOWING_WINDOWING_WINDOW_REMOVED_SIGNAL] = g_signal_new ("window-removed", BUDGIE_WINDOWING_TYPE_WINDOWING, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, xfw_window_get_type ());
#line 1662 "windowing.c"
	/**
	 * Emitted when the state of a window has changed.
	 */
#line 23 "../src/windowing/windowing.vala"
	budgie_windowing_windowing_signals[BUDGIE_WINDOWING_WINDOWING_WINDOW_STATE_CHANGED_SIGNAL] = g_signal_new ("window-state-changed", BUDGIE_WINDOWING_TYPE_WINDOWING, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_FLAGS_FLAGS, G_TYPE_NONE, 3, xfw_window_get_type (), xfw_window_state_get_type (), xfw_window_state_get_type ());
#line 1668 "windowing.c"
	/**
	 * Emitted when a Workspace has been created.
	 */
#line 23 "../src/windowing/windowing.vala"
	budgie_windowing_windowing_signals[BUDGIE_WINDOWING_WINDOWING_WORKSPACE_CREATED_SIGNAL] = g_signal_new ("workspace-created", BUDGIE_WINDOWING_TYPE_WINDOWING, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, xfw_workspace_get_type ());
#line 1674 "windowing.c"
	/**
	 * Emitted when a Workspace has been destroyed.
	 */
#line 23 "../src/windowing/windowing.vala"
	budgie_windowing_windowing_signals[BUDGIE_WINDOWING_WINDOWING_WORKSPACE_DESTROYED_SIGNAL] = g_signal_new ("workspace-destroyed", BUDGIE_WINDOWING_TYPE_WINDOWING, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, xfw_workspace_get_type ());
#line 1680 "windowing.c"
}

static void
budgie_windowing_windowing_instance_init (BudgieWindowingWindowing * self,
                                          gpointer klass)
{
#line 23 "../src/windowing/windowing.vala"
	self->priv = budgie_windowing_windowing_get_instance_private (self);
#line 1689 "windowing.c"
}

static void
budgie_windowing_windowing_finalize (GObject * obj)
{
	BudgieWindowingWindowing * self;
#line 23 "../src/windowing/windowing.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BUDGIE_WINDOWING_TYPE_WINDOWING, BudgieWindowingWindowing);
#line 24 "../src/windowing/windowing.vala"
	_g_object_unref0 (self->priv->screen);
#line 25 "../src/windowing/windowing.vala"
	_g_object_unref0 (self->priv->workspace_manager);
#line 26 "../src/windowing/windowing.vala"
	_g_hash_table_unref0 (self->priv->applications);
#line 27 "../src/windowing/windowing.vala"
	(self->priv->fullscreen_windows == NULL) ? NULL : (self->priv->fullscreen_windows = (_g_list_free__g_object_unref0_ (self->priv->fullscreen_windows), NULL));
#line 28 "../src/windowing/windowing.vala"
	_g_object_unref0 (self->priv->last_active_window);
#line 30 "../src/windowing/windowing.vala"
	_g_object_unref0 (self->priv->window_mapper);
#line 31 "../src/windowing/windowing.vala"
	_g_object_unref0 (self->priv->dispatcher);
#line 33 "../src/windowing/windowing.vala"
	_g_object_unref0 (self->priv->color_settings);
#line 34 "../src/windowing/windowing.vala"
	_g_object_unref0 (self->priv->wm_settings);
#line 23 "../src/windowing/windowing.vala"
	G_OBJECT_CLASS (budgie_windowing_windowing_parent_class)->finalize (obj);
#line 1718 "windowing.c"
}

/**
 * This object keeps track of WindowGroups. It serves as the main part
 * of the Budgie windowing library.
 */
static GType
budgie_windowing_windowing_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BudgieWindowingWindowingClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) budgie_windowing_windowing_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BudgieWindowingWindowing), 0, (GInstanceInitFunc) budgie_windowing_windowing_instance_init, NULL };
	GType budgie_windowing_windowing_type_id;
	budgie_windowing_windowing_type_id = g_type_register_static (G_TYPE_OBJECT, "BudgieWindowingWindowing", &g_define_type_info, 0);
	BudgieWindowingWindowing_private_offset = g_type_add_instance_private (budgie_windowing_windowing_type_id, sizeof (BudgieWindowingWindowingPrivate));
	return budgie_windowing_windowing_type_id;
}

GType
budgie_windowing_windowing_get_type (void)
{
	static volatile gsize budgie_windowing_windowing_type_id__once = 0;
	if (g_once_init_enter (&budgie_windowing_windowing_type_id__once)) {
		GType budgie_windowing_windowing_type_id;
		budgie_windowing_windowing_type_id = budgie_windowing_windowing_get_type_once ();
		g_once_init_leave (&budgie_windowing_windowing_type_id__once, budgie_windowing_windowing_type_id);
	}
	return budgie_windowing_windowing_type_id__once;
}

static void
_vala_budgie_windowing_windowing_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	BudgieWindowingWindowing * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BUDGIE_WINDOWING_TYPE_WINDOWING, BudgieWindowingWindowing);
#line 23 "../src/windowing/windowing.vala"
	switch (property_id) {
#line 23 "../src/windowing/windowing.vala"
		case BUDGIE_WINDOWING_WINDOWING_HAS_WINDOWS_PROPERTY:
#line 23 "../src/windowing/windowing.vala"
		g_value_set_boolean (value, budgie_windowing_windowing_get_has_windows (self));
#line 23 "../src/windowing/windowing.vala"
		break;
#line 23 "../src/windowing/windowing.vala"
		case BUDGIE_WINDOWING_WINDOWING_WINDOWS_PROPERTY:
#line 23 "../src/windowing/windowing.vala"
		g_value_set_pointer (value, budgie_windowing_windowing_get_windows (self));
#line 23 "../src/windowing/windowing.vala"
		break;
#line 1769 "windowing.c"
		default:
#line 23 "../src/windowing/windowing.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/windowing/windowing.vala"
		break;
#line 1775 "windowing.c"
	}
}

static void
_vala_budgie_windowing_windowing_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	BudgieWindowingWindowing * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BUDGIE_WINDOWING_TYPE_WINDOWING, BudgieWindowingWindowing);
#line 23 "../src/windowing/windowing.vala"
	switch (property_id) {
#line 23 "../src/windowing/windowing.vala"
		case BUDGIE_WINDOWING_WINDOWING_HAS_WINDOWS_PROPERTY:
#line 23 "../src/windowing/windowing.vala"
		budgie_windowing_windowing_set_has_windows (self, g_value_get_boolean (value));
#line 23 "../src/windowing/windowing.vala"
		break;
#line 1795 "windowing.c"
		default:
#line 23 "../src/windowing/windowing.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/windowing/windowing.vala"
		break;
#line 1801 "windowing.c"
	}
}

